CHANGES
=======

17.0.11
-------

* fix up numa-topology live migration hypervisor check
* Fail to live migration if instance has a NUMA topology
* Allow driver to properly unplug VIFs on destination on confirm resize
* Move get\_pci\_mapping\_for\_migration to MigrationContext
* libvirt: Do not reraise DiskNotFound exceptions during resize
* Include all network devices in nova diagnostics
* Workaround missing RequestSpec.instance\_group.uuid
* Add regression recreate test for bug 1830747
* Restore connection\_info after live migration rollback
* DRY up test\_rollback\_live\_migration\_set\_migration\_status
* Block swap volume on volumes with >1 rw attachment
* Fix live-migration when glance image deleted
* Add functional confirm\_migration\_error test
* [stable-only] Delete allocations even if \_confirm\_resize raises (part 2)
* Delete allocations even if \_confirm\_resize raises
* Stop logging traceback when skipping quiesce
* Fix retry of instance\_update\_and\_get\_original
* Teardown networking when rolling back live migration even if shared disk
* Use migration\_status during volume migrating and retyping
* libvirt: Always disconnect volumes after libvirtError exceptions
* libvirt: Stop ignoring unknown libvirtError exceptions during volume attach
* Fix {min|max}\_version in ironic Adapter setup
* Create request spec, build request and mappings in one transaction
* xenapi/agent: Change openssl error handling
* libvirt: Avoid using os-brick encryptors when device\_path isn't provided
* Fix nova-grenade-live-migration run book for opendev migration
* Fix regression in glance client call
* OpenDev Migration Patch
* Move legacy-grenade-dsvm-neutron-multinode-live-migration in-tree
* Fix legacy-grenade-dsvm-neutron-multinode-live-migration
* libvirt: set device address tag only if setting disk unit
* libvirt: disconnect volume when encryption fails
* Add missing libvirt exception during device detach
* Error out migration when confirm\_resize fails
* prevent common kwargs from glance client failure
* Define irrelevant-files for tempest-full-py3 job
* Delete instance\_id\_mappings record in instance\_destroy
* Do not persist RequestSpec.ignore\_hosts
* Add functional regression test for bug 1669054
* Update instance.availability\_zone on revertResize
* Add functional recreate test for bug 1819963
* [Stable Only] hardware: Handle races during pinning
* Fix incomplete instance data returned after build failure
* Update instance.availability\_zone during live migration
* Update resources once in update\_available\_resource
* Don't persist zero allocation ratios in ResourceTracker
* Document unset/reset wrinkle for \*\_allocation\_ratio options
* Replace openstack.org git:// URLs with https://

17.0.10
-------

* Fix resource tracker updates during instance evacuation
* Allow utime call to fail on qcow2 image base file
* libvirt: Add workaround to cleanup instance dir when using rbd
* Add description of custom resource classes
* Fix WeighedHost logging regression
* Avoid BadRequest error log on volume attachment
* Provide a useful error message when trying to update non-compute services
* Don't emit warning when ironic properties are zero
* Avoid redundant initialize\_connection on source post live migration
* Make host\_manager use scatter-gather and ignore down cells
* Make service all-cells min version helper use scatter-gather
* Ignore VolumeAttachmentNotFound exception in compute.manager
* Lock detach\_volume
* Fix a missing policy in test policy data
* Handle unicode characters in migration params
* tox: Don't write byte code (maybe)
* Handle IndexError in \_populate\_neutron\_binding\_profile
* PCI: do not force remove allocated devices
* Fix port dns\_name reset
* Fix incompatible version handling in BuildRequest
* Don't call begin\_detaching when detaching volume from shelved vm
* Skip checking of target\_dev for vhostuser
* Migrate nova v2.0 legacy job to zuulv3
* Fix os-simple-tenant-usage result order
* Send context.global\_id on neutron calls
* Removing pip-missing-reqs from default tox jobs
* Do not dump all instances in the scheduler
* Exclude build request marker from server listing
* Remove stale pip-missing-reqs tox test
* Ensure rbd auth fallback uses matching credentials
* Fix destination\_type attribute in the bdm\_v2 documentation
* Handle unbound vif plug errors on compute restart
* Update port device\_owner when unshelving
* Handle binding\_failed vif plug errors on compute restart

17.0.9
------

* Add secret=true to fixed\_key configuration parameter
* Don't persist RequestSpec.requested\_destination
* Handle tags in \_bury\_in\_cell0
* Create BDMs/tags in cell with instance when over-quota
* Make the nova-next job voting and gating
* Add functional regression test for bug 1806064
* Note the aggregate allocation ratio restriction in scheduler docs
* Fix InstanceNotFound during \_destroy\_evacuated\_instances
* Add functional regression test for bug 1794996
* compute: Ensure pre-migrating instances are destroyed during init\_host
* Add regression test for bug #1764883
* Test websocketproxy with TLS in the nova-next job
* Move the nova-next job in-tree and update it
* Default embedded instance.flavor.is\_public attribute
* Make supports\_direct\_io work on 4096b sector size
* De-dupe subnet IDs when calling neutron /subnets API
* Fix NoneType error in \_notify\_volume\_usage\_detach
* Ensure attachment cleanup on failure in driver.pre\_live\_migration
* Move live\_migration.pre.start to the start of the method
* Fix up compute rpcapi version for pike release
* conductor: Recreate volume attachments during a reschedule
* Add regression test for bug#1784353
* fixtures: Track volume attachments within CinderFixtureNewAttachFlow
* Add regression test for bug 1797580
* Handle volume API failure in \_post\_live\_migration
* Handle missing marker during online data migration

17.0.8
------

* Not set instance to ERROR if set\_admin\_password failed
* Ignore VirtDriverNotReady in \_sync\_power\_states periodic task
* Explicitly fail if trying to attach SR-IOV port
* stable-only: fix typo in IVS related privsep method
* Fix stacktraces with redis caching backend
* Null out instance.availability\_zone on shelve offload
* nova-manage - fix online\_data\_migrations counts
* Skip more rebuild tests for cells v1 job
* Skip ServerShowV247Test.test\_update\_rebuild\_list\_server in nova-cells-v1 job
* Skip ServerShowV254Test.test\_rebuild\_server in cells v1 job
* Enforce case-sensitive hostnames in aggregate host add
* Revert "Make host\_aggregate\_map dictionary case-insensitive"
* Skip ServerActionsTestJSON.test\_rebuild\_server for cells v1 job
* nova-status - don't count deleted compute\_nodes
* Filter deleted computes from get\_all\_by\_uuids()

17.0.6
------

* libvirt: Use os.stat and os.path.getsize for RAW disk inspection
* Add tempest-slow job to run the tempest slow tests
* libvirt: Always escape IPv6 addresses when used in migration URI
* libvirt: Reduce calls to qemu-img during update\_available\_resource
* Fix soft deleting vm fails after "nova resize" vm
* Fix service list for disabled compute using MC driver
* Set default of oslo.privsep.daemon logging to INFO level
* Refix disk size during live migration with disk over-commit
* Update RequestSpec.flavor on resize\_revert
* cover migration cases with functional tests
* Follow devstack-plugin-ceph job rename
* import zuul job settings from project-config
* Remove noisy DEBUG log
* Make scheduler.utils.setup\_instance\_group query all cells
* Fix nova-status "\_check\_resource\_providers" check
* Fix DB archiver AttributeError due to wrong table name attribute used
* Add functional test for affinity with multiple cells
* Fix the request context in ServiceFixture
* Move conductor wait\_until\_ready() delay before manager init
* Wait for network-vif-plugged before starting live migration
* Fix cancel\_all\_events event name parsing
* Filter out instances without a host when populating AZ
* Revert "libvirt: slow live-migration to ensure network is ready"
* VMware: fix TypeError while get console log
* block\_device: Rollback volumes to in-use on DeviceDetachFailed
* Fix host validity check for live-migration
* Fix bad links for admin-guide
* Update nova network info when doing rebuild for evacuate operation
* Fix message for unexpected external event
* Reload oslo\_context after calling monkey\_patch()
* [placement] Retry allocation writes server side
* Make ResourceTracker.stats node-specific
* Add recreate test for RT.stats bug 1784705
* Disable limits if force\_hosts or force\_nodes is set
* Make host\_aggregate\_map dictionary case-insensitive
* Call generate\_image\_url only for legacy notification
* Handle HostMappingNotFound when deleting a compute service
* Add unshelve instance error info to fault table
* [Stable Only] Remove soft-deleted instances from quota\_usages
* Fix server\_group\_members quota check
* Add functional regressions tests for server\_group\_members OverQuota
* hardware: fix hugepages memory usage per intances
* Fix TypeError in prep\_resize allocation cleanup
* unquiesce instance after quiesce failure
* Consider hostdev devices when building metadata
* Refactor \_build\_device\_metadata
* Default embedded instance.flavor.disabled attribute
* libvirt: add qemu version check when configuring mtu for network
* Fix unbound local when saving an unchanged RequestSpec
* add mtu to libvirt xml for ethernet and bridge types
* Use ironic-tempest-dsvm-ipa-wholedisk-bios-agent\_ipmitool-tinyipa in tree
* Fix regression when listing build\_requests with marker and ip filter
* Update admin/flavors document
* libvirt: Fix the rescue race for vGPU instances
* Make nova service-list use scatter-gather routine
* Handle CannotDeleteParentResourceProvider to 409 Conflict
* Fix unit test modifying global state
* Handle network-changed event for a specific port
* Make nova list and migration-list ignore down cells
* Use instance project/user when creating RequestSpec during resize reschedule
* libvirt: Log breadcrumb for known encryption bug
* Be graceful about vif plugging in early ironic driver startup
* [Stable Only] Add amd-ssbd and amd-no-ssb CPU flags
* Add policy rule to block image-backed servers with 0 root disk flavor
* ironic: stop lying to the RT when ironic is down
* [Stable Only] Initialise failed\_builds in IronicNodeState
* mock utils.execute() in qemu-img unit test
* Fix the file name of development-environment.rst
* Ensure resource class cache when listing usages
* Change consecutive build failure limit to a weigher
* Fix interpretation of max\_attempts for scheduling alternates
* Allow cinderv2 endpoints within the request context catalog

17.0.5
------

* libvirt: Skip fetching the virtual size of block devices
* libvirt: handle DiskNotFound during update\_available\_resource
* Metadata-API fails to retrieve avz for instances created before Pike
* Add ssbd and virt-ssbd flags to cpu\_model\_extra\_flags whitelist
* Avoid unnecessary joins in HostManager.\_get\_instances\_by\_host
* Fix shelving a paused instance
* Make instance.refresh() avoid recursion better
* Fix auth\_url example in hypervisor-hyper-v.rst
* placement: Fix HTTP error generation
* Update auth\_url in install docs
* Don't reschedule on RequestedVRamTooHigh errors
* Added ability to configure default architecture for ImagePropertiesFilter
* libvirt: Report the virtual size of RAW disks
* Add random sleep between retry calls to placement

17.0.4
------

* libvirt: check image type before removing snapshots in \_cleanup\_resize
* Stringify instance UUID
* Migrate tempest-dsvm-multinode-live-migration job in-tree
* log stale allocations as WARNING instead of DEBUG
* Fix detach\_volume calls when rolling back a failed attach
* Handle PortNotFoundClient exception when getting ports
* Make association\_refresh configurable
* Handle @safe\_connect returns None side effect in \_ensure\_resource\_provider
* libvirt: Make \`cpu\_model\_extra\_flags\` case-insensitive for real
* xenapi: handle InstanceNotFound in detach\_interface()
* Fix dropped check for boot\_index 0 in \_validate\_bdm
* libvirt: fix hard reboot issue with mdevs
* Update docs for [keystone\_authtoken] changes since Queens
* Improve performance when list instances with IP filter
* Cleanup RP and HM records while deleting a compute service
* Update os\_compute\_api:os-flavor-extra-specs:index docs for 2.47
* Log a warning and add nova-status check for old API service versions
* Add nova-status check for ironic flavor migration
* Delete allocations from API if nova-compute is down
* Block deleting compute services which are hosting instances
* api-ref: add a note in DELETE /os-services about deleting computes
* Add functional test for deleting a compute service
* Move update\_task\_state out of try/except

17.0.3
------

* libvirt: slow live-migration to ensure network is ready
* libvirt: Report the allocated size of preallocated file based disks
* Document how to disable notifications
* ironic: Get correct inventory for deployed node
* List instances performace optimization
* only increment disk address unit for scsi devices
* Skip placement on rebuild in same host
* Don't persist RequestSpec.retry
* Remove the branch specifier from the nova-multiattach job
* Add regression test for persisted RequestSpec.retry from failed resize
* libvirt: Allow to specify granular CPU feature flags
* libvirt: Block swapping to an encrypted volume when using QEMU to decrypt
* Avoid showing password in log
* Add \_\_repr\_\_ for NovaException

17.0.2
------

* Use ksa session for cinder microversion check
* vmware: Fixes \_detach\_instance\_volumes method
* add check before adding cpus to cpuset\_reserved
* Migrate tempest-dsvm-cells job to an in-tree job definition
* [placement] Add sending global request ID in get
* Move \_make\_instance\_list call outside of DB transaction context
* Add functional regression test for bug 1746509
* Change compute mgr placement check to region\_name
* Always deallocate networking before reschedule if using Neutron
* Preserve multiattach flag when refreshing connection\_info
* Handle EndpointNotFound when building image\_ref\_url in notifications
* Add --by-service to discover\_hosts
* Revert "Refine waiting for vif plug events during \_hard\_reboot"
* docs: Disable smartquotes
* Make archive\_deleted\_rows handle a missing CONF.api\_database.connection
* Update the nova-manage db archive\_deleted\_rows description
* Unmap compute nodes when deleting host mappings in delete cell operation
* Avoid exploding if guest refuses to detach a volume
* Return 400 when compute host is not found
* Handle not found error on taking snapshot

17.0.1
------

* Only attempt a rebuild claim for an evacuation to a new host
* hyper-v: Logs tips on PortBindingFailed
* Save admin password to sysmeta in libvirt driver
* Allow 'network' in RequestContext service\_catalog
* Check for multiattach before removing connections
* Pass user context to virt driver when detaching volume
* Allow force-delete even if task\_state is not None
* Ensure the JSON-Schema covers the legacy v2 API
* Detach volumes when VM creation fails
* Handle spawning error on unshelving
* Fix and update compute schedulers config guide
* Imported Translations from Zanata
* compute: Cleans up allocations after failed resize
* libvirt: mask InjectionInfo.admin\_pass
* Update noVNC deployment docs to mention non-US keymap fix in 1.0.0
* [placement] Add functional tests for traits API
* [placement] Add sending global request ID in put (3)

17.0.0
------

* libvirt: disconnect volume from host during detach
* Ensure attachment\_id always exists for block device mapping
* Add functional test for deleting BFV server with old attach flow
* Update plugs Contrail methods to work with privsep
* Only pull associated \*sharing\* providers
* Fix error handling in compute API for multiattach errors
* Detach volumes when deleting a BFV server pre-scheduling
* Add functional recreate test of deleting a BFV server pre-scheduling
* Clean up ports and volumes when deleting ERROR instance
* Add functional tests to ensure BDM removal on delete
* Store block device mappings in cell0
* Drop extra loop which modifies Cinder volume status
* Check quota before creating volume snapshots
* Add the ability to get absolute limits from Cinder
* Add resource\_class to fields in ironic node cache
* Lazy-load instance attributes with read\_deleted=yes
* unquiesce instance on volume snapshot failure

17.0.0.0rc2
-----------

* Add admin guide doc on volume multiattach support
* Cleanup the manage-volumes admin doc
* Don't JSON encode instance\_info.traits for ironic
* Use correct arguments in task inits
* Bindep does not catch missing libpcre3-dev on Ubuntu
* Fix docs for IsolatedHostsFilter
* Handle volume-backed instances in IsolatedHostsFilter
* Add regression test for BFV+IsolatedHostsFilter failure
* doc: fix the link for the evacuate cli
* Make bdms querying in multi-cell use scatter-gather and ignore down cell
* VGPU: Modify the example of vgpu white\_list set
* Refine waiting for vif plug events during \_hard\_reboot
* Update UPPER\_CONSTRAINTS\_FILE for stable/queens
* Update .gitreview for stable/queens

17.0.0.0rc1
-----------

* Encode libvirt domain XML in UTF-8
* Clean up reservations in migrate\_task call path
* Compute RPC client bump to 5.0
* Bump compute RPC API to version 5.0
* Fixed auto-convergence option name in doc
* Workaround glanceclient bug when CONF.glance.api\_servers not set
* Remove a duplicate colon
* TrivialFix: Add a blankline
* XenAPI: Provide support matrix and doc for VGPU
* Add a prelude release note for the 17.0.0 Queens GA
* Address comments from I51adbbdf13711e463b4d25c2ffd4a3123cd65675
* Add late server group policy check to rebuild
* Add regression test for bug 1735407
* Fix wrong link for "Manage Flavors" in CPU topologies doc
* Make sure that we have usable input for graphical console
* fix misspelling of 'projectUser'
* Test case: new standard resource class unusable
* Clarify CONF.scheduler.max\_attempts
* Add release note for Aggregate[Core|Ram|Disk]Filter change
* placement doc: Conflict caveat for DELETE APIs
* Trivial fix a missleading comment
* Provide support matrix and doc for VGPU
* doc: update the GPU passthrough HPC feature entry
* [placement] Add sending global request ID in put (2)
* [placement] Add sending global request ID in put (1)
* [placement] Add sending global request ID in post
* Update cells v2 layout doc caveats for Queens
* Zuul: Remove project name
* Doc: Nix os-traits link from POST resource\_classes
* docs: Add booting from an encrypted volume
* libvirt: fix native luks encryption failure to find volume\_id
* Don't wait for vif plug events during \_hard\_reboot
* Don't rely on parse.urlencode in url comparisons
* Reset the \_RC\_CACHE between tests
* Fix invalid UUIDs in test\_compute.py
* Fix the wrong description
* doc: placement upgrade notes for queens
* Add functional tests for traits-based scheduling
* Cleanup launch instance and manage IPs docs
* Migrate "launch instance" user guide docs
* Pass limit to /allocation\_requests
* doc: mark the max microversions for queens
* Updated from global requirements
* trivial: Fix few policy doc
* Query all cells for service version in \_validate\_bdm
* add "--until-complete" option for nova-manage db archive\_deleted\_rows
* Mention required traits in the flavors user docs
* Fix nits in support traits changes
* Log options at debug when starting API services under wsgi
* set\_{aggregates|traits}\_for\_provider: tolerate set
* ProviderTree.get\_provider\_uuids: Top-down ordering
* SchedulerReportClient.\_delete\_provider
* ComputeDriver.update\_provider\_tree()
* report client: get\_provider\_tree\_and\_ensure\_root
* trivial: Fix typos in release notes
* Use util.validate\_query\_params in list\_traits
* Add functional tests for virt driver get\_traits() method
* Implement get\_traits() for the ironic virt driver
* Add get\_traits() method to ComputeDriver
* [placement] Separate API schemas (resource\_provider)
* Fix invalid UUIDs in remaining tests
* ProviderTree.new\_child: parent is either uuid or name
* Add server filters whitelist in server api-ref
* reno for notification-transformation-queens
* Add the nova-multiattach job
* Collapse duplicate error handling in rebuild\_instance
* Rollback instance.image\_ref on failed rebuild
* Updated from global requirements
* SchedulerReportClient.set\_aggregates\_for\_provider
* Fix a comment in a notification functional test
* Bumping functional test job timeouts
* Remove deprecated policy items from fake\_policy
* Reduce policy deprecation warnings in test runs
* Fix the incorrect RST convention
* Fix SUSE Install Guide: Placement port
* Log the events we timed out waiting for while plugging vifs
* Reduce complexity of \_from\_db\_object

17.0.0.0b3
----------

* Ironic: Get IP address for volume connector
* Add release note for QEMU native LUKS decryption
* Fix missing 'if\_notifications\_enabled' decorator
* Fix missing marker functions
* Fix bug case by none token context
* Transform instance.resize\_prep notification
* Move remaining uses of parted to privsep
* Avoid suspending guest with attached vGPUs
* placement: enable required traits from the flavor extra specs
* placement: using the dict format for the allocation in claim\_resources
* Update VMWare vSphere link address
* Handle TZ change in iso8601 >=0.1.12
* Updated from global requirements
* Fix the order of target host checks
* Add the Nova libvirt StorPool attachment driver
* Expand on when you might want to set --max-count for map\_instances
* libvirt: pass the mdevs when rebooting the guest
* Set server status to ERROR if rebuild failed
* libvirt: QEMU native LUKS decryption for encrypted volumes
* Replace curly quotes with straight quotes
* Fix 'all\_tenants' & 'all\_projects' type in api-ref
* Use neutron port\_list when filtering instance by ip
* Start moving users of parted to privsep
* Add PowerVM to feature-classification
* Fix update\_cell to ignore existing identical cells
* Change compute RPC to use alternates for resize
* Report Client: PUT empty (not None) JSON data
* Send traits to ironic on server boot
* PowerVM Driver: SEA
* Recreate mediated devices on reboot
* [api] Allow multi-attach in compute api
* doc: Document TLS security setup for noVNC proxy
* placement: support traits in allocation candidates API
* api-ref: Fix parameter type in server-migrations.inc
* Transform instance-evacuate notification
* [placement] Add sending global request ID in delete (3)
* Add index(instance\_uuid, updated\_at) on instance\_actions table
* Fix 500 in test\_resize\_server\_negative\_invalid\_state
* Generalize DB conf group copying
* Track tree-associated providers in report client
* ProviderTree.populate\_from\_iterable
* Raise on API errors getting aggregates/traits
* Updated from global requirements
* Remove redundant swap\_volume tests
* Track associated sharing RPs in report client
* SchedulerReportClient.set\_traits\_for\_provider
* ProviderTree.data => ProviderData
* Cleanup redundant want\_version assignment
* Fix format in flavors.rst
* libvirt: Introduce disk encryption config classes
* libvirt: Collocate encryptor and volume driver calls
* libvirt: create vGPU for instance
* Deduplicate service status notification samples
* libvirt: don't attempt to live snapshot paused instances
* Pass multiattach flag to reserve\_block\_device\_name
* Handle swapping to a multiattach volume
* [libvirt] Allow multiple volume attachments
* trivial: Remove crud from 'conf.py'
* Fix openstackdocstheme options for api-ref
* Updated from global requirements
* [placement] Add functional tests for resource class API
* correct referenced url in comments
* Transform instance.resize\_confirm notification
* placement: \_get\_trees\_matching\_all\_resources()
* Account for deprecation of personality files
* PowerVM driver: ovs vif
* add \_has\_provider\_trees() utility function
* func tests for nested providers in alloc candidate
* Deduplicate aggregate notification samples
* Fix accumulated nits
* Make sure that functional test triggered on sample changes
* Add taskflow to requirements
* Updated from global requirements
* Enable py36 unit tests in tox
* Stop globally caching host states in scheduler HostManager
* make unit tests compatible with os-vif 1.8.0
* Remove unnecessary execute permissions in files
* [placement] Fix resource provider delete
* Transform rescue/unrescue instance notifications
* conf: Do not inherit image signature props with snapshots
* Track provider traits in report client
* Fix missing rps in allocation candidates
* Add aggregates check in allocation candidates
* Fix accumulated nits in refactor series
* Test helper: validate provider summaries
* Revert "Deduplicate service status notification samples"
* console: Provide an RFB security proxy implementation
* console: introduce the VeNCrypt RFB authentication scheme
* console: introduce framework for RFB authentication
* console: Send bytes to sockets
* Update links in documents
* Add a warning in 'nova-manage cell\_v2 delete\_cell'
* Modify the test case of get\_disk\_mapping\_rescue\_with\_config
* Rename block\_device\_info\_get\_root
* Increase notification wait timeout in functional tests
* [placement] Add sending global request ID in delete (2)
* Fix comment in MigrationSortContext
* Add index(updated\_at) on migrations table
* Add pagination and Changes-since filter support for os-migrations
* Deduplicate service status notification samples
* Add exception to no-upcall note of cells doc
* Fix typo in release note
* Add cross cell sort support for get\_migrations
* libvirt: add tests to check multipath in iscsi/fc volume connectors
* libvirt: test to make sure volume\_use\_multipath is properly used
* libvirt: use 'host-passthrough' as default on AArch64
* Add reference to policy sample
* Add an additional description for 'token\_ttl'
* Updated from global requirements
* Qualify the Placement 1.15 release note
* Add migration db and object pagination support
* Add regression test for resize failing during retries
* Fix race condition in retrying migrations
* libvirt: Provide VGPU inventory for a single GPU type
* Fix OpenStack capitalization
* Update FAQs about listing hosts in cellv2
* Add ConsoleAuthToken object
* Optionalize instance\_uuid in console\_auth\_token\_get\_valid()
* Add index on token\_hash and instance\_uuid for console\_auth\_tokens
* Add access\_url\_base to console\_auth\_tokens table
* Add debug output for selected page size
* Use method validate\_integer from oslo.utils
* conf: hyperv: fix a comment typo
* Remove a duplicate line in a unit test
* Use volume shared\_targets to lock during attach/detach
* Handle no allocations during migrate
* Add regression test for resizing failing when using CachingScheduler
* zuul: Move legacy jobs to project
* Imported Translations from Zanata
* log test: use fixtures.StandardLogging in setUp
* Fix up formatting for deprecate-api-extensions-policies release note
* Fix documentation nits in set\_and\_clear\_allocations
* Document lack of side-effects in AllocationList.create\_all()
* VMware: add support for different firmwares
* hyper-v: Deprecates support for Windows / Hyper-V Server 2012
* Use UEFI as the default boot for AArch64
* Don't log a warning for InstanceNotFound in detach\_interface
* manager: more detailed info of unsupported compute driver
* Add test for assignment of uuid to a deleted BDM
* Fix fake libvirt XML generation for disks
* Handle glance exception during rotating instance backup
* Move aggregates from report client to ProviderTree
* Only call numa\_fit\_instance\_to\_host if necessary
* Expose BDM uuid to drivers
* DriverBlockDevice: make subclasses inherit \_proxy\_as\_attr
* Add an online migration for BDM.uuid
* Address nits in I46d483f9de6776db1b025f925890624e5e682ada
* Add support for getting volume details with a specified microversion
* XenAPI: Unit tests must mock os\_xenapi calls
* Revert "Modify \_poll\_shelved\_instances periodic task call \_shelve\_offload\_instance()"
* Remove 'nova-manage host' and 'nova-manage agent'
* Remove 'nova-manage logs' command
* conf: Remove deprecated 'remap\_vbd\_dev' option
* api-ref: Fix incorrect parameter name
* [placement] Add sending global request ID in delete
* trivial: conf: libvirt: remove a redundant space
* Fix the formatting for 2.58 in the compute REST API history doc
* trivial: Modify signature of \_filter\_non\_requested\_pfs
* Add PCI NUMA policies
* Document testing guide for new API contributions
* trivial: use cn instead of rp
* Updated from global requirements
* Test allocation candidates: multiple aggregates
* Fix functional tests for USE\_NEUTRON
* Make conductor pass and use host\_lists
* Don't try to delete build request during a reschedule
* libvirt: don't log snapshot success unless it actually happens
* Add retry\_on\_deadlock decorator to action\_event\_start
* conf: libvirt: Cleanup CPU modelling related options
* Remove dead parameter from '\_create\_domain\_and\_network'
* Handle images with no data
* tests: Use correct response type in tests
* Remove the inherits parameter for the Resource object
* Remove the LoadedExtensionInfo object
* Initialize osprofiler in WSGI application
* doc: update supported drivers for cpu topology
* Do not set allocation.id in AllocationList.create\_all()
* [placement] Fix getting placement request ID
* [placement] Enable limiting GET /allocation\_candidates
* Pass RequestSpec to ConductorTaskAPI.build\_instances
* Fix an error in \_get\_host\_states when deleting a compute node
* Provide example for placement last-modified header of now
* objects: Add PCI NUMA policy fields
* Workaround missing RequestSpec.project\_id when moving an instance
* Use instance.project\_id when creating request specs for old instances
* Fix duplicate allocation candidates
* trivial: conf: libvirt: fix a typo
* Remove extensions module
* Fix 4 doc typos
* Fix false positive server group functional tests
* Updated from global requirements
* XenAPI: create vGPU for instance
* update\_cell allows more than once cell to have the same db/transport url
* [placement] Add x-openstack-request-id in API ref
* [placement] Separate API schemas (allocation\_candidate)
* [placement] Separate API schemas (allocation)
* Implement set\_and\_clear\_allocations in report client
* Make BlockDeviceMapping object support uuid
* Add uuid column to BlockDeviceMapping
* Remove unused argument from LibvirtDriver.\_disconnect\_volume
* Removed unused argument from LibvirtDriver.\_connect\_volume
* Fix unit test failures when direct IO not supported
* [placement] Separate API schemas (resource\_class)
* Updated from global requirements
* Deduplicate functional test code
* Aggregate ops on ProviderTree
* Implement query param schema for migration index
* Make request\_spec.spec MediumText
* Fix the formatting for 2.56 in the compute REST API history doc
* Delete the TypeAffinityFilter
* live-mig: keep disk device address same
* Traits ops on ProviderTree
* SchedulerReportClient.\_get\_providers\_in\_aggregates
* [placement] Separate API schemas (inventory)
* [placement] Separate API schemas (aggregate)
* [placement] Separate API schemas (trait)
* [placement] Separate API schemas (usage)
* Fix the bug report link of API Guide
* Extract instance allocation removal code
* Test alloc\_cands with one RP shared between two RPs
* Test alloc\_cands with non overlapping sharing RPs
* handle traits with sharing providers
* Fix possible TypeError in VIF.fixed\_ips
* Add pagination and changes-since for instance-actions
* Updated common create server sample request because of microversion 2.57
* Fix some typos in nova doc
* Retry \_trait\_sync on deadlock
* Remove unnecessary connector stash in attachment\_update
* Pass mountpoint to volume attachment\_create with connector
* Pass bdms to versioned notifications during finish\_revert\_resize
* Update and complete volume attachments during resize
* Pass mountpoint to volume attachment\_update
* Don't persist could-be-stale InstanceGroup fields in RequestSpec
* Update nova-status and docs for nova-compute requiring placement 1.14
* Wait for live\_migration\_rollback.end notification
* Some nit fix in multi\_cell\_list
* Raise MarkerNotFound if BuildRequestList.get\_by\_filters doesn't find marker
* Move flushing block devices to privsep
* Convert ext filesystem resizes to privsep
* [placement] Add info about last-modified to contrib docs
* [placement] Add cache headers to placement api requests
* Stabilize test\_live\_migration\_abort func test
* doc: add note about fixing admin-only APIs without a microversion
* Deprecate file injection
* VMware: implement get\_inventory() driver method
* VMware: expose max vCPUs and max memory per ESX host
* VMware: fix memory stats
* api-ref: Fix a description for 'guest\_format'
* Move the claim\_resources method to scheduler utils
* Change RPC for select\_destinations()
* Re-use existing ComputeNode on ironic rebalance
* placement: skip authentication on root URI
* Add instance action db and obj pagination support
* Update Instance action's updated\_at when action event updated
* Make live migration hold resources with a migration allocation
* Add instance action record for snapshot instances
* Add quiesce and unquiesce in support matrix
* libvirt: throw NotImplementedError if qga is not responsive when setting password
* [placement] Fix API reference for microversion 1.14
* Unmap compute nodes when deleting host mapping
* Follow up on removing old-style quotas code
* Add API and nova-manage tests that use the NoopQuotaDriver
* Add instance action record for backup instances
* Don't launch guestfs in a thread pool if guestfs.debug is enabled
* Remove confusing comment in compute\_node\_get API method
* [placement] add name to resource provider create error
* Improve error message on invalid BDM fields
* doc: link in some Sydney summit content
* trivial: more suitable log in set\_admin\_password
* Add support for listing hosts in cellv2
* [placement] Add 'Location' parameters in API ref
* [placement] Object changes to support last-modified headers

17.0.0.0b2
----------

* Implement new attach Cinder flow
* Add new style volume attachment support to block\_device.py
* SchedulerReportClient.\_get\_providers\_in\_tree
* Modify select\_destinations() to return objects and alts
* Move the to\_dict() method to the Selection object
* Return Selection objects from the scheduler driver
* Refactor the code to check for sufficient hosts
* Fix 'force' parameter in os-quota-sets PUT schema
* Reformat \_get\_all\_with\_shared
* Updated from global requirements
* Deprecate configurable Hide Server Address Feature
* XenAPI: update the picture in Xen hypervisor document
* Deprecate API extensions policies
* Avoid stashed connector lookup for new style detach
* placement: update client to set parent provider
* Scheduler set\_inventory\_for\_provider does nested
* placement: adds REST API for nested providers
* placement: allow filter providers in tree
* XenAPI: Don't use nicira-iface-id for XenServer VIF
* archive\_deleted\_instances is not atomic for insert/delete
* Remove the unused request\_id filter from api-paste.ini
* Add a new check to volume attach
* Add instance action record for shelve\_offload instances
* Modify \_poll\_shelved\_instances periodic task call \_shelve\_offload\_instance()
* Add Selection objects
* Fix doubling allocations on rebuild
* Add PowerVM to compute\_driver options
* Updated from global requirements
* Fix wrong argument order in functional test
* [placement] Fix an error message in API validation
* Transform instance.resize\_revert notification
* Mention API behavior change when over quota limit
* [placement] Fix foreign key constraint error
* [placement] Add aggregate link note in API ref
* Fail fast if changing image on a volume-backed server rebuild
* Get original image\_id from volume for volume-backed instance rebuild
* Add regression test for rebuilding a volume-backed server
* ProviderTree.get\_provider\_uuids()
* Fix cellsv1 messaging test
* Make \_Provider really private
* Split instance\_list into instance and multi\_cell
* Genericify the instance\_list stuff
* Remove 'nova-manage account' and 'nova-manage project'
* Remove 'nova-manage shell' command
* Updated from global requirements
* Fixes 'Not enough available memory' log message
* Only log not correcting allocation once per period
* Add description for resource class creation
* Trivial: Nix duplicate PlacementFixture() in test
* [placement] re-use existing conf with auth token middleware
* Fix disk size during live migration with disk over-commit
* Use ksa adapter for keystone conf & requests
* Downgrade log for keystone verify client fail
* [placement]Enhance doc for placement allocation list
* Update description of Rebuild in server\_concepts.rst
* Use oslo\_db Session in resource\_provider.py
* VMware: Handle concurrent registrations of the VC extension
* Proper error handling by \_ensure\_resource\_provider
* Refactor placement version check
* Nix log translations from scheduler.client.report
* Remove old-style quotas code
* Remove direct usage of glance.generate\_image\_url
* remove glance usage inside compute
* Assert that we restrict cold migrations to the same cell
* [placement] Fix format in placement API ref
* Enable cold migration with target host(2/2)
* qemu-img do not use cache=none if no O\_DIRECT support
* remove reserve\_quota\_delta
* Raise specific exception when swapping migration allocations fails
* Fix ValueError when loading old pci device record
* Updated from global requirements
* Remove the objects for describing the extension for v2.1 API
* Remove the objects which related to the old v2 API implementation
* Updated from global requirements
* Save updated libvirt domain XML after swapping volume
* placement: add nested resource providers
* Deprecate the IronicHostManager
* Fix some incorrect option references for scheduler filters
* Remove deprecated TrustedFilter
* Fix NoneType error when [service\_user] is misconfigured
* check query param for server groups function
* Deduplicate instance.create notification samples
* Nits from Ic3ab7d60e4ac12b767fe70bef97b327545a86e74
* [placement] Fix GET PUT /allocations nits
* [placement] POST /allocations to set allocations for >1 consumers
* Add instance action record for lock/unlock instances
* XenAPI: provide vGPU inventory in compute node
* XenAPI: get vGPU stats from hypervisor
* Add 'all\_tenants' for GET sec group api ref
* Update the documentation links
* Add instance action record for attach/detach/swap volumes
* Add regression test for rebuild with new image doubling allocations
* Refined fix for validating image on rebuild
* Address nits from service create/destroy notification review
* Versioned notifications for service create and delete
* Remove unnecessary self.flags and ConfPatcher
* Implement query param schema for delete assisted vol
* Add ProviderSummary.resource\_class\_names @property
* required traits for no sharing providers
* Fix invalid minRam error message
* finish refactor AllocCandidates.\_get\_by\_filters()
* PowerVM support matrix update
* Fix the format file name
* Simplify BDM boot index checking
* Remove unused global variables
* Updated from global requirements
* Implement query param schema for flavor index
* Implement query param schema for fping index
* Implement query param schema for sec group APIs
* Finish stestr migration
* Fix incorrect known vcpuset when CPUPinningUnknown raised
* Enable cold migration with target host(1/2)
* Update server query section in the API concept doc
* [placement] Add 'CUSTOM\_' prefix description in API ref
* [placement] Fix parameter order in placement API ref
* Remove 'nova-manage quota refresh' command
* Api-guide: Address TODOs in user\_concepts section
* Update server status api guide
* Api guide:add Server Consoles
* Update Metadata api section of api guide
* Implement query param schema for simple\_tenant\_usage
* Transform instance-live\_migration\_pre notification
* Use FakeLiveMigrateDriver in notification test
* Change live\_migrate tests to use fakedriver
* Test resource allocation during soft delete
* factor out compute service start in ServerMovingTest
* Moving more utils to ProviderUsageBaseTestCase
* Don't overwrite binding-profile
* Fix TypeError of \_get\_project\_id when project\_id is None
* Regenerate and pass configdrive when rebuild Ironic nodes
* Update bindep.txt for doc builds
* [placement] Symmetric GET and PUT /allocations/{consumer\_uuid}
* Service token is not experimental
* Use ksa adapter for neutron client
* Get auth from context for glance endpoint
* vgpu: add enabled white list
* cleanup mapping/reqspec after archive instance
* Fix the usage of instance.snapshot notification sample
* Update document related to host aggregate
* api-ref: Add a description of 'key\_name' in rebuild
* api-ref: Fix an example in "Delete Assisted Volume Snapshot"
* Use the RequestSpec when getting scheduler\_hints in compute
* Add migration\_get\_by\_uuid in db api
* Add instance action record for attach/detach interface
* placement: Document request headers in api-ref
* Deduplicate keypair notification samples
* Include project\_id and user\_id in AllocationList.get\_all\_by\_consumer\_id
* Clean up exception caught in \_validate\_and\_build\_base\_options
* Implement query param schema for volume, snapshot API
* Implement query param schema for quota set APIs
* api-ref: fix the type on the block\_device\_mapping\_v2 parameter
* placement: Document \`in:\` prefix for ?member\_of=
* libvirt: Re-initialise volumes, encryptors, and vifs on hard reboot
* VMware: serial console log (completed)
* PowerVM Driver: config drive
* Fix TypeError in nova-manage db archive\_deleted\_rows
* Remove setting of version/release from releasenotes
* Fix the formatting for the 2.54 microversion REST API version history
* hyper-v: Do not allow instances with pinned CPUs to spawn
* Updated from global requirements
* Add microversion to allow setting flavor description
* Fix docstring for GET /os-migrations and related DB API
* Add a note about versioned notification samples being per-release
* Document the real behavior of notify\_on\_state\_change
* Use NoDBTestCase for powervm driver tests
* create allocation request for single provider
* build alloc request resources for shared resources
* build ProviderSummary objects in sep function
* begin refactor AllocCandidates.\_get\_by\_filters()
* Add security release note for OSSA-2017-005
* Add error message on metadata API
* api-ref: make a note about os:scheduler\_hints being a top-level key
* doc: fix link to creating unit tests in contributor guide
* Validate new image via scheduler during rebuild
* Add FlavorPayload.description for versioned notifications
* placement: AllocCands.get\_by\_{filters => requests}
* Deduplicate server\_group samples
* Correct log message when removing a security group
* Updated from global requirements
* Enable reset keypair while rebuilding instance
* Test allocation\_candidates with only sharing RPs
* Test alloc candidates with same RC in cn & shared
* rt: Make resource tracker always invoking get\_inventory()
* Revert "Don't overwrite binding-profile"
* Cleanup build\_request\_spec
* Refactor test\_allocation\_candidates
* block\_device\_mapping\_v2.bus\_type is missing from api-ref
* Remove incorrect comment about instance.locked
* Don't overwrite binding-profile
* Do not use “-y” for package install
* [placement] set accept to application/json if accept not set
* [placement] Fix a wrong redirection in placement doc
* Handle InstanceNotFound when setting password via metadata
* Extract allocation candidates functional tests
* Deduplicate instance.reboot notification samples
* Deduplicate instance.live\_migration notification samples
* Deduplicate instance.interface\_attach samples
* Deduplicate instance.power-off notification samples
* Transform instance-live\_migration\_abort notification
* Deduplicated instance.(un)pause notification samples
* Factor out duplicated notification sample data (2)
* Move last\_bytes into the path module
* Fix test\_get\_volume\_config method
* Fix missing versioned notification sample
* Clean up allocations if instance deleted during build
* Avoid deleting allocations for instances being built
* libvirt: remove old code in post\_live\_migration\_at\_destination
* Using --option ARGUMENT
* Add Flavor.description attribute
* Modify incorrect debug meaasge in \_inject\_data
* Avoid redundant security group queries in GET /servers/{id}/os-security-groups
* Update contributor microversion doc for compute
* Updated from global requirements
* Granularize resources\_from\_{flavor|request\_spec}
* Parse granular resources/traits from extra\_specs
* placement: Parse granular resources & traits
* RequestGroup class for placement & consumers
* Factor out duplicated notification sample data
* libvirt: Don't VIR\_MIGRATE\_NON\_SHARED\_INC without migrate\_disks
* libvirt: do unicode conversion for error messages
* Fix return type in FilterScheduler.\_legacy\_find\_hosts
* Implement power\_off/power\_on for the FakeDriver
* Remove instance.keypairs migration code
* conf: Validate '[api] vendordata\_providers' options
* conf: Remove 'vendordata\_driver' opt
* Trivial grammar fix
* Fix warning on {'cell\_id': 1} is an invalid UUID
* Move contrail vif plugging to privsep
* Move plumgrid vif plugging to privsep
* Move midonet vif plugging to privsep
* Move infiniband vif plugging to privsep
* Remove compatibility method from FlavorPayload
* placement: Contributor doc microversion checklist
* libvirt: do not remove inst\_base when volume-backed during resize
* Refactor claim\_resources() to use retries decorator
* Make put\_allocations() retry on concurrent update
* [placement] avoid case issues microversions in gabbits
* Fix format in live-migration-usage.rst
* Don't update RT in \_allocate\_network
* Transform keypair.import notification
* api-ref: document caveats with scheduler hints
* add whereto for testing redirect rules
* rp: break functions out of \_set\_traits()
* Use Migration object in ComputeManagerMigrationTestCase
* check query param for used\_limits function
* VMware: add support for graceful shutdown of instances
* Pass requested\_destination in filter\_properties
* Functional regression test for evacuate with a target
* Fix indent in configuring-migrations.rst
* XenAPI: resolve VBD unplug failure with VM\_MISSING\_PV\_DRIVERS error
* libvirt: properly decode error message from qemu guest agent
* Use ksa adapter for placement conf & requests
* Only filter/weigh hosts once if scheduling a single instance
* Update placement api-ref: allocations link in 1.11
* rt: Implement XenAPI get\_inventory() method
* Fix instance lookup in hide\_server\_addresses extension
* libvirt: remove extraneous retry assignment in cleanup method
* libvirt: Don't disregard cache mode for instance boot disks
* Fix live migration grenade ceph setup
* Pass the correct image to build\_request\_spec in conductor.rebuild\_instance
* rp: remove \_HasAResourceProvider mixin
* rp: move RP.\_set\_traits() to module scope
* rp: Remove RP.get\_traits() method
* [placement] Limit number of attempts to delete allocations
* [placement] Allow \_set\_allocations to delete allocations
* conf: Move additional nova-net opts to 'network'
* Do not attempt volume swap when guest is stopped/suspended
* Convert IVS VIF plugging / unplugging to privsep
* Move blkid calls to privsep
* trivial: Rename 'policy\_check' -> 'policy'
* test: Store the OutputStreamCapture fixture
* Accept all standard resource classes in flavor extra specs
* Fix AttributeError in BlockDeviceMapping.obj\_load\_attr
* Move project\_id and user\_id to Allocation object
* VGPU: Define vgpu resource class
* Make migration uuid hold allocations for migrating instances
* Fix wrapping of neutron forbidden error
* Import user-data page from openstack-manuals
* Import the config drive docs from openstack-manuals
* Move kpartx calls to privsep
* Move nbd commands to privsep
* Move loopback setup and removal to privsep
* Move the idmapshift binary into privsep
* Include /resource\_providers/uuid/allocations link
* xenapi: cached images should be cleaned up by time
* Add test so we remember why CUSTOM\_ prefix added
* Move xend existence probes to privsep
* Move shred to privsep
* Add alternate hosts
* Implement query param schema for host index
* conf: Remove deprecated 'null\_kernel' opt
* Adds 'sata' as a valid disk bus for qemu and kvm hypervisors
* propagate OSError to MigrationPreCheckError
* Trivial: fix spelling of allocation\_request
* Transform instance.trigger\_crash\_dump notification
* Add debug information to metadata requests

17.0.0.0b1
----------

* placement: integrate ProviderTree to report client
* [Trivial] Fix up a docstring
* Remove duplicate error info
* [placement] Clean up TODOs in allocations.yaml gabbit
* Add attachment\_get to refresh\_connection\_info
* Add 'delete\_host' command in 'nova-manage cell\_v2'
* Keep updating allocations for Ironic
* docs: Explain the flow of the "serial console" feature
* Send Allocations to spawn
* Move lvm handling to privsep
* Cleanup mount / umount and associated rmdir calls
* Update live migration to use v3 cinder api
* placement: set/check if inventory change in tree
* Move restart\_compute\_service to a common place
* Fix nova-manage commands that do not exist
* fix cleaning up evacuated instances
* doc: Fix command output in scheduler document
* Refactor resource tracker to account for migration allocations
* Revert allocations by migration uuid
* Split get\_allocations\_for\_instance() into useful bits
* Regenerate context during targeting
* Pick ironic nodes without VCPU set
* Don't use mock.patch.stopall
* Move test\_uuid\_sentinels to NoDBTestCase
* [placement] Confirm that empty resources query causes 400
* [placement] add coverage for update of standard resource class
* api-ref: add warning about force evacuate for ironic
* Add snapshot id to the snapshot notifications
* Reproduce bug 1721652 in the functional test env
* Add 'done' to migration\_get\_in\_progress\_by\_host\_and\_node filter
* Update "SHUTOFF" description in API guide
* api-ref: fix server status values in GET /servers docs
* Fix connection info refresh for reboot
* rp: rework AllocList.get\_all\_by\_consumer\_id()
* rp: fix up AllocList.get\_by\_resource\_provider\_uuid
* rp: remove ability to delete 1 allocation record
* rp: remove dead code in Allocation.\_create\_in\_db()
* rp: streamline InventoryList.get\_all\_by\_rp\_uuid()
* rp: remove CRUD operations on Inventory class
* Make expected notifications output easier to read in tests
* Elevate existing RequestContext to get bandwidth usage
* Fix target\_cell usage for scatter\_gather\_cells
* Nix bug msg from ConfGroupForServiceTypeNotFound
* nova-manage map\_instances is not using the cells info from the API database
* Updated from global requirements
* Update cinder in RequestContext service catalog
* Target context for build notification in conductor
* Don't fix protocol-less glance api\_servers anymore
* Move user\_data max length check to schema
* Remove unnecessary BDM destroy during instance delete
* rp: Move RP.\_get|set\_aggregates() to module scope
* rp: de-ORM ResourceProvider.get\_by\_uuid()
* use already loaded BDM in instance.create
* use already loaded BDM in instance.<action> (2)
* use already loaded BDM in instance.<action>
* Remove dead code of api.fault notification sending
* Fix sending legacy instance.update notification
* doc: Rework man pages
* Fix typo in test\_prep\_resize\_errors\_migration
* Fix minor input items from previous patches
* nova.utils.get\_ksa\_adapter()
* De-duplicate \_numa\_get\_flavor\_XXX\_map\_list
* hardware: Flatten functions
* Update libvirt volume drivers to use os-brick constants
* Always put 'uuid' into sort\_keys for stable instance lists
* Fix instance\_get\_by\_sort\_filters() for multiple sort keys
* Deprecate allowed\_direct\_url\_schemes and nova.image.download.modules
* Add error notification for instance.interface\_attach
* Note TrustedFilter deprecation in docs
* Make setenv consistent for unit, func, and api-samples
* Blacklist test\_extend\_attached\_volume from cells v1 job
* Pre-create migration object
* Remove metadata/system\_metadata filter handling from get\_all
* fix unstable shelve offload functional tests
* TrivialFix: Fix the incorrect test case
* stabilize test\_resize\_server\_error\_and\_reschedule\_was\_failed
* api-ref: note that project\_id filter only works with all\_tenants
* Avoid redundant BDM lookup in check\_can\_live\_migrate\_source
* Only query BDMs once in API during rebuild
* Make allocation cleanup honor new by-migration rules
* Modernize set\_vm\_state\_and\_notify
* Remove system\_metadata loading in Instance.\_load\_flavor
* Stop joining on system\_metadata when listing instances
* Remove old compat code from servers ViewBuilder.\_get\_metadata
* Remove unused get\_all\_instance\_\*metadata methods
* doc: Add documentation for cpu\_realtime, cpu\_realtime\_mask
* Remove 400 as expected error
* Remove doc todo related to bug/1506667
* api-ref: add note about rebuild not replacing volume-backed root disk
* api-ref: remove redundant preserve\_ephemeral mention from rebuild docs
* [placement] gabbi tests for shared custom resource class
* Update RT aggregate map less frequently
* libvirt: add method to configure migration speed
* Set migration object attributes for source/dest during live migrate
* Refactor duplicate code for looking up the compute node name
* Fix CellDatabases fixture swallowing exceptions
* Use improved instance\_list module in compute API
* Fix a pagination logic bug in test\_bug\_1689692
* Add hints to what the Migration attribute values are
* Move cell0 marker test to Cellsv1DeprecatedTestMixIn
* Ensure instance can migrate when launched concurrently
* console: introduce basic framework for security proxying
* [placement] Update the placement deployment instructions
* Move allocation manipulation out of drop\_move\_claim()
* Do not monkey patch eventlet in unit tests
* Do not setup conductor in BaseAPITestCase
* Make etree.tostring() emit unicode everywhere
* Fix inconsistency of 'NOTE:' description
* Don't shell out to mkdir, use ensure\_tree()
* Read from console ptys using privsep
* Move ploop commands to privsep
* Set group\_members when converting to legacy request spec
* Support qemu >= 2.10
* Fix policy check performance in 2.47+
* doc: make host aggregates examples more discoverable
* Remove dest node allocations during live migration rollback
* Fix race in delete allocation in ServerMovingTests
* xenapi: pass migrate\_data to recover\_method if live migrate fails
* \_rollback\_live\_migration in live-migration seqdiag
* Log consumer uuid when retrying claims in the scheduler
* Add recreate test for live migrate rollback not cleaning up dest allocs
* Add slowest command to tox.ini
* Make TestRPC inherit from the base nova TestCase
* Ensure errors\_out\_migration errors out migration
* use context mgr in instance.delete
* Implement query param schema for GET hypervisor(2.33)
* Remove SCREEN\_LOGDIR from devstack install setting
* Fix --max-count handling for nova-manage cell\_v2 map\_instances
* Set the Pike release version for scheduler RPC
* Add functional for live migrate delete
* Fix IoOpsFilter test case class name
* Add get\_node\_uuid() helper to ResourceTracker
* Live Migration sequence diagram
* Deprecate idle\_timeout in api\_database
* cleanup test-requirements
* Add 400 as error code for resource class delete
* Implement query param schema for agent index
* fix nova accepting invalid availability zone name with ':'
* check query param for service's index function
* Remove useless periodic task that expires quota reservations
* Add attachment\_get call to volume/cinder\_api
* Add functional migrate force\_complete test
* Copy some tests to a cellsv1 mixin
* Add get\_instance\_objects\_sorted()
* Make 'fault' a valid joined query field for Instance
* Change livesnapshot to true by default
* docs: Rename cellsv2\_layout -> cellsv2-layout
* Add datapath type information to OVS vif objects
* libvirt: Make 'get\_domain' private
* Fix 500 if list servers called with empty regex pattern
* Vzstorage: synchronize volume connect
* Add \_wait\_for\_action\_fail\_completion to InstanceHelperMixin
* Remove allocations when unshelve fails on host
* Updated from global requirements
* Add instance.interface\_detach notification
* Add default configuration files to data\_files
* Remove method "\_get\_host\_ref\_from\_name"
* Add a regression test for bug 1718455
* Add recreate test for unshelve offloaded instance spawn fail
* Add PowerVM hypervisor configuration doc
* Add tests to validate instance\_list handles faults correctly
* Add fault-filling into instance\_get\_all\_by\_filters\_sort()
* Support pagination in instance\_list
* Add db.instance\_get\_by\_sort\_filters()
* Make instance\_list honor global query limit
* Add base implementation for efficient cross-cell instance listing
* Fix hyperlinks in document
* api-ref: fix default sort key when listing servers
* Add instance.interface\_attach notification
* libvirt: bandwidth param should be set in guest migrate
* Updated from global requirements
* Add connection pool size to vSphere settings
* Add live.migration.force.complete to the legacy notification whitelist
* Restore '[vnc] vnc\_\*' option support
* neutron: handle binding:profile=None during migration
* doc: Add documentation for emulator\_thread\_policy
* doc: Split flavors docs into admin and user guides
* VMware: Factor out relocate\_vm()
* remove re-auth logic for ironic client wrapper
* hyperv: report disk\_available\_least field
* Allow shuffling hosts with the same best weight
* Enable custom certificates for keystone communication
* Fix the ocata config-reference URLs
* Fix a typo
* Account for compute.metrics.update in legacy notification whitelist
* use unicode in tests to avoid SQLA warning
* Move libvirts dmcrypt support to privsep
* Squash dacnet\_admin privsep context
* Squash dac\_admin privsep context
* Move the dac\_admin privsep code to a new location
* Use symbolic names for capabilities, expand sys\_admin context
* stabilize test\_resize\_server\_error\_and\_reschedule\_was\_failed
* Updated from global requirements
* Drop support for the Cinder v2 API
* Remove 400 as expected error
* Set error state after failed evacuation
* Add @targets\_cell for live\_migrate\_instance method in conductor
* [placement] Removing versioning from resource\_provider objects
* doc: rename the Indices and Tables section
* doc: Further cleanup of doc contributor guide
* [placement] Unregister the ResourceProvider object
* [placement] Unregister the ResourceProviderList object
* [placement] Unregister the Inventory object
* [placement] Unregister the InventoryList object
* [placement] Unregister the Allocation object
* [placement] Unregister the AllocationList object
* [placement] Unregister the Usage object
* [placement] Unregister the UsageList object
* [placement] Unregister the ResourceClass object
* [placement] Unregister the ResourceClassList object
* [placement] Unregister the Trait object
* [placement] Unregister the TraitList object
* Add '\_has\_qos\_queue\_extension' function
* Add '\_has\_dns\_extension' function
* Assume neutron auto\_allocate extension's enabled
* Add single quotes for posargs on jobs
* Add nova-manage db command for ironic flavor migrations
* enhance api-ref for os-server-external-events
* Have one list of reboot task\_states
* Call terminate\_connection when shelve\_offloading
* Revert "Enable test\_iscsi\_volume in live migration job"
* Target context when setting instance to ERROR when over quota
* Cleanup running of osprofiler tests
* Fix test runner config issues with os-testr 1.0.0
* Fix missed chown call
* Updated from global requirements
* Tweak connection\_info translation for the new Cinder attach/detach API
* Add attachment\_complete call to volume/cinder.py
* Remove dest node allocation if evacuate MoveClaim fails
* Add a test to make sure failed evacuate cleans up dest allocation
* Add recreate test for evacuate claim failure
* Create allocations against forced dest host during evacuate
* fake\_notifier: Refactor wait\_for\_versioned\_notification
* Transform instance.resize.error notifications
* Update docs to include standardization of VM diagnostics
* Refactor ServerMovingTests for non-move tests
* Remove deprecated keymgr code
* Move execs of tee to privsep
* Add ComputeNodeList.get\_by\_hypervisor\_type()
* Split out the core of the ironic flavor migration
* Fix binary name
* Revert "Revert "Fix AZ related API docs""
* [placement] Correct a comment in \_set\_allocations
* Remove Xen networking plugin
* Revert "Fix AZ related API docs"
* [placement] correct error on bad resource class in allocation
* api-ref: note the microversions for GET /resource\_providers query params
* doc: fix flavor notes
* Fix AZ related API docs
* Transform aggregate.remove\_host notification
* Transform servergroup.delete notification
* Transform aggregate.add\_host notification
* Cleanup unused get\_iscsi\_initiator
* Remove two testing stubs which aren't really needed
* Typo error about help resource\_classes.inc
* Transform servergroup.create notification
* Set regex flag on ostestr command for osprofiler tests
* Transform keypair.delete notification
* Move execs of touch to privsep
* Move libvirt usages of chown to privsep
* Enable test\_iscsi\_volume in live migration job
* Refactor out claim\_resources\_on\_destination into a utility
* Fix broken URLs
* Ensure instance mapping is updated in case of quota recheck fails
* Track which cell each instance is created in and use it consistently
* Make ConductorTaskTestCase run with 2 cells
* xenapi: Exception Error logs shown in Citrix XenServer CI
* Update contributor guide for Queens
* Allow setting up multiple cells in the base TestCase
* Fix test\_rpc\_consumer\_isolation for oslo.messaging 5.31.0
* Fix broken link
* First attempt at adding a privsep user to nova itself
* Provide hints when nova-manage db sync fails to sync cell0
* Add release note for force live migration allocations
* Handle exception on adding secgroup
* doc: Add configuration index page
* doc: Add user index page
* spelling mistake
* Fix ValueError if invalid max\_rows passed to db purge
* Remove usage of kwarg retry\_on\_request in API
* Add release note for requiring shred 8.22 or above
* Make xen unit tests work with os-xenapi>=0.3.0
* Skip more racy rebuild failing tests with cells v1
* Add some inline code docs tracing the cold migrate flow
* Mark LXC as missing for swap volume support
* Remove compatibility code for flavors
* rbd: Remove unnecessary 'encode' calls
* Updated from global requirements
* Pass config object to oslo\_reports
* Replace http with https for doc links in nova
* Put base policy rules at first
* Amend uuid4 hacking rule
* conf: Rename two VNC options
* Correct examples in "Manage Compute services" documentation
* Handle deleted instances when refreshing the info\_cache
* Remove qpid description in doc
* Replace dd with shred for zeroing lvm volumes
* Update docs for \_destroy\_evacuated\_instances
* doc: link to versioned notification samples from main index
* doc: link to placement api-ref and history docs from main index
* doc: fix online\_data\_migrations option in upgrades doc
* Add recreate test for forced host evacuate not setting dest allocations
* add online\_data\_migrations to nova docs
* Glance download: only fsync files
* Functional test for regression bug #1713783
* doc: fix show-hide sample in notification devref
* Default the service version in the notification tests
* api-ref: add warnings about forcing the host for live migrate/evacuate
* HyperV: Perform proper cleanup after failed instance spawns
* [placement] Update user doc with api-ref link
* [placement] api-ref GET /traits name:startswith
* Add video type virtio for AArch64
* Document tagged attach in the feature support matrix
* [placement] Require at least one resource class in allocation
* Enhance doc for nova services
* Update doc to indicate nova-network deprecated
* Updated from global requirements
* [placement] Add test for empty resources in allocation
* Refactor LiveMigrationTask.\_find\_destination
* Cleanup allocations on invalid dest node during live migration
* Hyper-V: Perform proper cleanup after cold migration
* Test InstanceNotFound handling in 'nova usage'
* Typo fix in admin doc ssh-configuration.html
* iso8601.is8601.Utc No Longer Exists
* Fix nova assisted volume snapshots
* Fix \_delete\_inventory log message in report client
* Add functional recreate test for live migration pre-check fails
* doc: Remove deprecated call to sphinx.util.compat
* Remove unneeded attributes from context
* Updates to scheduling workflow doc
* Add uuid online migration for migrations
* Add uuid to migration object and migrate-on-load
* Add uuid to migration table
* Add placeholder migrations for Pike backports
* Clarify the field usage guidelines
* Optimize MiniDNS for fewer syscalls
* [Trivial] docstrings, typos, minor refactoring
* Update PCI passthrough doc for moved options
* tests: De-duplicate some graphics tests
* Reduce code complexity - linux\_net.py
* Refactor init\_instance:resume\_guests\_state
* conf: Allow users to unset 'keymap' options
* Change default for [notifications]/default\_publisher\_id to $host
* Deprecate CONF.monkey\_patch
* Add device tag support info in support matrix
* Prevent blank line at start of migration placeholders
* Remove useless error handling in prep\_resize
* De-duplicate two delete\_allocation\_for\_\* methods
* Move hash ring initialization to init\_host() for ironic
* Fix bug on vmware driver attach volume failed
* fix a typo in format\_cpu\_spec doc
* Cleanup allocations in failed prep\_resize
* Add functional test for rescheduling during a migration
* Remove allocation when booting instance rescheduled or aborted
* Fix sample configuration generation for compute-related options
* Add formatting to scheduling activity diagram
* Monkey patch the blockdiag extension
* docs: Document the scheduler workflow
* Updated from global requirements
* Delete instance allocations when the instance is deleted
* How about not logging errors every time we shelve offload?
* Add missing tests for \_remove\_deleted\_instances\_allocations
* nova-manage: Deprecate 'cell' commands
* Add missing unit tests for FilterScheduler.\_get\_all\_host\_states
* api-ref: fix key\_name note formatting
* Assume neutron port\_binding extensions enabled
* libvirt: Fix getting a wrong guest object
* pci: Validate behavior of empty devname
* Tests: Add cleanup of 'instances' directory
* Remove the section about extensions from the API concept doc
* Restrict live migration to same cell
* Remove source node allocation after live migration completes
* Allocate resources on forced dest host during live migration
* Add language for compute node configuration
* trivial: Remove some single use function from utils
* Add functional live migrate test
* Add functional force live migrate test
* doc: Address review comments for main index
* trivial: Remove dead function, variable
* tests: Remove useless test
* Remove plug\_ovs\_hybrid, unplug\_ovs\_hybrid
* Correct statement in api-ref
* Fix a typo in code comment
* Refactor libvirt.utils.execute() away
* Fix quobyte test\_validate\_volume\_no\_mtab\_entry
* Updated from global requirements
* update comment for dropping support
* Move common definition into common layer
* Remove host filter for \_cleanup\_running\_deleted\_instances periodic task
* Fix contributor documentation
* replace chance with filter scheduler in func tests
* Clean up resources at shelve offload
* test shelve and shelve offload with placement
* Amend the code review guide for microversion API
* delete allocation of evacuated instance
* Make scheduler.utils.merge\_resources ignore zero values
* Fix a wrong link
* Fix reporting inventory for provisioned nodes in the Ironic driver
* Avoid race in test\_evacuate
* Reset client session when placement endpoint not found
* Update api doc with latest updates in api framework
* doc: Extend nfv feature matrix with pinning/NUMA
* Always use application/json accept header in report client
* Fix messages in functional tests
* Handle addition of new nodes/instances in ironic flavor migration
* Skip test\_rebuild\_server\_in\_error\_state for cells v1
* test server evacuation with placement
* doc: add superconductor up-call caveat for cross\_az\_attach=False
* doc: add another up-call caveat for cells v2 for xenapi aggregates
* Update reno for stable/pike
* Deprecate bare metal filters

16.0.0.0rc1
-----------

* Remove "dhcp\_options\_for\_instance"
* Clarifying node\_uuid usage in ironic driver
* doc: address review comments in stable-api guide updates
* Resource tracker compatibility with Ocata and Pike
* placement: avoid returning duplicated alloc\_reqs when no sharing rp
* Imported Translations from Zanata
* [placement] Make placement\_api\_docs.py failing
* [placement] Add api-ref for allocation\_candidates
* Clarify that vlan feature means nova-network support
* [placement] Add api-ref for RP usages
* Remove ram/disk sched filters from default list
* Remove provider allocs in confirm/revert resize
* placement: refactor healing of allocations in RT
* remove log message with potential stale info
* doc: Address review comments for contributor index
* Require Placement 1.10 in nova-status upgrade check
* Mark Chance and Caching schedulers as deprecated
* [placement] Add api-ref for usages
* Clean up \*most\* ec2 / euca2ools references
* Add documentation for documentation contributions
* Structure cli page
* doc: Import configuration reference
* Add release note for shared storage known issue
* Improve stable-api doc with current API state
* update policy UT fixtures
* Bulk import all config reference figures
* rework index intro to describe nova
* Mark max microversion for Pike in history doc
* Add a prelude section for Pike
* doc: provide more details on scheduling with placement
* Add functional test for local delete allocations
* Document service layout for consoles with cells
* Add For Operators section to front page
* Create For End Users index section
* doc: code review considerations for online data migrations
* Add track\_instance\_changes note in disable\_group\_policy\_check\_upcall
* Cleanup release note about ignoring allow\_same\_net\_traffic
* no instance info cache update if instance deleted
* Add format\_dom for PCI device addresses
* doc: Add additional content to admin guide
* Create reference subpage
* Raise NoValidHost if no allocation candidates
* Fix all >= 2 hit 404s
* Handle ironicclient failures in Ironic driver
* Fix migrate single instance when it was created concurrently
* trivial: Remove files from 'tools'
* trivial: Remove "vif" script
* tools/xenserver: Remove 'cleanup\_sm\_locks'
* Test resize with too big flavor
* [placement] Add api-ref for RP allocations
* placement: filtering the resource provider id when delete trait association
* Updated from global requirements
* Add resource utilities to scheduler utils
* Add Contributor Guide section page
* Fix getting instance bdms in multiple cells
* Update install guide to clearly define between package installs
* doc: Import administration guide
* doc: Import installation guide
* Complete dostring of live\_migration related methods
* Add a caveat section about cellsv2 upcalls
* doc: Start using oslo\_policy.sphinxext
* policies: Fix Sphinx issues
* doc: Start using oslo\_config.sphinxext
* doc: Rework README to reflect new doc URLs
* doc: Remove dead files
* nova-manage: Deprecate '--version' parameters
* imagebackend: cleanup constructor args to Rbd
* Sum allocations in the scheduler when resizing to the same host
* doc: Make use of definition lists, literals
* hardware offload support for openvswitch
* reflow rpc doc to 80 columns
* fix list rendering in policy-enforcement
* Fix scope of errors\_out\_migration in finish\_resize
* Fix scope of errors\_out\_migration in resize\_instance
* Split Compute.errors\_out\_migration into a separate contextmanager
* fix list rendering in cells
* fix list rendering in aggregates
* Fix list rendering in bdm doc
* fix list rendering in rpc doc
* Fix list rendering in code-review.rst
* Fix whitespace in rest\_api\_version\_history
* Fix lists in process doc
* [placement] Avoid error log on 405 response
* Keep the code consistent
* Filter out stale migrations in resource audit
* Test resize to same host with placement api
* fix rpc broken rst comment
* sort redirectmatch lines
* add top 404 redirect
* [placement] Require at least one allocation when PUT
* Add redirect for api-microversion-history doc
* Fix 409 handling in report client when deleting inventory
* Detach device from live domain even if not found on persistent
* Cleanup unnecessary logic in os-volume\_attachments controller code
* Adopt new pypowervm power\_off APIs
* placement: remove existing allocs when set allocs
* Additional assertions to resize tests
* Accept any scheduler driver entrypoint
* add redirects for existing broken docs urls
* Add some more cellsv2 doc goodness
* Test resize with placement api
* Deprecate cells v1
* Add release note for PUT /os-services/\* for non-compute services
* Updated from global requirements
* Don't warn on expected network-vif-unplugged events
* do not pass proxy env variables by tox
* Show quota detail when inject file quota exceeds
* rootwrap.d cleanup mislabeled files
* always show urls in list\_cells
* api-ref: requested security groups are not applied to pre-existing ports
* api-ref: fix security\_groups response parameter in os-security-groups
* Clean variable names and docs around neutron allocate\_for\_instance
* explain payload inheritance in notification devref
* Update SSL cert used in testing
* Remove RamFilter and DiskFilter in default filter
* Enhance support matrix document
* remove extension param and usage
* Add description on maximum placement API version
* Updated from global requirements
* Add cinder keystone client opts to config reference
* Updated from global requirements
* fix test\_rebuild\_server\_exc instability
* [placement] quash unicode warning with shared provider
* add a redirect for the old cells landing page
* Remove unnecessary code

16.0.0.0b3
----------

* claim resources in placement API during schedule()
* placement: account for move operations in claim
* add description about key\_name
* doc: add FAQ entry for cells v1 config options
* Add oslo\_concurrency=INFO to default log levels for nova-manage
* stabilize test\_create\_delete\_server functional test
* Ensure we unshelve in the cell the instance is mapped
* Fix example in \_serialize\_allocations\_for\_consumer
* deprecate \`\`wsgi\_log\_format\`\` config variable
* Move the note about '/os-volume\_boot' to the correct place
* Remove the useless fake ExtensionManager from API unittests
* Netronome SmartNIC Enablement
* Updated from global requirements
* Enhance support matrix document
* add cli to support matrix
* add a retry on DBDeadlock to \_set\_allocations()
* docstring and unused code removal
* libvirt: Post-migration, set cache value for Cinder volume(s)
* use os\_traits.MISC\_SHARES\_VIA\_AGGREGATE
* style-only: s/context/ctx/
* Instance remains in migrating state forever
* Add helper method for waiting migrations in functional tests
* Improve assertJsonEqual error reporting
* Translate the return value of attachment\_create and \_update
* Move the last\_bytes util method to libvirt
* Do not import nova.conf into nova/exception.py
* Set IronicNodeState.uuid in \_update\_from\_compute\_node
* Add VIFHostDevice support to libvirt driver
* Remove redundant free\_vcpus logging in \_report\_hypervisor\_resource\_view
* Remove the useless extension block\_device\_mapping\_v1 object
* Remove the useless FakeExt
* Remove the code related to extension loading from APIRouterV21
* Add 'updated\_at' field to InstancePayload in notifications
* Use wsgi-intercept in OSAPIFixture
* API ref: associate floating IP requires Active status
* Suppress some test warnings
* Use enum value instead of string service name
* rename binary to source in versioned notifications
* Trim the fat from InstanceInfo
* [placement] Use wsgi\_intercept in PlacementFixture
* Replaces uuid.uuid4 with uuidutils.generate\_uuid()
* Ironic: Support boot from Cinder volume
* [placement] Flush RC\_CACHE after each gabbit sequence
* Stop using mox stubs in cast\_as\_call.py
* Add online migration to move quotas to API database
* Migrate Ironic Flavors
* Add tags to instance.create Notification
* request\_log addition for running under uwsgi
* Stop using mox stubs in test\_console\_auth\_tokens.py
* Increase cpu time for image conversion
* Remove an unnecessary argument in \_prep\_resize
* Updated from global requirements
* Using plain routes for the microversions test
* Updated from global requirements
* Updated from global requirements
* placement: add retry tight loop claim\_resources()
* Dump versioned notifications when test\_create\_delete\_server
* retry on authentication failure in api\_client
* Change default policy to view quota details
* Implement interface attach/detach in ironic virt driver
* Update policy description for 'instance\_actions'
* Update ironic feature matrix
* Updated from global requirements
* doc: Switch to openstackdocstheme
* Don't cast cinderclient microversions to float
* Remove the unittest for plugin framework
* Use plain routes list for versions instead of stevedore
* Removed unused 'wrap' property
* Make Quotas object favor the API database
* Remove check\_detach
* Remove improper LOG.exception() calls in placement
* VMware: Handle missing volume vmdk during detach
* Use \_error\_out\_instance\_on\_exception in finish\_resize
* placement: proper JOIN order for shared resources
* placement: alloc candidates only shared resources
* Allow wrapping of closures
* Updated from global requirements
* provide interface-scoped nameserver information
* Only setup iptables for metadata if using nova-net
* Fix and optimize external\_events for multiple cells
* Add policy granularity to the Flavors API
* Deprecate useless quota\_usage\_refresh from nova-manage
* add dict of allocation requests to select\_dests()
* Handle None returned from get\_allocation\_candidates due to connect failure
* Updated from global requirements
* Update URL home-page in documents according to document migration
* api-ref: Fix an expand button in os-quota-sets
* Correct the description of 'disable-log-reason' api-ref
* Consider instance flavor resource overrides in allocations
* Do not mention that tags are case sensitive in docs
* api-ref: fix max\_version for deprecated os-quota-class-sets parameters
* Handle uuids in os-hypervisors API
* Use uuid for id in os-services API
* Remove 'reserved' count from used limits
* Make security\_group\_rules use check\_deltas() for quota
* Make key\_pairs use check\_deltas() for quota
* Count instances to check quota
* Use plain routes list for extension\_info instead of stevedore
* Use plain routes list for os-snapshots instead of stevedore
* Use plain routes list for os-volume-attachments instead of stevedore
* doc: Populate the 'user' section
* doc: Populate the 'reference' section
* doc: Populate the 'contributor' section
* doc: Populate the 'configuration' section
* Add log info in scheduler to mark start of scheduling
* [placement] Add api-ref for allocations
* [placement] Add api-ref for RP traits
* [placement] Add api-ref for traits
* Remove translation of log messages
* Fix indentation in policy doc
* conf: remove \*\_topic config opts
* Stop using mox stubs in test\_remote\_consoles.py
* api-ref: Verify parameters in os-migrations.inc
* Use URIOpt
* Convert HostState.limits['numa\_topology'] to primitive
* Log compute node uuid when the record is created
* Remove key\_manager.api\_class hack
* Update policy descriptions for base
* Consistent policies
* Support tag instances when boot(4/4)
* Fix instance evacuation with PCI devices
* [placement] fix 500 error when allocating to bad class
* [placement] Update allocation-candidates.yaml for gabbi 1.35
* fix test\_volume\_swap\_server instability
* XenAPI: Fix ValueError in test\_slave\_asks\_master\_to\_add\_slave\_to\_pool
* api-ref: mention disk size limitations in resize flavor
* [placement] cover deleting a custom resource class in use
* [placement] cover deleting standard trait
* Updated from global requirements
* fix unshelve notification test instability
* scheduler: isolate \_get\_sorted\_hosts()
* Set wsgi.keep\_alive=False globally for tests
* Dump tracked version notifications when swap volume tests fail
* Default reservations=None in Cells v1 and conductor APIs
* Avoid false positives of Jinja2 in Bandit scan
* Updated from global requirements
* Remove 'create\_rule\_default'
* Use oslo.polcy DocumentedRuleDefault
* trivial: Remove unnecessary function
* doc: Populate the 'cli' section
* Fix the releasenote and api-ref for quota-class API
* Fix typo
* Stop counting hw\_video:ram\_max\_mb against quota
* Add ability to signal and perform online volume size change
* api-ref: mark instance action events parameter as optional
* Add BDM to InstancePayload
* placement: add claim\_resources() to report client
* doc: Enable pep8 on doc generation code
* doc: Remove dead plugin
* Use plain routes list for os-volumes instead of stevedore
* Use plain routes list for os-baremetal-nodes endpoint instead of stevedore
* Use plain routes list for os-security-group-default-rules instead of stevedore
* Use plain routes list for os-security-group-rules instead of stevedore
* Use plain routes list for server-security-groups instead of stevedore
* Use plain routes list for os-security-groups instead of stevedore
* Use plain routes list for image-metadata instead of stevedore
* Use plain routes list for images instead of stevedore
* Remove the test for the route '/resources.:(format)'
* doc: Use consistent author, section for man pages
* Use plain routes list for os-networks instead of stevedore
* doc: Remove cruft from conf.py
* Fix wrong log parm
* Query deleted instance records during \_destroy\_evacuated\_instances
* Skip boot from encrypted volume on Xen+libvirt
* improve notification short-circuit
* Use PCIAddressField in oslo.versionedobjects
* Fix quota class set APIs
* api-ref: Add X-Openstack-Request-Id description
* Fix a missing classifier
* api-ref: Add missing parameters in limits.inc
* api-ref: Fix parameters in server-security-groups
* Stop using deprecated 'message' attribute in Exception
* Adjust error msg for ImageNUMATopologyAsymmetric
* placement: scheduler uses allocation candidates
* Trivial: Remove unnecessary format specifier
* Handle Cinder 3.27 style attachments in swap\_volume
* Support tag instances when boot(3/4)
* Remove reverts\_task\_state decorator from swap\_volume
* Pre-load instance.device\_metadata in InstanceMetadata
* Updated from global requirements
* [placement] Improve allocation\_candidates coverage
* xenapi: avoid unnecessary BDM query when building device metadata
* Add release note for xenapi virt device tagging support
* Make notification publisher\_id consistent
* Modify some comments for virt driver
* Fix parameters and description for os-volume\_attachments
* Remove nova.api.extensions.server.extensions usage
* Fix error message when support matrix entry is missing a driver
* Fix comment for API binary name in WSGIService
* Fix arguments in calling \_delete\_nic\_metadata
* Fix incorrect docstrings in neutron network API
* Add 'networks' quota in quota sample files
* Reset the traits sync flag in the placement fixtures
* Add api-ref for os-quota-class-set APIs
* trivial: Use valid UUIDs in test\_admin\_password
* placement: filter usage records by resource provider id
* Fix 'project-id' 'user-id' as required in server group
* Reduce (notification) test duplication
* Use plain routes list for os-cells endpoint instead of stevedore
* Hyper-V: fix live migration with CSVs
* placement: support GET /allocation\_candidates
* Handle keypair not found from metadata server using cells
* Don't delete neutron port when attach failed
* Removes getfattr from Quobyte Nova driver
* libvirt: update the logic to configure volume with scsi controller
* libvirt: update logic to configure device for scsi controller
* Updated from global requirements
* conf: fix netconf, my\_ip and host are unclear
* Remove wsdl\_location configuration option
* hyperv: Fixes log message in livemigrationops
* hyperv: stop serial console workers while deleting vm files
* hyperv: Fixes Generation 2 VMs volume boot order
* Ensure the JSON-Schema covers the legacy v2 API
* API support for tagged device attachment
* Delete disk metadata when detaching volume
* Add scatter gather utilities for cells
* Sanitize instance in InstanceMetadata to avoid un-pickleable context
* remove the very old unmaintained wsgi scripts
* Extract custom resource classes from flavors
* Fix the log information argument mistake
* Remove mox from nova.tests.unit.virt.xenapi.test\_vm\_utils.py
* Handle version for PUT and POST in PlacementFixture
* Add a reset for traits DB sync
* Strengthen the warning on the old broken WSGI script
* Add key\_name field to InstancePayload
* Add keypairs field to InstanceCreatePayload
* api-ref: Fix missing parameters in API Versions
* placement: refactor driver select\_destinations()
* Updated from global requirements
* VStorage: changed default log path
* Add python 3.5 in classifier
* Delete nic metadata when detaching interface
* Remove mox from nova.tests.unit.api.openstack.compute.test\_limits
* Add get\_count\_by\_vm\_state() to InstanceList object
* move resources\_from\_request\_spec() to utils
* return 400 Bad Request when empty string resources
* placement: adds ProviderTree for nested resources
* Add missing microversion documentation
* Remove mox in test\_availability\_zone.py
* Stop using mox stubs in test\_keypairs.py
* Plumbing for tagged nic attachment
* Remove code that produces warning in modern Python
* Plumbing for tagged volume attachment
* Fix misuse of assertIsNone
* Simplify a condition
* Support paging over compute nodes with a uuid marker
* Update api-ref to indicate swap param
* \_schedule\_instances() supporting a RequestSpec object
* Removes potentially bad exit value from accepted list in Quobyte volume driver
* Switch Nova Quobyte volume driver to mount via systemd-run
* Clean up volumes on boot failure
* Explain why API services are filtered out of GET /os-services
* Fix redundant BDM lookups during rebuild
* Delete all inventory has its own method DELETE
* Remove translation of log messages
* hypervisor\_hostname must match get\_available\_nodes
* Fix using targeted cell context when finding services in cells
* [doc] Updated sqlalchemy URL in migrate readme
* placement: separate normalize\_resources\_qs\_param
* Updated from global requirements
* Use more specific asserts in tests
* Transform instance.soft\_delete notifications
* Fix the note at the end of allocate\_for\_instance
* Count floating ips to check quota
* Add FloatingIPList.get\_count\_by\_project()
* Count fixed ips to check quota
* Add FixedIPList.get\_count\_by\_project()
* Count security groups to check quota
* Add SecurityGroupList.get\_counts()
* Count networks to check quota
* Provide a hint when \_verify\_response fails
* Provide error message in MismatchError for api-samples tests
* placement: produce set of allocation candidates
* Reduce code duplication
* Use plain routes list for os-remote-consoles instead of stevedore
* Remove multiple create from stevedore
* Use plain routes list for os-tenant-networks instead of stevedore
* Use plain routes list for os-cloudpipe endpoint instead of stevedore
* Use plain routes list for os-quota-classes endpoint instead of stevedore
* Consolidate index and detail methods in HypervisorsController
* Handle uuid in HostAPI.compute\_node\_get
* api-ref: fix unshelve asynchronous postconditions typo
* add missing notification samples to dev ref
* Fix regression preventing reporting negative resources for overcommit
* Add separate instance.create payload type
* placement: Add GET /usages to placement API
* placement project\_id, user\_id in PUT /allocations
* api-ref: fix hypervisor\_hostname description for Ironic
* Updated from global requirements
* Provide original fault message when BFV fails
* Add PowerVM to nova support matrix
* remove null\_safe\_int from module scope
* Fix a wrong comment
* Stop caching compute nodes in the request
* Centralize compute\_node\_search\_by\_hypervisor in os-hypervisors
* api-ref: cleanup PUT /os-hypervisors/statistics docs
* Make compute\_node\_statistics() work across cells
* Only auto-disable new nova-compute services
* Cleanup the plethora of libvirt live migration options
* [placement] Update placement devref to modern features
* Make all timestamps formats equal
* Transform keypair.create notification
* remove mox from unit/virt/vmwareapi/test\_driver\_api.py
* XenAPI: device tagging
* Updated from global requirements
* api-ref: fix misleading description in PUT /os-services/disable
* Remove service control from feature support matrix
* Indicate Hyper-v supports fibre channel in support matrix
* Use CONF.host for powervm nodename
* Pull out code that builds VIF in \_build\_network\_info\_model
* Use plain routes list for os-server-groups endpoint instead of stevedore
* Use plain routes list for user\_data instead of stevedore
* remove get\_nw\_info\_for\_instance from compute.utils
* remove ugly local import
* Add missing query filter params for GET /os-services API
* XenAPI: Create linux bridge in dest host during live migration
* Remove translation of log messages
* Count server group members to check quota
* Add bool\_from\_string for force-down action
* Remove old service version check for mitaka
* Clarify conf/compute.py help text for ListOpts
* Use plain routes list for block\_device\_mapping instead of stevedore
* Use plain routes list for os-consoles, os-console-auth-tokens endpoint instead of stevedore
* [placement] Increase test coverage
* Remove unused variable
* pci: add uuid field to PciDevice object
* libvirt: dump debug info when interface detach times out
* Amend api-ref for multiple networks request
* Remove translation of log messages
* Calculate stopped instance's disk sizes for disk\_available\_least
* Transform instance.live\_migration\_rollback notification
* Add InstanceGroup.\_remove\_members\_in\_db

16.0.0.0b2
----------

* Fix lookup of instance mapping in metadata set-password
* libvirt: Extract method \_guest\_add\_spice\_channel
* libvirt: Extract method \_guest\_add\_memory\_balloon
* libvirt: Extract method \_guest\_add\_watchdog\_action
* libvirt: Extract method \_guest\_add\_pci\_devices
* libvirt: Extract method \_guest\_add\_video\_device
* libvirt: fix alternative\_device\_name for detaching interfaces
* [placement] Add api-ref for aggregates
* Add docstring for test\_limit\_check\_project\_and\_user\_zero\_values
* Skip microversion discovery check for update/delete volume attachments
* Use 3.27 microversion when creating new style volume attachments
* Use microversions for new style volume attachments
* libvirt: handle missing rbd\_secret\_uuid from old connection info
* Log a warning if there is only one cell when listing instances
* [placement] Use util.extract\_json in allocations handler
* [placement] Disambiguate resource provider conflict message
* raise exception if create Virtuozzo container with swap disk
* Convert additional disassociate tests to mock
* Remove useless API tests
* Remove \*\*kwargs passing in payload \_\_init\_\_
* Prefer non-PCI host nodes for non-PCI instances
* Add PCIWeigher
* XenAPI: Remove bittorrent.py which is already deprecated
* Count server groups to check quota
* Default to 0 when merging values in limit check
* api-ref: fix type for hypervisor\_marker
* Fix html\_last\_updated\_fmt for Python3
* nfs fix for xenial images
* Remove unused CONF import from placement/auth.py
* xen: pass Xen console in cmdline
* Add earliest-version tags for stable branch renos
* Fix the race condition with novnc
* Add service\_token for nova-glance interaction
* Adopts keystoneauth with glance client
* placement: use separate tables for projects/users
* Move rebuild notification tests into separate method
* contrail: add vrouter VIF plugin type support
* Fix cell0 naming when QS params on the connection
* libvirt: Check if domain is persistent before detaching devices
* Fix device metadata service version check for multiple cells
* Remove cells topic configuration option
* Add get\_minimum\_version\_all\_cells() helper for service
* libvirt: rearange how scsi controller is defined
* libvirt: set full description of the controller used by disk
* libvirt: update LibvirtConfigGuestDeviceAddress to provide XML
* Use plain routes list for os-services endpoint instead of stevedore
* use plain routes list for os-virtual-interfaces
* use plain routes list for hypervisor endpoint instead of stevedore
* Use plain routes list for hosts endpoint instead of stevedore
* Use plain routes list for os-fping endpoint
* Use plain routes list for instance actions endpoint
* Use plain routes list for server ips endpoint
* XenAPI: use os-xenapi 0.2.0 in nova
* Add InstanceGroupList.get\_counts()
* Reset the \_TRAITS\_SYNCED global in Traits tests
* Revert "Remove Babel from requirements.txt"
* Avoid unnecessary lazy-loads in mutated\_migration\_context
* libvirt: log vm and task state when vif plugging times out
* Send out notifications when instance tags changed
* Catch neutronclient.NotFound on floating deletion
* Move notifications/objects/test\_base.py
* Fixed some nits for microversion 2.48
* code comments incorrectness
* Remove Babel from requirements.txt
* Sync os-traits to Traits database table
* Support tag instances when boot(2/4)
* ComputeDriver.get\_info not limited to inst name
* Replace messaging.get\_transport with get\_rpc\_transport
* Be more tolerant of keystone catalog configuration
* Send request\_id on glance calls
* Updated from global requirements
* [placement] Add api-ref for resource classes
* Standardization of VM diagnostics info API
* Remove unused exceptions
* Refactor a test method including 7 test cases
* Fix missing marker functions
* Completed implementation of instance diagnostics for Xen
* Updated from global requirements
* Use VIR\_DOMAIN\_BLOCK\_REBASE\_COPY\_DEV when rebasing
* show flavor info in server details
* placement: Specific error for inventory in use
* Updated from global requirements
* Add database migration and model for consumers
* add new test fixture flavor with extra\_specs
* Updated from global requirements
* Connecting Nova to DRBD storage nodes directly
* Update server create networks API reference description for tags
* libvirt: fix call args to destroy() during live migration rollback
* Pass a list of instance UUIDs to scheduler
* Fix call to driver\_detach in remove\_volume\_connection
* Use plain routes list for server diagnostics endpoint
* Use plain routes list for os-server-external-events endpoint
* Use plain routes list for server-migrations endpoint instead of stevedore
* Use plain routes list for server-tags instead of stevedore
* Use plain routes list for os-interface endpoint instead of stevedore
* Remove usage of parameter enforce\_type
* placement: test for agg association not sharing
* placement: test non-shared out of inventory
* placement: tests for non-shared with shared
* placement: shared resources when finding providers
* Fix live migration devstack hook for multicell environment
* Target cell on local delete
* Updated from global requirements
* Fix default\_availability\_zone docs
* Send request\_id on neutron calls
* Update policy description for os-volumes
* Fix doc job with correct ref link
* Remove oslo.config deprecated parameter enforce\_type
* Completely remove mox from unit/network/test\_linux\_net.py
* Add configuration options for certificate validation
* Do not rely on dogpile internals for mocks
* XenAPI: nova-compute cannot restart after manually delete VM
* Add policy description for os-networks
* Changing deleting stale allocations warning to debug
* Replace diagnostics objects with Nova diagnostics objects
* Added nova objects for intance diagnostics
* [placement] adjust resource provider links by microversion
* Add \`img\_hide\_hypervisor\_id\` image property
* Catch InstanceNotFound when deleting allocations
* Remove mox from nova/tests/unit/virt/xenapi/test\_xenapi.py[1]
* [placement] Add api-ref for DELETE resource provider
* [placement] Add api-ref for PUT resource provider
* [placement] Add api-ref for GET resource provider
* [placement] Add api-ref for POST resource provider
* [placement] Add api-ref for DELETE RP inventory
* [placement] Add api-ref for PUT RP inventory
* [placement] Add api-ref for GET RP inventory
* [placement] Add api-ref for DELETE RP inventories
* [placement] Add api-ref for PUT RP inventories
* Add check\_deltas() and limit\_check\_project\_and\_user() to Quotas
* Enhancement comments on CountableResource
* Deprecate TypeAffinityFilter
* [placement] Add api-ref for GET RP inventories
* Optimize creating security\_group
* Limit the min length of string for integer JSON-Schema
* Avoid lazy-loading instance.id when cross\_az\_attach=False
* Use plain routes list for os-migrations endpoint instead of stevedore
* Updated from global requirements
* Migrate to oslo request\_id middleware - mv 2.46
* Ensure the value of filter parameter is unicode
* XenAPI: Deprecate nicira-iface-id for XenServer VIF
* Don't run ssh validation in cells v1 job
* Fix MarkerNotFound when paging and marker was found in cell0
* Add recreate functional test for regression bug 1689692
* cinder: add attachment\_update method
* cinder: add attachment\_create method
* Use targeted context when burying instances in cell0
* Send request\_id on cinder calls
* Remove unused migrate\_data kwarg from virt driver destroy() method
* Fix the display of updated\_at time when using memcache driver
* Check instance existing before check in mapping
* Remove mox from unit/cells/test\_cells\_messaging.py
* make sure to rebuild claim on recreate
* Nix redundant dict in set\_inventory\_for\_provider
* PowerVM Driver: SSP emphemeral disk support
* Avoid lazy-load error when getting instance AZ
* Handle conflict from neutron when addFloatingIP fails
* re-Allow adding computes with no ComputeNodes to aggregates
* Libvirt volume driver for Veritas HyperScale
* Make the method to put allocations public
* Don't delete allocation if instance being scheduled
* Exclude deleted service records when calling hypervisor statistics
* Modify incorrect comment on return\_reservation\_id
* Remove incorrect comments in multiple\_create
* Have nova.context use super from\_context
* Handle new hosts for updating instance info in scheduler
* [Trivial] Hyper-V: accept Glance vhdx images
* Add strict option to discover\_hosts
* make route and controller in alpha sequence
* [placement] Fix placement-api-ref check tool
* Use plain routes list for limits endpoint instead of stevedore
* Updated from global requirements
* Handle uuid in HostAPI.\_find\_service
* doc: add cells v2 FAQ on mapping instances
* doc: add cells v2 FAQ on refreshing global cells cache
* doc: start a FAQs section for cells v2
* De-complicate some of the instance delete path
* doc: add links to summit videos on cells v2
* Make target\_cell() yield a new context
* Move to proper target\_cell calling convention
* Updated from global requirements
* Repair links in Nova documentation
* api-ref: Fix parameter order in os-services.inc
* fix typo
* Deprecate unused policy from policy doc
* trivial: Remove dead code
* convert unicode to string before we connect to rados
* Use plain routes list for os-quota-sets endpoint instead of stevedore
* Use plain routes list for os-certificates endpoint instead of stevedore
* Remove mox from cells/test\_cells\_rpc\_driver.py
* api-ref: Example verification for servers-actions.inc
* Updated from global requirements
* nova-manage: Deprecate 'log' commands
* nova-manage: Deprecate 'host' commands
* nova-manage: Deprecate 'project', 'account' commands
* libvirt: remove glusterfs volume driver
* libvirt: remove scality volume driver
* Deprecate scheduler trusted filter
* XenAPI: remove hardcode dom0 plugin version in unit test
* Change log level from ERROR to DEBUG for NotImplemented
* Skip policy rules on attach\_network for none network allocation
* Skip ceph in grenade live migration job due to restart failures
* Correct \_ensure\_console\_log\_for\_instance implementation
* Cache database and message queue connection objects
* Correct the error message for query parameter validation
* correctly log port id in neutron api
* Fix uuid replacement in aggregate notification test
* Remove DeviceIsBusy exception
* Catch exception.OverQuota when create image for volume backed instance
* Add policy description for os-host
* Libvirt support for tagged volume attachment
* Libvirt support for tagged nic attachment
* Updated from global requirements
* Add policy description for 'os-hide-server-addresses'
* Add policy description for os-fixed-ips
* Add policy description for networks\_associate
* Add policy description for server\_usage
* Modify the description of flat\_injected in nova.conf
* Add policy description for multinic
* Add policy description for 'limits'
* Use plain routes list for server-password endpoint instead of stevedore
* libvirt: expand checks for SubclassSignatureTestCase
* fix InvalidSharedStorage exception message
* Fix decoding of encryption key passed to dmcrypt
* Make compute auto-disable itself if builds are failing
* Make discover\_hosts only query for unmapped ComputeNode records
* api-ref: Fix examples for add/removeFixedIp action
* Fix a typo in code comment
* Updated from global requirements
* [BugFix] Change the parameter of the exception error message
* Handle special characters in database connection URL netloc
* fix typo in parameter type definition
* Move null\_safe funcs to module level
* do not log error for missing \_save\_tags
* Add more description to policies in the keypairs.py
* Add description to policies in extended\_status and extended\_volumes
* Address comments when moving volume detach to block\_device.py
* Updated from global requirements
* Add a functional test for 'removeFloatingIp' action
* Correct the wording about filter options
* libvirt: Fix races with nfs volume mount/umount
* libvirt: Pass instance to connect\_volume and disconnect\_volume
* Remove the can\_host column
* Totally freeze the extension\_info API
* Trivial fix typo in document
* Add missing rootwrap filter for cryptsetup
* Add Cinder v3 detach to shutdown\_instance
* Make NovaException format errors fatal for tests
* Fix unit test exception KeyErrors
* [BugFix] Release the memory quota for video ram when deleting an instance
* Remove the rebuild extension help methods
* service: use restart\_method='mutate' for all services
* Verify project id for flavor access calls
* Add a convenience attribute for reportclient
* Add uuid to service.update notification payload
* objects: add ComputeNode.get\_by\_uuid method
* objects: add Service.get\_by\_uuid method
* db api: add service\_get\_by\_uuid
* Add online data migration for populating services.uuid
* placement: get providers sharing capacity
* Remove cloudpipe APIs
* Replace newton to release\_name in upgrade.rst
* Fix a typo
* neutron: retrieve physical network name from a multi-provider network
* Use six.text\_type() when logging Instance object
* Fix typo in wsgi applications release note
* Catching OverQuota Exception
* Add description to policies in extended\_az and extend\_ser\_attrs
* Add policy description for os-quota-classes
* Add policy description for instance actions
* Add policy description for fping
* Updated from global requirements
* Ensure sample policy help text correctly wrapped
* Add policy description for extensions
* Use plain routes list for server-metadata endpoint instead of stevedore
* Transform instance.volume\_detach notification
* Transform instance.volume\_attach.error notification
* Transform instance.volume\_attach notification
* Fix units for description of "flavor\_swap" parameter
* Don't lazy-load flavor.projects during destroy()
* devref and reno for nova-{api,metadata}-wsgi scripts
* Add pbr-installed wsgi application for metadata api
* Update devref with vendordata changes
* remove unused functions
* Use systemctl to restart services
* Remove nova-cert leftovers
* Add policy description for image size
* Add policy description for instance-usage-audit-log
* Add policy description for Servers IPs
* Add policy description for config\_drive
* XenAPI: update support matrix to support detach interface
* Remove unnecessary execute permissions
* Use plain routes list for os-fixed-ips endpoint instead of stevedore
* Use plain routes list for os-availability-zone endpoint instead of stevedore
* Use plain routes list for os-assisted-volume-snapshots endpoint
* Use plain routes list for os-agents endpoint instead of stevedore
* Use plain routes list for os-floating-ip-dns endpoint instead of stevedore
* Add compute\_nodes\_uuid\_idx unique index
* Use plain routes list for os-floating-ips-bulk endpoint instead of stevedore
* Use plain routes list for os-floating-ip-pools endpoint instead of stevedore
* Use plain routes list for os-floating-ips endpoint instead of stevedore
* api-ref: Fix unnecessary description in servers-admin-action
* api-ref: Fix parameters in servers-action-console-output
* api-ref: Use 'note' directive
* use plain routes list for os-simple-tenant-usage
* Use plain routes list for os-instance-usage-audit-log  endpoint instead of stevedore
* Support tag instances when boot(1)
* Add Cinder v3 detach call to \_terminate\_volume\_connections
* placement: implement get\_inventory() for libvirt
* nova-manage: Deprecate 'agent' commands
* Add reserved\_host\_cpus option
* Update description to policies in remaining flavor APIs
* Add description to policies in migrations.py
* Trivial fix: fix broken links
* Remove nova-cert
* Fixed a broken link in API Plugins document
* Stop using mox int unit/virt/xenapi/image/test\_utils.py
* Add ability to query for ComputeNodes by their mapped value
* Add ComputeNode.mapped field
* Updated from global requirements
* Add a note to \*\_allocation\_ratio options about Ironic hardcode
* Remove legacy v2.0 code from test\_flavor\_access
* Do not log live migration success when it actually failed
* Expose StandardLogging fixture for use
* Add Cinder v3 detach to local\_cleanup
* Don't check for file type in \_find\_base\_file
* Rename \_handle\_base\_image to \_mark\_in\_use
* Add context comments to \_handle\_base\_image
* Add mock check and fix uuid's use in test
* Revert "Prevent delete cell0 in nova-manage command"
* Improve comment for PCI port binding update
* Parse algorithm from cipher for ephemeral disk encryption
* Add description to policies in floating\_ip files
* Add description to policies in migrate\_server.py
* Remove all discoverable policy rules
* PowerVM Driver: console
* Update doc/source/process.rst
* 2.45: Remove Location header from createImage and createBackup responses
* Clean up ClientRouter debt
* api-ref: move createBackup to server-actions
* Deprecate Multinic, floatingip action and os-virtual-interface API
* Register osapi\_compute when nova-api is wsgi
* disable keepalive for functional tests
* Use plain routes list for '/os-aggregates' endpoint instead of stevedore
* Use plain routes list for '/os-keypairs' endpoint instead of stevedore
* Use plain routes list for flavors-access endpoint instead of stevedore
* Use plain routes list for flavors-extraspecs endpoint instead of stevedore
* Use plain routes list for flavor endpoint instead of stevedore[1]
* Use plain routes list for '/servers' endpoint instead of stevedore
* encryptors: Switch to os-brick encryptor classes
* Fix unnecessary code block in a release note
* Remove redundant code
* api-ref: Fix a parameter description in servers.inc
* api-ref: Parameter verification for servers-actions (4/4)
* api-ref: Parameter verification for servers-actions (3/4)
* Refactor a test method including 3 test cases
* Sort CellMappingList.get\_all() for safety
* Add workaround to disable group policy check upcall
* Make server groups api aware of multiple cells for membership
* libvirt: remove redundant and broken iscsi volume test
* Remove BuildRequest.block\_device\_mapping clone workaround
* libvirt: Always disconnect\_volume after rebase failures
* Rework descriptions in os-hypervisors
* Trivial Fix a typo
* api-ref: Parameter verification for servers-actions (2/4)
* Updated from global requirements
* PowerVM Driver: spawn/destroy #4: full flavor
* Remove archaic reference to QEMU errors during post live migration
* Tell people that the nova-cells man page is for cells v1
* Add release note and update cell install guide for multi-cell limitations
* PowerVM Driver: spawn/destroy #3: TaskFlow
* Allow CONTENT\_LENGTH to be present but empty
* libvirt: Remove is\_job\_complete polling after pivot
* Adding auto\_disk\_config field to InstancePayload
* add tags field to instance.update notification
* Add description to policies in hypervisors.py
* Explicitly define enum type as string in schema
* PowerVM Driver: power\_on/off and reboot
* Using max api version in notification sample test
* PowerVM Driver: spawn/destroy #2: functional
* Warn the user about orphaned extra records during keypair migration
* Deprecate os-hosts API
* Update resource tracker to PUT custom resource classes
* [placement] Idempotent PUT /resource\_classes/{name}
* Update detach to use V3 Cinder API
* conf: Move 'floating\_ips' opts into 'network'
* conf: Deprecate 'default\_floating\_pool'
* conf: Add neutron.default\_floating\_pool
* libvirt: Use config types to parse XML for root disk
* libvirt: Add missing tests for utils.find\_disk
* libvirt: Use config types to parse XML for instance disks
* Updated from global requirements
* Mock timeout in test\_\_get\_node\_console\_with\_reset\_wait\_timeout
* Add test ensure all the microversions are sequential in placement API
* fix overridden error
* fix typos
* Add interfaces functional negative tests
* Remove unused os-pci API
* Fix mitaka online migration for PCI devices
* Fix port update exception when unshelving an instance with PCI devices
* Fix docstring in \_validate\_requested\_port\_ids
* Fix the evacuate API without json-schema validation in 2.13
* api-ref: Fix response code and parameters in evacuate
* Remove json-schema extension variable for resize
* Update etherpad url
* Use deepcopy when process filters in db api
* Add regression test for server filtering by tags bug 1682693
* remove unused parameter in rpc call
* Remove usage of parameter enforce\_type
* Remove test\_init\_nonexist\_schedulerdriver
* Spelling error "paramenter"
* api-ref: Parameter verification for servers-actions (1/4)
* Revert "Make server\_groups determine deleted-ness from InstanceMappingList"

16.0.0.0b1
----------

* Fix hypervisors api missing HostMappingNotFound handlers
* Updated from global requirements
* Fix HTTP 500 raised for getConsoleLog for stopped instance
* Remove backend dependency for key types
* Fix libvirt group selection in live migration test
* Update network metadata type field for IPv6
* Add description to policies in servers.py
* Add description to policies in security\_groups.py
* api-ref: Nova Update Compute services Link
* api-ref: Fix parameters in os-hosts.inc
* Add uuid to Service model
* Modify PciPassthroughFilter to accept lists
* Deprecate CONF.api.allow\_instance\_snapshots
* Read NIC features in libvirt
* Fix api-ref for create servers response
* placement: Add Traits API to placement service
* Remove aggregate uuid generation on load from DB
* Document and provide useful error message for volume-backed backup
* PowerVM Driver: spawn/delete #1: no-ops
* Refactor: Move post method to APIValidationTestCase base class
* remove log translation tags from nova.cells
* Get BDMs when we need to in \_handle\_cell\_delete
* Remove dead db api code
* Add description to policies in server\_password.py
* remove flake8-import-order
* Expand help text for [libvirt]/disk\_cachemodes
* Updated from global requirements
* Add description to policies in remote\_consoles.py
* api-ref: fix os-extended-volumes:volumes\_attached in servers responses
* Image meta min\_disk should be int in fake\_request\_spec
* Optimize the link address
* Add description to policies in quota\_sets.py
* Fix joins in instance\_get\_all\_by\_host
* Fix test\_instance\_get\_all\_by\_host
* Remove the stevedore extension point for server create
* Remove the json-schema extension point of server create
* Remove the extension check for os-networks in servers API
* Make server\_groups determine deleted-ness from InstanceMappingList
* Add get\_by\_instance\_uuids() to InstanceMappingList
* Remove Mitaka-era service version check
* Teach HostAPI about cells
* Make scheduler target cells to get compute node instance info
* Deprecate the Cinder API v2 support
* Limit exposure of network device types to the guest
* Remove a fallacy in scheduler.driver config option help text
* [placement] Allow PUT and POST without bodies
* Use physical utilisation for cached images
* Remove config opts for extension black/white list
* Remove the usage of extension black/white list opt in scheduler hints
* Cleanup wording on compute service version checks in API
* Fix test\_no\_migrations\_have\_downgrade
* Perform old-style local delete for shelved offloaded instances
* Regression test for local delete with an attached volume
* Set size/status during image create with FakeImageService
* Commit usage decrement after destroying instance
* Add regression test for quota decrement bug 1678326
* Short-circuit local delete path for cells v2 and InstanceNotFound
* api-ref: make it clear that os-cells is for cells v1
* Add description to policies in security\_group\_default\_rules.py
* Remove the usage of extension black/white list opt in user data
* Add empty flavor object info in server api-ref
* placement: Enable attach traits to ResourceProvider
* docs: update description for AggregateInstanceExtraSpecsFilter
* nova-net: remove get\_instance\_nw\_info from API subclass
* API: accept None as content-length in HTTP requests
* Switch from pip\_missing\_reqs to pip\_check\_reqs
* nova-manage: Deprecate 'shell' commands
* doc: Separate the releasenotes guide from the code-review section
* Distinguish between cells v1 and v2 in upgrades doc
* Use HostAddressOpt for opts that accept IP and hostnames
* Stop using ResourceProvider in scheduler and RT
* Updated from global requirements
* Remove unnecessary tearDown function in testcase
* Ensure reservation\_expire actually expires reservations
* Remove unnecessary duplicated NOTE
* Add description to policies in server\_diagnostics.py
* Add description to policies in server\_external\_events.py
* Add server-action-removefloatingip.json file and update servers-actions.inc
* api-ref: networks is mandatory in Create Server
* Trivial: Remove unused method
* Make metadata doc more readable
* Remove the usage of extension black/white list opt in AZ
* Remove the usage of extension black/white list opt in config drive
* Remove the usage of extension black/white list opts in multi-create
* Remove the usage of extension black/white list opts in BDM tests
* Rename the model object ResourceProviderTraits to ResourceProviderTrait
* Short circuit notifications when not enabled
* Add description to policies in services.py
* compute: Move detach logic from manager into driver BDM
* doc: Move code-review under developer policies
* Add description to policies in servers\_migrations.py
* Remove mox from nova/tests/unit/consoleauth/test\_consoleauth.py
* Remove unnecessary setUp function in testcase
* api-ref: Fix wrong HTTP response codes
* Make conductor ask scheduler to limit migrates to same cell
* Updated from global requirements
* Consolidate unit tests for shelve API
* Remove \_wait\_for\_state\_change() calls from notification (action)tests
* Fix calling super function in setUp method
* Remove namespace check in creating traits
* Add description for /consoles
* Ensure instance is in active state after notification test
* Add description to policies in used\_limits
* Add description to policies in lock\_server.py
* Add description to policies in server\_metadata.py
* Add description to policies in evacuate.py and rescue.py
* Add description to policies in server\_groups.py
* Use cursive for signature verification
* Fix api-ref for adminPass behavior
* Fix 'server' and 'instance' occurrence in api-ref
* Add description to policies in flavor\_extra\_specs.py
* code comment redundant
* Add exclusion list for tempest for a libvirt+xen job
* Add description to policies in cells\_scheduler.py
* Add description to policies in aggregates.py
* Add description to policies in pause\_server.py
* Add description to policies in simple\_tenant\_usage.py
* Add description to policies in keypairs.py
* Remove unused policy rule in admin\_actions.py
* Add description to policies in admin\_actions
* Add description to policies in certificates.py
* libvirt: Remove dead code
* Add description to policies in console\_output.py
* tox: Stop calling config/policy generators twice
* There is a error on annotation about related options
* Remove mox from nova.tests.unit.objects.test\_instance.py
* fixed typos and reword stable api doc
* Fix some reST field lists in docstrings
* Add description to nova/policies/shelve.py
* [placement] Split api-ref topics per file
* Add description to policies in tenant\_networks.py
* placement: Add Trait and TraitList objects
* Remove legacy regeneration of RequestSpec in MigrationTask
* remove i18n log markers from nova.api.\*
* [placement] add api-ref for GET /resource\_providers
* Structure for simply managing placement-api-ref
* 'uplug' word spelling mistake
* Make xenapi driver compatible with assert\_can\_migrate
* Remove mox from nova/tests/unit/api/openstack/compute/test\_virtual\_interfaces.py
* Remove mox from nova/tests/unit/api/openstack/compute/test\_quotas.py
* Remove mox from nova/tests/unit/api/openstack/compute/test\_migrations.py
* Fix wrong unit test about config option enabled\_apis
* Do not attempt to load osinfo if we do not have os\_distro
* Add confirm resized server functional negative tests
* remove mox from unit/api/openstack/compute/test\_disk\_config.py
* Revert "libvirt: Pass instance to connect\_volume and ..."
* Add descripiton to policies in virtual\_interfaces.py
* Add description to policies to availability\_zone
* Add description to policies in suspend\_server.py
* api-ref: fix description of volumeAttachment for attach/swap-volume
* Get instance availability\_zone without hitting the api db
* Set instance.availability\_zone whenever we schedule
* [placement] Don't use floats in microversion handling
* tests: fix uefi testcases
* libvirt: make emulator threads to run on the reserved pCPU
* libvirt: return a CPU overhead if isolate emulator threads requested
* virt: update overhead to take into account vCPUs
* numa: update numa usage to include reserved CPUs
* numa: take into account cpus reserved
* numa: fit instance NUMA node with cpus reserved onto host NUMA node
* remove mox from unit/api/openstack/compute/test\_flavor\_manage.py
* remove mox from unit/compute/test\_compute\_utils.py
* api-ref: Complete all the verifications of remote consoles
* remove mox from unit/virt/xenapi/image/test\_bittorrent.py
* Fix some reST field lists in docstrings
* Add lan9118 as valid nic for hw\_vif\_model property for qemu
* Add description to policies in deferred\_delete.py
* Add description to policies in create\_backup.py
* Add description to policies in consoles.py
* Add description to policies in cloudpipe.py
* Add description to policies in console\_auth\_tokens.py
* Add description to policies in baremetal\_nodes.py
* conf: Final cleanups in conf/network
* conf: Deprecate 'allow\_same\_net\_traffic'
* libvirt: Ignore 'allow\_same\_net\_traffic' for port filters
* conf: Deprecate 'use\_ipv6'
* netutils: Ignore 'use\_ipv6' for network templates
* Add check for invalid inventory amounts
* Add check for invalid allocation amounts
* Remove the Allocation.create() method
* Add release note for CVE-2017-7214
* Add description to policies in cells.py
* Tests: remove .testrepository/times.dbm in tox.ini (functional)
* Pre-add functional tests stub to notification testing
* libvirt: conditionally set script path for ethernet vif types
* Add description to policies in agents.py
* Add description to policies in admin\_password.py
* libvirt: mark some Image backend methods as abstract
* Add description to policies in assisted\_volume\_snapshots.py
* Change os-server-tags default policy
* Ironic: hardcode min\_unit for standard resources to 1
* Refactor: remove \_items() in nova/api/openstack/compute/attach\_interfaces.py
* delete more i18n log markers
* remove log translation from nova.api.metadata
* update i18n guide for nova
* Add description to policies in attach\_interfaces.py
* Add description to policies in volumes\_attachments.py
* Add description to policies in volumes.py
* Fix rest\_api\_version\_history (2.40)
* fix os-volume\_attachments policy checks
* libvirt: Ignore 'use\_ipv6' for port filters
* conf: Fix indentation in conf/netconf
* Remove unused VIFModel.\_get\_legacy method
* Add helper method to add additional data about policy rule
* DELETE all inventory for a resource provider
* nova-status: don't coerce version numbers to floats for comparison
* remove mox from unit/api/openstack/compute/test\_flavors.y
* Improve descriptions for hostId, host, and hypervisor\_hostname
* compute: Only destroy BDMs after successful detach call
* Remove old oslo.messaging transport aliases
* Updated from global requirements
* do not include context to exception notification
* Add api-ref for filter/sort whitelist
* Fix functional regression/recreate test for bug 1671648
* api-ref: fix description in os-services
* flake8: Specify 'nova' as name of app
* objects: Add attachment\_id to BlockDeviceMapping
* db: Add attachment\_id to block\_device\_mapping
* Updated from global requirements
* Clarify os-stop API description
* remove flake8-import-order for test requirements
* Avoid lazy-loading projects during flavor notification
* libvirt: add debug logging in detach\_device\_with\_retry
* Transform instance.reboot.error notification
* Transform instance.reboot notifications
* remove hacking rule that enforces log translation
* doc: configurable versioned notifications topics
* Replace obsolete vanity openstack.org URLs
* Add populate\_retry to schedule\_and\_build\_instances
* Add a functional regression/recreate test for bug 1671648
* virt: implement get\_inventory() for Ironic
* Fix the help for the disk\_weight\_multiplier option
* Add a note about force\_hosts only ever having a single value
* Make os-availability-zones know about cells
* Introduce fast8 tox target
* Duplicate JSON line ending check to pep8
* trivial: Remove \r\n line endings from JSON sample
* [placement] Raising http codes on old microversion
* Updated from global requirements
* doc: add some documentation around quotas
* Make versioned notifications topics configurable
* Use proper user and tenant in the owner section of libvirt.xml
* Prevent delete cell0 in nova-manage command
* Refactor InstancePayload creation
* nova-status: require placement >= 1.4
* Temporarily untarget context when deleting from cell0
* Decrement quota usage when deleting an instance in cell0
* VMware: use WithRetrieval in ds\_util module
* VMware: use WithRetrieval in get\_network\_with\_the\_name
* Remove VMware driver \_get\_vm\_ref\_from\_uuid method
* trivial: Add a note about 'cells\_api'
* Add description for Image location in snapshot
* Typo fix in releasenotes: deprecate network options
* api-ref: Fix parameters and examples in aggregate API
* Transform instance.rebuild.error notification
* Transform instance.rebuild notification
* Add regression test for bug 1670627
* No API cell up-call to delete consoleauth tokens
* Add identity helper property to CellMapping
* Correctly set up deprecation warning
* Add cell field to Destination object
* Change MQ targeting to honor only what is in the context
* Remove duplicate attributes in sample files
* api-ref: Fix keypair API parameters
* Fix missing instance.delete notification
* conf: Fix formatting of network options
* Teach simple\_tenant\_usage about cells
* Teach os-migrations about cells
* Teach os-aggregates about cells
* Stop using mox in unit/virt/disk/test\_api.py
* Avoid using fdatasync() when fetching images
* Fix API doc about server attributes (2.3 API)
* Refactor cell loading in compute/api
* Target cell in super conductor operations
* Ensure image conversion flushes output data to disk
* fdatasync() downloaded images before use
* conf: fix default values reporting infra worker
* Error message should not include SQL command
* Make consoleauth target the proper cell
* Enlighten server tags API about cells
* Update docstrings for legacy notification methods
* conf: Deprecate most 'network' option
* Use Cinder API v3 as default
* get\_model method missing for Ploop image
* trivial: Standardize naming of variables
* trivial: Standardize indentation of test\_vif
* autospec the virt driver mock in test\_resource\_tracker
* Add functional test for bad res class in set\_inventory\_for\_provider
* Remove unused placement\_database config options
* libvirt: pass log\_path to \_create\_pty\_device for non-kvm/qemu
* virt: add get\_inventory() virt driver API method
* conf: remove console\_driver opt
* Use flake8-import-order
* numa: add numa constraints for emulator threads policy
* Remove mox from nova.tests.unit.api.openstack.compute.test\_block\_device\_mapping
* Revert "Add some metadata logging to root cause ssh failure"
* Add comment to instance\_destroy()
* Remove GlanceImageService
* Use Sphinx 1.5 warning-is-error
* Add warning on setting secure\_proxy\_ssl\_header
* handle uninited fields in notification payload
* Fix api-ref with Sphinx 1.5
* Imported Translations from Zanata
* Reno for additional-notification-fields-for-searchlight
* Default firewall\_driver to nova.virt.firewall.NoopFirewallDriver
* Handle conflicts for os-assisted-volume-snapshots
* Remove mox from nova.tests.unit.api.openstack.compute.test\_create\_backup
* Log with cell.uuid if cell.name is not set
* Updated from global requirements
* re-orphan flavor after rpc deserialization
* Stop using mox stubs in nova.tests.unit.api.openstack.compute.test\_serversV21
* Skip unit tests for SSL + py3
* Add functional test for ip filtering with regex
* Add resize server functional negative tests
* conf: resolved final todos in libvirt conf
* Only create vendordata\_dynamic ksa session if needed
* Check for 204 case in DynamicVendorData
* Add some metadata logging to root cause ssh failure
* Remove unused variable
* Remove domains \*-log-\* from compile\_catalog
* Updated from global requirements
* Updated from global requirements
* [placement] Add Traits related table to the api database
* Remove mox from nova/tests/unit/db/test\_db\_api.py
* Complete verification of servers-action-fixed-ip.inc
* Remove mox in nova/tests/unit/compute/test\_shelve.py (3)
* libvirt: Pass instance to connect\_volume and disconnect\_volume
* Stop using mox in compute/test\_hypervisors.py
* Add device\_id when creating ports
* Make compute/api instance get set target cell on context
* Remove mox from nova.tests.unit.virt.xenapi.test\_vmops[1]
* Tests: remove .testrepository/times.dbm in tox.ini
* Updated from global requirements
* Remove invalid tests-py3 whitelist item
* Ignore deleted services in minimum version calculation
* Add RPC version aliases for Ocata
* Remove mox from nova/tests/unit/test\_configdrive2.py
* Remove usage of config option verbose
* Remove check\_attach
* Handle VolumeBDMIsMultiAttach in os-assisted-volume-snapshots
* api/metadata/vendordata\_dynamic: don't import Requests for its constants
* Fix typos detected by toolkit misspellings
* remove a TODO as all set for tags
* Clean up metadata param in doc
* Remove extension in API layer
* Correct some spelling errors
* Fix typo in config drive support matrix docs
* doc: Don't put comments inside toctree
* Fix doc generation warnings
* Remove run\_tests.sh
* Fix spice channel type
* Updated from global requirements
* libvirt: drop MIN\_LIBVIRT\_HUGEPAGE\_VERSION
* libvirt: drop MIN\_LIBVIRT\_NUMA\_VERSION
* libvirt: drop MIN\_QEMU\_NUMA\_HUGEPAGE\_VERSION
* libvirt: Fix misleading error in Ploop imagebackend
* More usage of ostestr and cleanup an unused dependency
* Ensure that instance directory is removed after success migration/resize
* api-ref: Body verification for os-hypervisors.inc
* Make conductor create InstanceAction in the proper cell
* Allow nova-status to work with custom ca for placement
* libvirt: Handle InstanceNotFound exception
* Make scheduler get hosts from all cells
* Make servers API use cell-targeted context
* Make CellDatabases fixture work over RPC
* Use the keystone session loader in the placement reporting
* Verify project\_id when quotas are checked
* Remove mox from nova/tests/unit/virt/vmwareapi/test\_vif.py
* conf: Fix invalid rST comments
* Revert "fix usage of opportunistic test cases with enginefacade"
* Placement api: set custom json\_error\_formatter in resource\_class
* Enable coverage report
* Make server\_external\_events cells-aware
* Remove service version check for Ocata/Newton placement decisions
* Remove a dead cinder v1 check
* Raise correct error instead of class exist in Placement API
* Remove mox from nova/tests/unit/objects/test\_service.py
* Skip soft-deleted records in 330\_enforce\_mitaka\_online\_migrations
* Stop using mox from tests/unit/test\_service.py
* Update placement\_dev with info about new decorator
* Remove unused logging import
* Deprecate xenserver.vif\_driver config option and change default
* Fix live migrate with XenServer
* Fix novncproxy for python3
* Remove mox stubs in api/openstack/compute/test\_server\_reset\_state.py
* Fix some typo errors
* Enable defaults for cell\_v2 update\_cell command
* Remove dead code: \_safe\_destroy\_instance\_residue
* Updated from global requirements
* Make eventlet hub use a monotonic clock
* Tolerate WebOb===1.7.1
* Tolerate jsonschema==2.6.0
* Stop using mox in test\_compute\_cells.py
* Stop using mox in virt/xenapi/image/test\_glance.py
* Remove mox from unit/api/openstack/compute/test\_aggregates.py
* Remove mox from api/openstack/compute/test\_deferred\_delete.py
* Typo fix: degredation => degradation
* api-ref: Fix deprecated proxy API parameters
* api-ref: note that boot ignores bdm:device\_name
* Skip test\_stamp\_pattern in cells v1 job
* Fix misuse of assertTrue
* Fix improper prompt when update RC with existed one's name
* Remove mox from nova/tests/unit/virt/vmwareapi/test\_configdrive.py
* Placement api: set custom json\_error\_formatter in root
* Cleanup some issues with CONF.placement.os\_interface
* Placement api: set custom json\_error\_formatter in aggregate and usage
* Fix suggested database migration command
* Placement api: set custom json\_error\_formatter in resource\_provider
* api-ref: Fix network\_label parameter type
* Fix incorrect example for querying resource for RP
* Use ListOfIntegersField in oslo.versionedobjects
* libvirt: drop MIN\_QEMU\_PPC64\_VERSION
* libvirt: drop MIN\_LIBVIRT\_AUTO\_CONVERGE\_VERSION
* libvirt: drop MIN\_QEMU\_DISCARD\_VERSION
* libvirt: drop MIN\_LIBVIRT\_HYPERV\_TIMER\_VERSION
* libvirt: drop MIN\_LIBVIRT\_UEFI\_VERSION
* libvirt: drop MIN\_LIBVIRT\_FSFREEZE\_VERSION
* libvirt: drop MIN\_LIBVIRT\_BLOCKJOB\_RELATIVE\_VERSION
* Bump minimum required libvirt/qemu versions for Pike
* api-ref: fix instance action 'message' description
* Placement api: set custom json\_error\_formatter in inventory
* conf/libvirt: remove invalid TODOs
* conf/compute: remove invalid TODOs
* Remove straggling use of main db flavors in cellsv1 code
* Add Cells V1 -> Cells V2 step-by-step example
* nova-manage: Update deprecation timeline
* Enable global hacking checks and removed local checks
* Update hacking version
* Use min parameter to restrict live-migration config options
* Fix typo in nova/network/neutronv2/api.py
* libvirt: wait for interface detach from the guest
* libvirt: fix and break up \_test\_attach\_detach\_interface
* api-ref: mark id as optional in POST /flavors
* Fix nova-manage cell\_v2 metavar strings
* Remove unused validation code from block\_device
* Prepare for using standard python tests
* Placement api: set custom json\_error\_formatter in allocations
* [3/3]Replace six.iteritems() with .items()
* conf: Deprecate 'firewall\_driver'
* conf: Deprecate 'ipv6\_backend'
* libvirt: set vlan tag for macvtap on SR-IOV VFs
* Removed unnecessary parantheses and fixed formation
* Fix the spelling mistake in host.py
* Allow None for block\_device\_mapping\_v2.boot\_index
* Edits for Cells V2 step-by-step examples
* api-ref: fix delete server async postcondition docs
* libvirt: check if we can quiesce before volume-backed snapshot
* Default live\_migration\_progress\_timeout to off
* libvirt: Remove redundant bdm serial mangling and saving during swap\_volume
* Consider startup scenario in \_get\_compute\_nodes\_in\_db
* libvirt: Introduce Guest.get\_config method
* libvirt: Parse basic attributes of LibvirtConfigGuest from xml
* libvirt: Parse filesystem elements of guest config
* libvirt: Parse virt\_type attribute of LibvirtConfigGuest from xml
* libvirt: Parse os attributes of LibvirtConfigGuest from xml
* libvirt: Remove unused disk\_info parameter
* libvirt: Simplify internal usage of get\_instance\_disk\_info
* Stop failed live-migrates getting stuck migrating
* Stop \_undefine\_domain erroring if domain not found
* tests: fix vlan test type from int to str
* Add an update\_cell command to nova-manage
* allocations.consumer\_id is not used in query
* api-ref: document the 'tenant\_id' query parameter
* TrivialFix: replace list comprehension with 'for'
* Reserve migration placeholders for Ocata backports
* Update the upgrades part of devref
* Cleanup the caches when deleting a resource provider
* vomiting
* Clarify the deployment of placement for cellsv1 users
* conf: remove deprecated image url options
* conf: add min parameter to scheduler opts
* Add step-by-step examples for Cells V2 setup
* Add nodename to \_claim\_test log messages
* Update reno for stable/ocata

15.0.0.0rc1
-----------

* Add placement request id to log when GET or POST rps
* Add placement request id to log when GET aggregates
* Add more debug logging on RP inventory delete failures
* Add more debug logging on RP inventory update failures
* Delete a compute node's resource provider when node is deleted
* Remove mox from unit/virt/libvirt/test\_imagebackend.py (end)
* Mark compute/placement REST API max microversions for Ocata
* Add release note for filter/sort whitelist
* Clarify the language in the apache wsgi sample
* Stop swap allocations being wrong due to MB vs GB
* Clarify the [cells] config option help
* Add offset & limit docs & tests
* Report reserved\_host\_disk\_mb in GB not KB
* Fix access\_ip\_v4/6 filters params for servers filter
* Fix typo in cells v2 ocata reno
* doc: add upgrade notes to the placement devref
* Simplify uses of assert\_has\_calls
* Fix typo in help for discover\_hosts\_in\_cells\_interval
* Handle NotImplementedError in \_process\_instance\_vif\_deleted\_event
* Fix the terminated\_at field in the server query params schema
* Add release note for nova-status upgrade check CLI
* Add prelude section for Ocata
* Collected release notes for Ocata CellsV2
* reno for notification-transformation-ocata
* Allow scheduler to run cell host discovery periodically
* doc: update the man page entry for nova-manage db sync
* doc: refer to the cell\_v2 man pages from the cells v2 doc
* doc: add some detail to the map\_cell0 man page
* Remove pre-cellsv2 short circuit in instance get
* Continue processing build requests even if one is gone already
* Allow placement endpoint interface to be set
* Ensure build request exists before creating instance
* placement-api: fix ResourceProviderList query
* tests: Remove duplicate NumaHostInfo
* tests: Combine multiple NUMA-generation functions
* tests: Don't reinvent \_\_init\_\_
* Explain how allow\_resize\_to\_same\_host is useful
* nova-status: relax the resource providers check
* Read instances from API cell for cells v1
* [placement] Use modern attributes of oslo\_context
* Fix map\_cell\_and\_hosts help
* Fresh resource provider in RT must have generation 0
* libvirt: Limit destroying disks during cleanup to spawn
* Use is\_valid\_cidr and is\_valid\_ipv6\_cidr from oslo\_utils
* Ignore IOError when creating 'console.log'
* Fix unspecified bahavior on GET /servers/detail?tenant\_id=X as admin
* Remove unused exceptions from nova.exception
* nova-manage docs: cell\_v2 delete\_cell
* nova-manage docs: cell\_v2 list\_cells
* nova-manage docs: cell\_v2 discover\_hosts
* nova-manage docs: cell\_v2 create\_cell
* nova-manage docs: cell\_v2 verify\_instance
* nova-manage docs: cell\_v2 map\_cell\_and\_hosts
* Fix tag attribute disappearing in 2.33 and 2.37
* Scheduler calling the Placement API
* Block starting compute unless placement conf is provided
* Added instance.reboot.error to the legacy notifications
* Avoid redundant call to update\_resource\_stats from RT
* api-ref: Fix path parameters in os-hypervisors.inc
* libvirt: fix vCPU usage reporing for LXC/QEMU guests
* Adding vlans field to Device tagging metadata
* libvirt: expose virtual interfaces with vlans to metadata
* objects: vlan field to NetworkInterfaceMetadata object
* Move instance creation to conductor
* Updated from global requirements
* Fix server group functional test by using all filters
* Hyper-V PCI Passthrough
* Change exponential function to linear
* Fixed indentation in virt/libvirt/driver.py
* Cache boot time roles for vendordata
* Optionally make dynamic vendordata failures fatal
* Use a service account to make vendordata requests
* libvirt: ephemeral disk support for virtuozzo containers

15.0.0.0b3
----------

* ironic: Add trigger crash dump support to ironic driver
* Only warn about hostmappings during ocata upgrade
* nova-manage docs: cell\_v2 map\_instances
* nova-manage docs: cell\_v2 map\_cell0
* nova-manage docs: cell\_v2 simple\_cell\_setup
* Add new configuration option live\_migration\_scheme
* Fix race condition in instance.update sample test
* libvirt: Use the mirror element to detect job completion
* libvirt: Mock is\_job\_complete in test\_driver
* adding debug info for pinning calculation
* PCI: Check pci\_requests object is empty before passing to support\_requests
* Ironic: Add soft power off support to Ironic driver
* Add sort\_key white list for server list/detail
* Trivial-fix: replace "json" with "yaml" in policy README
* Release PCI devices on drop\_move\_claim()
* objects: add new field cpuset\_reserved in NUMACell
* Make api\_samples tests use simple cell environment
* Assign mac address to vf netdevice when using macvtap port
* conf: Deprecate 'console\_driver'
* libvirt: avoid generating script with empty path
* placement: minor refactor \_allocate\_for\_instance()
* placement: report client handle InventoryInUse
* Multicell support for instance listing
* scheduler: Don't modify RequestSpec.numa\_topology
* Fix and add some notes to the cells v2 first time setup doc
* Add deleting log when config drive was imported to rbd
* Updated from global requirements
* Amend the PlacementFixture
* Prevent compute crash on discovery failure
* Ironic: Add soft reboot support to ironic driver
* os-vif: convert libvirt driver to use os-vif for fast path vhostuser
* Updated from global requirements
* Add a PlacementFixture
* Set access\_policy for messaging's dispatcher
* libvirt: make coherent logs when reboot success
* Add ComputeNodeList.get\_all\_by\_uuids method
* Fix typo in 216\_havana.py
* placement: create aggregate map in report client
* Support Ironic interface attach/detach in nova virt
* Generate necessary network metadata for ironic port groups
* Ensure we mark baremetal links as phy links
* os-vif-util: set vif\_name for vhostuser ovs os-vif port
* Move migration\_downtime\_steps to libvirt/migration
* libvirt: fix nova can't delete the instance with nvram
* Remove mox in libvirt destory tests
* VMWare: Move constant power state strings to the constant.py
* Remove references to Python 3.4
* hyperv: make sure to plug OVS VIFs after resize/migrate
* Strict pattern match query parameters
* Raise InvalidInput exception
* Fix Nova to allow using cinder v3 endpoint
* [py35] Fixes to get more tempest tests working
* Move to tooz hash ring implementation
* api-ref: Fix a parameter in os-availability-zone.inc
* objects: remove cpu\_topology from \_\_init\_\_ of InstanceNUMATopology
* Integrate OSProfiler and Nova
* Remove mox from unit/virt/libvirt/test\_imagebackend.py (5)
* Enable virt.vmwareapi test cases on Python
* Enable virt.test\_virt\_drivers.AbstractDriverTestCase on Python 3
* Port compute.test\_user\_data.ServersControllerCreateTest to Python 3
* Add revert resized server functional negative tests
* XenAPI: Fix vif plug problem during VM rescue/unrescue
* Handle oslo.serialization type error and binascii error
* Remove invalid URL in gabbi tests
* nova-manage cell\_v2 map\_cell0 exit 0
* Add query parameters white list for server list/detail
* nova-manage docs: add cells commands prep
* Add --verbose option to discover\_hosts command
* Add more details when test\_create\_delete\_server\_with\_instance\_update fails
* Updated from global requirements
* Add some cellsv2 setup docs
* Fix the generated cell0 default database name
* rt: use a single ResourceTracker object instance
* Add nova-manage cell\_v2 delete\_cell command
* Add InstanceMappingList.get\_by\_cell\_id
* Create HostMappingList object
* Add nova-manage cell\_v2 list\_cells command
* Add nova-manage cell\_v2 create\_cell command
* Add rudimentary CORS support to placement API
* libvirt: workaround findmnt behaviour change
* api-ref: Fix parameters whose values are 'null'
* Fix broken link of Doc
* api-ref: Fix parameters and response in os-quota-sets.inc
* Remove nova-manage image from man pages
* Updated from global requirements
* Fixes to get all functional tests working on py35
* [placement] Add a bit about extraction plans to placement\_dev
* [placement] Add an "Adding a Handler" section to placement\_dev
* [placement] placement\_dev info for testing and gabbi
* [placement] placement\_dev info for microversion handling
* Updated from global requirements
* placement: validate member\_of values are uuids
* Make metadata server know about cell mappings
* Remove redundant arg check in nova-manage cell\_v2 verify\_instance
* Expose a REST API for a specific list of RPs
* copy pasta error
* Set sysinfo\_serial="none" in LibvirtDriverTestCase
* [py35] Fixes to get rally scenarios working
* Fix missing RP generation update
* Add service\_token for nova-neutron interaction
* rt: explicitly pass compute node to \_update()
* Make unit tests work with os-vif 1.4.0
* Updated from global requirements
* libvirt: make live migration possible with Virtuozzo
* Small improvements to placement.rst
* Better black list for py35 tests
* Fix class type error in attach\_interface() function
* Hyper-V: Adds vNUMA implementation
* Don't bypass cellsv1 replication if cellsv2 maps are in place
* Adds Hyper-V OVS ViF driver
* docs - Connect to placement service & retries
* Improve flavor sample in notification sample tests
* xenapi: support the hotplug of a neutron port
* Update notification for flavor
* Add service\_token for nova-cinder interaction
* Make allocate\_for\_instance take consistent args
* XenAPI Remove useless files when use os-xenapi lib
* XenAPI Use os-xenapi lib for nova
* Make placement client keep trying to connect
* releasenotes: Add missing releasenote for encryption provider constants
* Stop using mox stubs in test\_attach\_interfaces.py
* Remove mox from api/openstack/compute/test\_floating\_ip\_dns.py
* Remove mox in nova/tests/unit/compute/test\_shelve.py (end)
* Remove mox in unit/api/openstack/test\_wsgi.py
* Document testing process for zero downtime upgrade
* Remove mox in nova/tests/unit/compute/test\_shelve.py (2)
* Notifications for flavor operations
* Add debug possibility for nova-manage command
* conf: Deprecate yet more nova-net options
* conf: Resolve formatting issues with 'quota'
* [2/3]Replace six.iteritems() with .items()
* Port xenapi test\_vm\_utils to Python 3
* docs: sort the Architecture Concepts index
* Make the SingleCellSimple fixture a little more comprehensive
* Fix non-parameterized service id in hypervisors sample tests
* Fix TypeError in \_update\_from\_compute\_node race
* Trivial indentation fix
* Add missing CLI commands in support-matrix.ini
* tests: Replace use of CONF with monkey patching
* correct misleading wording
* Fix a typo in documents
* Don't translate exceptions w/ no message
* Fix ksa mocking in test\_cinderclient\_unsupported\_v1
* [placement] fix typo in call to create auth middleware
* HTTP interface for resource providers by aggregates
* Return uuid attribute for aggregates
* Update docstring of \_schema\_validation\_helper
* api-ref: use the examples with paging links
* Port libvirt.test\_vif to Python 3
* Port libvirt.test\_firewall to Python 3
* Move quota options to a config group
* Handle Unauthorized exception in report client's safe\_connect()
* Remove mox from unit/virt/libvirt/test\_imagebackend.py (4)
* Remove mox from unit/virt/libvirt/test\_imagebackend.py (3)
* Remove mox from unit/virt/libvirt/test\_imagebackend.py (2)
* Do not post allocations that are zero
* Remove mox from unit/compute/test\_compute\_api.py (1)
* Add aggregate notification related enum values
* Transform aggregate.delete notification
* Transform aggregate.create notification
* Added missing decorator for instance.create.error
* Enable Neutron by default
* Port virt.libvirt.test\_imagebackend to Python 3
* move gate hooks to gate/
* tools: Remove 'colorizer'
* tools: Remove 'with\_venv'
* tools: Remove 'install\_venv', 'install\_venv\_common'
* tools: Remove 'clean-vlans'
* tools: Remove 'enable-pre-commit-hook'
* Use JSON-Schema to validate query parameters for keypairs API
* Adds support for versioned schema validation for query parameters
* Remove mox from api/openstack/compute/test\_extended\_hypervisors.py
* Stop using mox in compute/test\_server\_actions.py
* Remove mox from unit/api/openstack/compute/test\_cloudpipe.py
* Add support matrix for attach and detach interfaces
* Make last remaining unit tests work with Neutron by default
* Make test\_metadata pass with CONF.use\_neutron=True by default
* Make test\_nova\_manage pass with CONF.use\_neutron=True by default
* Stub out os\_vif.unplug in libvirt instance destroy tests
* Make test\_attach\_interfaces work with use\_neutron=True by default
* Make test\_floating\_ip\* pass with CONF.use\_neutron=True by default
* Make several API unit tests pass with CONF.use\_neutron=True by default
* Make test\_server\_usage work with CONF.use\_neutron=True by default
* Make test\_security\_group\_default\_rules work with use\_neutron=True by default
* Make test\_tenant\_networks pass with CONF.use\_neutron=True by default
* Make test\_security\_groups work with CONF.use\_neutron=True by default
* Make test\_virtual\_interfaces work with CONF.use\_neutron=True by default
* Make test\_user\_data and test\_multiple\_create work with use\_neutron=True
* Make test\_quota work with CONF.use\_neutron=True by default
* Make test\_compute pass with CONF.use\_neutron=True by default
* api-ref: Fix parameters in os-server-groups.inc
* Remove mox in test\_block\_device\_mapping\_v1.py
* placement: Do not save 0-valued inventory
* Add 'disabled' to WatchdogAction field
* Remove more deprecated nova-manage commands
* Make servers api view load instance fault from proper cell
* Add support for setting boot order in Hyper-V
* Create schema generation for NetworkModel
* conf: added notifications group
* Missing usage next links in api-ref
* [placement] start a placement\_dev doc
* Stop handling differences in registerCloseCallback
* Enable TestOSAPIFixture.test\_responds\_to\_version on Python 3
* pci: Clarify SR-IOV ports vs direct passthrough ports
* nova-status: check for compute resource providers
* doc: add recomendation for delete notifications
* Move FlavorPayload to a seperate file
* Remove Rules.load\_json warning
* Handle unicode when dealing with duplicate aggregate errors during migration
* Handle unicode when dealing with duplicate flavors during online migrations
* Actually test online flavor migrations
* Remove unused init\_only kwarg from wsgi app init
* api-ref: add notes about POST/DELETE errors for os-tenant-networks
* Remove unnecessary attrs from TenantNetworksDeprecationTest
* api-ref: microversion 2.40 overview
* Fix assertion in test\_instance\_fault\_get\_by\_instance
* Add more field's in InstancePayload
* api-ref: cleanup os-server-groups 'policies' parameter description
* objects: add new field cpu\_emulator\_threads\_policy
* Support filtering resource providers by aggregate membership
* Resource tracker doesn't free resources on confirm resize
* Stop using mox stubs in nova/tests/unit/cells
* Add release note to PCI passthrough whitelist regex support
* api-ref: Fix parameter type in servers-admin-action.inc
* Port security group related tests to Python 3
* Add create image functional negative tests
* Don't apply multi-queue to SRIOV ports
* Avoid multiple initializations of Host class
* placement: correct improper test case inheritance
* Remove mox in tests/unit/objects/test\_instance\_info\_cache
* Port compute unit tests to Python 3
* Fix urllib.urlencode issue in functional tests on Python 3
* Trival fix typo
* Enble network.test\_neutronv2.TestNeutronv2 on Python 3
* Enble compute.test\_compute\_mgr.ComputeManagerUnitTestCase on Python 3
* Port api.openstack.compute.test\_disk\_config to Python 3
* Updated from global requirements
* Ignore 404s when deleting allocation records
* nova-status: return 255 for unexpected errors
* VMware: Update supported OS types for ESX 6.5
* Replace "Openstack" with "OpenStack"
* Use bdm destination type allowed values hard coded
* Fix BDM JSON-Schema validation
* [TrivialFix] Fix comment and function name typo error
* [TrivialFix] Fix comment typo error
* Fix python3 issues with devstack
* [1/3]Replace six.iteritems() with .items()
* Fix typo
* Fix misleading port delete description
* conf: remove deprecated barbican options
* conf: Remove 'virt' file
* Trival fix typos in api-ref
* make 2.31 microversion wording better
* Add soft delete wrinkle to api-ref
* Add document update for get console usage
* Trivial: add ability to define action description
* Added missed "raises:" docstrings into numa\_get\_constraints() method
* Removes unnecessary utf-8 encoding
* Port test\_matchers.TestDictMatches.test\_\_str\_\_ to Python 3
* Skip network.test\_manager.LdapDNSTestCase on Python 3
* Remove mox in tests/unit/objects/test\_security\_group
* Remove v2.40 from URL string in usage API docs
* nova-status: add basic placement status checking
* nova-status: check for cells v2 upgrade readiness
* Add nova-status upgrade check command framework
* rt: remove fluff from test\_resource\_tracker
* rt: pass the nodename to public methods
* conf: make 'default' upper case
* conf: move few console opts to xenserver group
* conf: remove deprecated ironic options
* conf: refactor conf\_fixture.py
* Add unit test for extract\_snapshot with compression enabled
* Refactor the code to add generic schema validation helper
* Updated from global requirements
* Fix error if free\_disk\_gb is None in CellStateManager
* nova-manage: squash oslo\_policy debug logging
* Pre-load info\_cache when handling external events and handle NotFound
* Make nova-manage cell\_v2 discover\_hosts tests use DBs
* Fix nova-manage cell\_v2 discover\_hosts RequestContext
* Make nova-manage emit a traceback when things blow up
* XenAPI: Remove ovs\_integration\_bridge default value
* rt: pass nodename to internal methods
* Failing test (mac osx) - test\_cache\_ephemeral
* Catch VolumeEncryptionNotSupported during spawn
* Updated from global requirements
* Fix exception message formatting error in test
* osapi\_max\_limit -> max\_limit
* Add more detail to help text for reclaim\_instance\_interval option
* Added PRSM to HVType class for support PR/SM hypervisor
* conf: Deprecate more nova-net options

15.0.0.0b2
----------

* [test]Change fake image info to fit instance xml
* Cleanup Newton Release Notes
* Port libvirt.storage.test\_rbd to Python 3
* VMware: ensure that provider networks work for type 'portgroup'
* libvirt: Stop misusing NovaException
* Fix the file permissions of test\_compute\_mgr.py
* Add detail to cellsv2-related release notes
* Revert "Use liberty-eol tag for liberty release notes"
* Fix some release notes in preparation for the o-2 beta release
* Add schedule\_and\_build\_instances conductor method
* libvirt: Detach volumes from a domain before detaching any encryptors
* libvirt: Flatten 'get\_domain' function
* fakelibvirt: Remove unused functions
* libvirt: Remove slowpath listing of instances
* Only return latest instance fault for instances
* Remove dead begin/end code from InstanceUsageAuditLogController
* Use liberty-eol tag for liberty release notes
* api-ref: Fix description of os-instance-usage-audit-log
* conf: fix formatting in base
* Stop allowing tags as empty string
* libvirt: remove hack for dom.vcpus() returning None
* Add Python 3.5 functional tests in tox.ini
* Simple tenant usage pagination
* Modify mistake of scsi adapter type class
* Remove the EC2 compatible API tags filter related codes
* Port virt vmwareapi tests to Python 3
* Mark sibling CPUs as 'used' for cpu\_thread\_policy = 'isolated'
* Added missed "raises:" docstrings into numa\_get\_constraints() method
* Changed NUMACell to InstanceNUMACell in test\_stats.py
* TrivialFix: changed log message
* api-ref: Fix 'id' (attachment\_id) parameters
* Move tags validation code to json schema
* Let nova-manage cell\_v2 commands use transport\_url from CONF
* Make test\_create\_delete\_server\_with\_instance\_update deterministic
* restore locking in notification tests
* Remove mox from unit/compute/test\_compute\_api.py(2)
* Deprecate compute options
* Remove support for the Cinder v1 API
* Make simple\_cell\_setup fully idempotent
* Corrects the type of a base64 encoded string
* Fix instructions for running simple\_cell\_setup
* Quiet unicode warnings in functional test\_resource\_provider
* conf: Detail the 'injected\_network\_template' opt
* Add more description for rx and tx param
* move rest\_api\_version\_history.rst to compute layer
* Enhance PCI passthrough whitelist to support regex
* Better wording for micorversion 2.36
* Port test\_servers to py3
* Catch InstanceNotFound exception
* Remove mox in tests/unit/objects/test\_compute\_node
* Refactor REGEX filters to eliminate 500 errors
* Fix crashing during guest config with pci\_devices=None
* Provide an online data migration to cleanup orphaned build requests
* Add SecurityGroup.identifier to prefer uuid over name
* Setup CellsV2 environment in base test
* conf: add warning for vm's max delete attempts
* Cleanup after any failed libvirt spawn
* Guestfs handle no passwd or group in image
* Return 400 when name is more than 255 characters
* Check that all JSON files don't have \r\n in line
* Enable test\_bdm.BlockDeviceMappingEc2CloudTestCase on Python 3
* network id is uuid instead of id
* fix for auth during live-migration
* Don't trace on ImageNotFound in delete\_image\_on\_error
* Cascade deletes of RP aggregate associations
* Make resource provider objects not remotable
* Bump prlimit cpu time for qemu from 2 to 8
* test: drop unused config option fake\_manager
* conf: Remove config option compute\_ manager
* Extend get\_all\_by\_filters to support resource criteria
* Port test\_virt\_drivers to Python 3
* Don't use 'updated\_at' to check service's status
* libvirt: Fix initialising of LVM ephemeral disks
* Remove extra ^M for json file
* Port virt.disk.mount.test\_nbd to Python 3
* Remove unnecessary comment of BDM validation
* Update ironic driver get\_available\_nodes docstring
* api-ref: note that os-virtual-interfaces is nova-network only
* Fix up non-cells-aware context managers in test\_db\_api
* Add SingleCellSimple fixture
* [proxy-api] microversion 2.39 deprecates image-metadata proxy API
* Make RPCFixture support multiple connections
* tests: avoid starting compute service twice in sriov functional test
* tests: generate correct pci addresses for fake pci devices
* Fix nova-serialproxy when registering cli options
* Updated from global requirements
* Revert "reduce pep8 requirements to just hacking"
* conf: Improve help text for network options
* conf: Deprecate all nova-net related opts
* libvirt: Mock imagebackend template funcs in ImageBackendFixture
* libvirt: Combine injection info in InjectionInfo
* Fix misuse of assertTrue
* Return 400 when name is more than 200 characters
* Replace the assertEqual(None,A) with assertIsNone(A)
* Rename few tests as per new config options
* Handle MarkerNotFound from cell0 database
* Removed unused ComputeNode create/update\_inventory methods
* Fix a typo in a comment in microversion history
* Handle ImageNotFound exception during instance backup
* Add a CellDatabases test fixture
* Pass context as kwarg instead of positional arg to get\_engine
* Transform instance.snapshot notifications
* libvirt: virtlogd: use virtlogd for char devices
* libvirt: create consoles in an understandable/extensible way
* Add more log when delete orphan node
* libvirt: Add comments in \_hard\_reboot
* Update cors-to-versions-pipeline release note
* Unity the comparison of hw\_qemu\_guest\_agent
* Add metadata functional negative tests
* Require cellsv2 setup before migrating to Ocata
* Improving help text for xenapi\_vmops\_opts
* convert libvirt driver to use os-vif for vhost-user with ovs
* Handle ComputeHostNotFound when listing hypervisors
* Improve the error message for failed RC deletion
* refactor: move down \`\`dev\_number\`\` in xenapi
* Fix placement API version history 1.1 title
* placement: Perform build list of standard classes once
* placement: REST API for resource classes
* Add a retry loop to ResourceClass creation
* conf: Remove deprecated service manager opts
* support polling free notification testing
* conf: Standardize formatting of virt
* Updated from global requirements
* Remove invalid tests for config option osapi\_compute\_workers
* placement: adds ResourceClass.save()
* Add CORS filter to versions pipeline
* Create hyperv fake images under proper directory
* Some improvement to the process doc
* libvirt: Improve \_is\_booted\_from\_volume implementation
* libvirt: Delete duplicate check when live-migrating
* Add block\_device\_mapping\_v2.uuid to api-ref
* Correct the sorting of datetimes for migrations
* Fix pci\_alias that include white spaces
* Raise DeviceNotFound detaching volume from persistent domain
* Always use python2.7 for docs target
* objects: Removes base code that already exists in o.vo
* libvirt: Don't re-resize disks in finish\_migration()
* libvirt: Never copy a swap disk during cold migration
* libvirt: Rename Backend snapshot and image
* libvirt: Cleanup test\_create\_configdrive
* libvirt: Test disk creation in test\_hard\_reboot
* libvirt: Rewrite \_test\_finish\_migration
* guestfs: Don't report exception if there's read access to kernel
* Fix for live-migration job
* Handle maximum limit in schema for int and float type parameters
* Port compute.test\_extended\_ip\* to Python 3
* Remove more tests from tests-py3.txt
* Support detach interface with same MAC from instance
* placement: adds ResourceClass.destroy()
* Make test\_shelve work with CONF.use\_neutron=True by default
* Restrict test\_compute\_cells to nova-network
* Make test\_compute\_mgr work with CONF.use\_neutron=True by default
* Make test\_compute\_api work with CONF.use\_neutron=True by default
* Make nova.tests.unit.virt pass with CONF.use\_neutron=True by default
* Make xenapi tests work with CONF.use\_neutron=True by default
* Make libvirt unit tests work with CONF.use\_neutron=True by default
* Make vmware unit tests work with CONF.use\_neutron=True
* Explicitly use nova-network in nova-network network tests
* Make test\_serversV21 tests work with neutron by default
* neutron: handle no\_allocate in create\_pci\_requests\_for\_sriov\_ports
* Add a releasenote for bug#1633518
* libvirt: prefer cinder rbd auth values over nova.conf
* libvirt: cleanup network volume driver auth config
* Fix wait for detach code to handle 'disk not found error'
* [api-ref] Minor text clean-up, formatting
* Convert live migration uri back to string
* conf: improve libvirt lvm
* conf: Trivial fix of indentation in 'api'
* config options: improve libvirt utils
* Never pass boolean deleted to instance\_create()
* Port xenapi test\_xenapi to Python 3
* Port libvirt test\_driver to Python 3
* conf: Deprecate 'torrent\_' options
* hacking: Use uuidutils or uuidsentinel to generate UUID
* Replace uuid4() with uuidsentinel
* Replace uuid4() with uuidsentinel
* Replace uuid4() with uuidsentinel
* Add os-start/stop functional negative tests
* Port ironic unit tests to Python 3
* Port test\_keypairs to Python 3
* Port test\_metadata to Python 3
* Fix expected\_attrs kwarg in server\_external\_events
* Check deleted flag in Instance.create()
* Revert "Revert "Make n-net refuse to start unless using CellsV1""
* Revert "Log a warning when starting nova-net in non-cellsv1 deployments"
* Default deleted if the instance from BuildRequest is not having it
* docs: cleanup wording for 'SOFT\_DELETED' in api-guide
* libvirt: Acquire TCP ports for console during live migration
* conf: Deprecate 'remap\_vbd\_dev' option
* conf: Covert StrOpt -> PortOpt
* Check Config Options Consistency  for xenserver.py
* Add description for 2.9 microversion
* Remove AdminRequired usage in flavor
* Optional name in Update Server description in api-ref
* List support for force-completing a live migration in Feature support matrix
* Remove mox from nova/tests/unit/compute/test\_virtapi.py
* Remove mox from nova/tests/unit/virt/test\_virt.py
* Catch ImageNotAuthorized during boot instance
* Remove require\_admin\_context
* remove NetworkDuplicated exception
* InstanceGroupPolicyNotFound not used anymore
* UnsupportedBDMVolumeAuthMethod is not used
* Port virt.xenapi.client.test\_session to Python 3
* vif: allow for creation of multiqueue taps in vrouter
* conf: Move api options to a group
* [scheduler][tests]: Fix incorrect aggr mock values
* objects: Move 'vm\_mode' to 'fields.VMMode'
* objects: Move 'hv\_type' to 'fields.HVType'
* objects: Move 'cpumodel' to 'fields.CPU\*'
* objects: Move 'arch' to 'fields.Architecture'
* Show team and repo badges on README
* Remove config option snapshot\_name\_template
* Remove deprecated compute\_available\_monitors option
* Improve help text for interval\_opts
* config options: improve libvirt remotefs
* Improve consistency in libvirt
* Fix root\_device\_name for Xen
* Move tag schema to parameter\_types.py
* Remove tests from tests-py3.txt
* hardware: Flatten functions
* add host to vif.py set\_config\_\* functions
* linux\_net: allow for creation of multiqueue taps
* Fix notification doc generator
* Config options: improve libvirt help text (2)
* Placement api: Add informative message to 404 response
* Remove sata bus for virtuozzo hypervisor
* Fix a typo in nova/api/openstack/compute/volumes.py
* Fix race in test\_volume\_swap\_server\_with\_error
* libvirt: Call host connection callbacks asynchronously
* conf: remove deprecated cert\_topic option
* Return build\_requests instead of instances
* conf: remove deprecated exception option
* doc: Add guidline about notification payload
* Port libvirt test\_imagecache to Python 3
* Port test\_serversV21 to Python 3
* encryptors: Introduce encryption provider constants
* Add TODO for returning a 202 from the volume attach API
* Fix typo in image\_meta.py & checks.py & flavor.py
* Refactor two nearly useless secgroup tests
* Transform instance.finish\_resize notifications
* Remove redundant VersionedObject Fields
* Transform instance.create.error notification
* Transform instance.create notification
* api-ref: add missing os-server-groups parameters
* libvirt: prepare domain XML update for serial ports
* [placement] increase gabbi coverage of handlers.resource\_provider
* [placement] increase gabbi coverage of handlers.inventory
* [placement] increase gabbi coverage of handlers.allocation
* libvirt: do not return serial address if disabled on destination
* Remove mox from api/openstack/compute/test\_fping.py
* Add index on instances table across project\_id and updated\_at
* Complete verification for os-floating-ips
* libvirt: handle os-brick InvalidConnectorProtocol on init
* placement: adds ResourceClass.get\_by\_name()
* placement: adds ResourceClass.create()
* Improve help text for libvirt options
* Use byte string or utf8 depending on python version for wsgi
* Separate CRUD policy for server\_groups
* Stop using mox stubs in nova/tests/unit/virt/disk
* Remove the description of compute\_api\_class option
* Remove mox in virt/xenapi/image/test\_bittorrent.py
* Add context param to confirm\_migration virt call
* Use pick\_context\_manager throughout DB APIs
* Database poison note
* tests: verify cpu pinning with prefer policy
* api-ref: Body verification for os-simple-tenant-usage.inc
* remove additional param
* Fix typo for 'infomation'
* Remove unused code in nova/api/openstack/wsgi.py
* conf: remove deprecated cells driver option
* Fix detach\_interface() call from external event handler
* Implement get and set aggregates in the placement API
* Add {get\_,set\_}aggregates to objects.ResourceProvider
* Log a warning when starting nova-net in non-cellsv1 deployments
* Revert "Make n-net refuse to start unless using CellsV1"
* HyperV: use os-brick for volume related operations
* INFO level logging should be useful in resource tracker
* hyper-v: wait for neutron vif plug events
* Remove mox in nova/tests/unit/api/openstack/compute (1)
* Use available port binding constants
* Rename PCS to Virtuozzo in error message
* [PY3] byte/string conversions and enable PY3 test
* Fix mock arg list order in test\_driver.py
* Add handle for 2 exceptions in force\_delete
* Typo error about help    libvirt.py
* Updated from global requirements
* Introduce PowerVMLiveMigrateData
* Make n-net refuse to start unless using CellsV1
* Store security groups in RequestSpec
* api-ref: body verification for abort live migration
* Fix data error in api samples doc

15.0.0.0b1
----------

* Typo error servers.py
* Typo error allocations.yaml
* Refactor console checks in live migration process
* Remove mox in tests/unit/objects/test\_pci\_device
* Add microversion cap information
* No return for flavor destroy
* neutron: actually populate list in populate\_security\_groups
* Clarify the approval process of specless blueprints
* Add uuid field to SecurityGroup object
* api-ref: body verification for force\_complete server migration
* api-ref: body verification for show server migration
* api-ref: body verification for list server migrations
* api-ref: example verification for server-migrations
* api-ref: parameter verification for server-migrations
* api-ref: method verification for server-migrations
* [placement] Enforce min\_unit, max\_unit and step\_size
* Remove ceph install/config functions from l-m hook
* Ceph bits for live-migration job
* Avoid unnecessary db\_calls in objects.Instance.\_from\_db\_object()
* placement: genericize on resource providers
* api-ref: fix server\_id in metadata docs
* Add the initial documentation for the placement API
* API Ref: update server\_id params
* conf: fix formatting in wsgi
* Transform requested secgroup names to uuids
* conf: fix formatting in availability\_zone
* libvirt: Cleanup spawn tests
* Rename security\_group parameter in compute.API:create
* Change database poison warning to an exception
* Fix database poison warnings, part 25
* Updated from global requirements
* Correct wrong max\_unit in placement inventory
* Add flavor extra\_spec info link to api\_ref
* Fix database poison warnings in resource providers
* Placement api: 404 response do not indicate what was not found
* Instance obj\_clone leaves metadata as changed
* Add a no-op wait method to NetworkInfo
* Move driver\_dict\_from\_config to libvirt driver
* Create schema generation for AddressBase
* conf: Improve help text for ldap\_dns\_opts
* conf: Fix indentation of network
* Fix config option types
* libvirt: Fix incorrect libvirt library patching in tests
* libvirt: refactor console device creation methods
* libvirt: read rotated "console.log" files
* libvirt: change get\_console\_output as prep work for bp/libvirt-virtlogd
* Updated from global requirements
* api-ref: Fix a 'port' parameter in os-consoles.inc
* Update nova api.auth tests to work with newer oslo.context
* Remove ironic instance resize from support matrix doc
* [placement] add a placement\_aggregates table to api\_db
* libvirt: remove py26 compat code in "get\_console\_output"
* Change RPC post\_live\_migration\_at\_destination from cast to call
* libvirt: add migration flag VIR\_MIGRATE\_PERSIST\_DEST
* Revert MTU hacks for bug 1623876
* Pass MTU into os-vif Network object
* Updated from global requirements
* api-ref: fix addFloatingIp action docs
* Fix a TypeError in notification\_sample\_base.py
* Add functional api\_samples test for addFloatingIp action
* Fix qemu-img convert image incompatability in alpine linux
* migration.source\_compute should be unchanged after finish\_revert\_resize
* Add explicit dependency on testscenarios
* Updated from global requirements
* cors: update default configuration in config
* api-ref: remove user\_id from keypair list response and fix 2.10
* Don't parse PCI whitelist every time neutron ports are created
* conf: Remove deprecated 'compute\_stats\_class' opt
* conf: Remove extraneous whitespace
* hardware: Split '\_add\_cpu\_pinning\_constraint'
* libvirt: Delete the lase\_device of find\_disk\_dev\_for\_disk\_bus
* EventReporterStub
* Catch all local/catch-all addresses for IPv6
* placement: add ResourceClass and ResourceClassList
* placement: raise exc when resource class not found
* fix connection context manager in rc cache
* pci: remove pci device from claims and allocations when freeing it
* PCI: Fix PCI with fully qualified address
* Log warning when user set improper config option value
* libvirt: fix incorrect host cpus giving to emulator threads when RT
* Transform instance.shutdown notifications
* encryptors: Workaround mangled passphrases
* Fix cold migration with qcow2 ephemeral disks
* Updated from global requirements
* config options: Improve help for SPICE
* Remove manual handling of old context variables
* api-ref: cleanup bdm.delete\_on\_termination field
* api-ref: document the power\_state enum values
* libvirt: Pass Host instead of Driver to volume drivers
* conf: Attempt to resolve TODOs in scheduler.py
* conf: Remove 'scheduler\_json\_config\_location'
* Remove unreachable code
* [api-ref] Fix path parameter console\_id
* doc: add a note about conditional support for xenserver change password
* Replace admin check with policy check in placement API
* Fix import statement order
* Fix database poison warnings, part 24
* libvirt: sync time on resumed from suspend instances
* Fix database poison warnings, part 23
* Add RPC version aliases for Newton
* Transform instance.unpause notifications
* Catch NUMA related exceptions in create server API method
* Notification object version test depends on SCHEMA
* Updated from global requirements
* Virt: add context to attach and detach interface
* Imported Translations from Zanata
* Stop using mox stubs in test\_shelve.py
* Fix SAWarning in TestResourceProvider
* Transform instance.unshelve notifications
* TrivialFix: Fixed typo in 'MemoryPageSizeInvalid' exception name in docstrings
* Make build\_requests.instance MediumText
* Use six.wraps
* Transform instance.resume notifications
* Transform instance.shelve\_offload notifications
* api-ref: fix image GET response example
* Fix exception raised in exception wrapper
* Add missing compat routine for Usage object
* Updated from global requirements
* Transform instance.power\_off notifications
* conf: Removed TODO note and updated desc
* Set 'last\_checked' flag if start to check scheduler file
* Remove bandit.yaml in favor of defaults
* Pre-add instance actions to avoid merge conflicts
* Add swap volume notifications (error)
* libvirt: add supported vif types for virtuozzo virt\_type
* fix testcase test\_check\_can\_live\_migrate\_dest\_fills\_listen\_addrs
* doc: Integrate oslo\_policy.sphinxpolicygen
* Using get() method to prevent KeyError
* tests: verify pci passthrough with numa
* tests: Adding functional tests to cover VM creation with sriov
* [placement] Add support for a version\_handler decorator
* pci: in free\_device(), compare by device id and not reference
* Mention API V2 should no longer be used
* doc: Update libvirt-numa guide
* Remove deprecated nova-manage vm list command
* Remove block\_migration from LM rollback
* PCI: Avoid looping over PCI devices twice
* Update docs for serial console support
* Remove conductor local api:s and 'use\_local' config option
* Cleanup before removal of conductor local apis
* compute: fixes python 3 related unit tests
* XenAPI: Fix VM live-migrate with iSCSI SR volume
* Fix the scope of cm in ServersTestV219
* Explicitly name commands target environments
* \_run\_pending\_deletes does not need info\_cache/security\_groups
* Updated from global requirements
* hardware: Standarized flavor/image meta extraction
* Tests: improve assertJsonEqual diagnostic message
* api-ref: Fix wrong parameters in os-volumes.inc
* Remove mox from unit/virt/libvirt/test\_imagebackend.py (1)
* Send events to all relevant hosts if migrating
* Catch error and log warning when not able to update mtimes
* Clarify what changed with scheduler\_host\_manager
* Add related options to floating ip config options
* Correct bug in microversion headers in placement
* Ironic Driver: override get\_serial\_console()
* Updated from global requirements
* Drop deprecated support for hw\_watchdog\_action flavor extra spec
* Remove watchdog\_actions module
* Removal of tests with different result depending on testing env
* Add debug to tox environment
* Document experimental pipeline in Nova CI
* Update rolling upgrade steps from upgrades documentation
* Add migrate\_uri for invoking the migration
* Fix bug in "nova/tests/unit/virt/test\_virt\_drivers.py" for os-vif
* Remove redundant req setting
* Changed the name of the standard resource classes
* placement: change resource class to a StringField
* Remove nova/openstack/\* from .coveragerc
* Remove deprecated nova-all binary
* Fix issue with not removing rbd rescue disk
* Require WebOb>=1.6.0
* conf: Remove deprecated \`\`use\_glance\_v1\`\`
* Adding hugepage and NUMA support check for aarch64
* hacking: Use assertIs(Not), assert(True|False)
* Use more specific asserts in tests
* Add quota related tables to the api database
* doc: add dev policy about no new metrics monitors
* Always use python2.7 for functional tests
* doc: note the future of out of tree support
* docs: update the Public Contractual API link
* Remove \_set\_up\_controller() from attach tests
* Add InvalidInput handling for attach-volume
* placement: add cache for resource classes
* placement: add new resource\_classes table
* hardware: Rework docstrings
* doc: Comment on latin1 vs utf8 charsets
* Improve help text for libvirt options
* block\_device: Make refresh\_conn\_infos py3 compatible
* Add swap volume notifications (start, end)
* Add a hacking rule for string interpolation at logging
* Stop using mox stubs in test\_snapshots.py
* Stop using mox from compute/test\_multiple\_create.py
* Don't attempt to escalate nova-manage privileges
* Improve help text for upgrade\_levels options
* Remove dead link from notification devref
* Stop using mox stubs in test\_evacuate.py
* Tests: fix a typo
* ENOENT error on '/dev/log'
* Patch mkisofs calls
* conf: Group scheduler options
* conf: Move consoleauth options to a group
* Fix exception due to BDM race in get\_available\_resource()
* Delete traces of in-progress snapshot on VM being deleted
* Add error handling for delete-volume API
* Catch DevicePathInUse in attach\_volume
* Enable release notes translation
* Fix drop\_move\_claim() on revert resize
* Updated from global requirements
* Fix API doc for os-console-auth-tokens
* tests: avoid creation of instances dir in the working directory
* config options: improve libvirt imagebackend
* libvirt: fix DiskSmallerThanImage when block migrate ephemerals
* Remove unnecessary credential sanitation for logging
* Replace uuid4() with uuidsentinel
* Change log level to debug for migrations pairing
* Remove the duplicated test function
* Move get\_instance() calls from try-except block
* Allow running db archiving continuously
* Add some extra logging around external event handling
* Fix a typo in driver.py
* Avoid Forcing the Translation of Translatable Variables
* Fix database poison warnings, part 21
* libvirt: Fix BlockDevice.wait\_for\_job when qemu reports no job
* Stop using mox from compute/test\_used\_limits.py
* Updated from global requirements
* Remove mox from tests/unit/conductor/tasks/test\_live\_migrate.py(3)
* Remove mox from tests/unit/conductor/tasks/test\_live\_migrate.py(2)
* Remove mox from tests/unit/conductor/tasks/test\_live\_migrate.py(1)
* Fix calling super function in setUp method
* refresh instances\_path when shared storage used
* Prevent us from sleeping during DB retry tests
* Fix error status code on update-volume API
* conf: Trivial cleanup of console.py
* conf: Trivial cleanup of compute.py
* conf: Trivial cleanup of 'cells'
* conf: Deprecate all topic options
* Updated from global requirements
* Disable 'supports\_migrate\_to\_same\_host' HyperV driver capability
* Fix periodic-nova-py{27,35}-with-oslo-master
* Report actual request\_spec when MaxRetriesExceeded raised
* Make db archival return a meaningful result code
* Remove the sample policy file
* libvirt/guest.py: Update docstrings of block device methods
* Fix small RST markup errors
* [Trivial] changes tiny RST markup error
* Add get\_context helper method
* Use gabbi inner\_fixtures for better error capture
* Hyper-V: Fixes os\_type image property requirement
* conf: Cleanup of glance.py
* conf: Move PCI options to a PCI group
* Add Apache 2.0 license to source file
* Updated from global requirements
* Make releasenotes reminder detect added and untracked notes
* [placement] reorder middleware to correct logging context
* Fixes RST markup error to create a code-box
* libvirt: support user password settings in virtuozzo
* Removing duplicates from columns\_to\_join list
* Ignore BuildRequest during an instance reschedule
* Remove stale pyc files when running the cover job
* Add a post-test-hook to run the archive command
* [placement] ensure that allow headers are native strings
* Fix a few typos in API reference
* Fix typo on api-ref parameters
* Fix typo in comment
* Remove mox in nova/tests/unit/compute/test\_shelve.py (1)
* Let schema validate image metadata type and key lengths
* Remove scheduled\_at attribute from instances table
* Fix database poison warnings, part 22
* Archive instance-related rows when the parent instance is deleted
* Unwind circular import issue with api / utils
* Fix database poison warnings, part 18
* Remove context object in oslo.log method
* libvirt: pick future min libvirt/qemu versions
* Improve consistency in serial\_console
* conf: Improve consistency in scheduler opts
* Move notification\_format and delete rpc.py
* config options: improve libvirt smbfs
* Fix database poison warnings, part 17
* Updated from global requirements
* Fix database poison warnings, part 16
* Hyper-V: Adds Hyper-V UEFI Secure Boot
* Stop overwriting thread local context in ClientRouter
* Cleanup some redundant USES\_DB\_SELF usage
* Fix database poison warnings, part 20
* Fix database poison warnings, part 19
* use proper context in libvirt driver unit test
* Renamed parameters name in config.py
* [placement] Allow both /placement and /placement/ to work
* numa: Fixes NUMA topology related unit tests
* VMware: Do not check if folder already exists in vCenter
* libvirt: fixes python 3 related unit tests
* Clean up stdout/stderr leakage in cmd testing
* Capture stdout in for test\_wsgi:test\_debug
* Add destroy method to the RequestSpec object
* Remove last sentence
* VMware: Enforce minimum vCenter version of 5.5
* test:Remove unused method \_test\_get\_test\_network\_info
* Determine disk\_format for volume-backed snapshot from schema
* Fix database poison warnings, part 15
* Fix CONTAINER\_FORMATS\_ALL to have ova insteadk of vmdk
* Config options consistency of ephemeral\_storage.py
* docs: Clarify sections & note on filter scheduler
* Fixes python 3 unit tests
* Add Hyper-V storage QoS support
* Add blocker migration to ensure for newton online migrations
* hacking: Always use 'assertIs(Not)None'
* Hyper-V: fix image handling when shared storage is being used
* Annotate online db migrations with cycle added
* properly capture logging during db functional tests
* [placement] 404 responses do not cause exception logs
* Fix pep8 E501 line too long
* Remove unused code
* Replace uuid4() with generate\_uuid() from oslo\_utils
* Return instance of Guest from method write\_instance\_config
* Mock.side\_effects does not exist, use Mock.side\_effect instead
* Remove redundant str typecasting
* VMware: deprecate wsdl\_location conf option
* Remove nova.image.s3 and configs
* Remove internal\_id attribute from instances table
* Fix stdout leakage during opportunistic db tests
* Updated from global requirements
* Improve help text for glance options
* libvirt: ignore conflict when defining network filters
* Add placeholder DB migrations for Ocata
* Remove PCI parent\_addr online migration
* Make nova-manage online migrations more verbose
* Fix check\_config\_option\_in\_central\_place
* Skip malformed cookies
* Fix database poison warnings, part 14
* Standardize output capture for nova-manage tests
* Work around tests that don't use nova.test as a base
* Don't print to stdout when executing hacking checks
* Make test logging setup fixture disable future setup
* Fix typo in docsting in test\_migrations.py
* Remove support for deprecated driver import
* conf: Add 'deprecated\_reason' to osapi opts
* Add hacking checks for xrange()
* Using assertIsNone() instead of assertEqual(None)
* move os\_vif.initialize() to nova-compute start
* Add deprecated\_since parameter
* [placement] Manage log and other output in gabbi fixure
* Reduce duplication and complexity in format\_dom
* Fix invalid exception mock for InvalidNUMANodesNumber
* libvirt: fix serial console not correctly defined after live-migration
* Add more description when service delete
* trivial: Rewrap guide at 79 characters
* plugins/xenserver: Add '.py' extension
* conf: Fix opt indentation for scheduler.py
* conf: Reorder scheduler opts
* Updated from global requirements
* Revert "Set 'serial' to new volume ID in swap volumes"
* [placement] Adjust the name of the gabbi tests
* placement: refactor instance translate function
* Move wsgi-intercept to test-requirements.txt
* Add missing slash to dir path
* Expand feature classification matrix with gate checks
* [placement] Stringify class and provider uuid in error
* [api-ref] Correct parameter type
* Remove default=None for config options
* libvirt: cleanup never used migratable flag checking
* Remove unnecessary setUp and tearDown
* Remove unused parameters
* Remove duplicate key from dictionary
* Updated from global requirements
* placement: refactor translate from node to dict
* stub out instances\_path in unit tests
* Add a new release note
* XenAPI: add unit test for plugin test\_pluginlib\_nova.py
* Add link ref to nova api concept doc
* libvirt: Use the recreated disk.config.rescue during a rescue
* Add members in InstanceGroup object members field
* Updates URL and removes trailing characters
* Stop ovn networking failing on mtu
* Update reno for stable/newton
* Don't pass argument sqlite\_db in method set\_defaults

14.0.0.0rc1
-----------

* Override MTU for os\_vif attachments
* Fix object assumption in remove\_deleted\_instances()
* Add is\_cell0 helper method
* Set a bigger TIMEOUT\_SCALING\_FACTOR value for migration tests
* Update minimum requirement for netaddr
* [placement] consolidate json handling in util module
* Fix unnecessary string interpolation
* Handle TypeError when disabling host service
* Fix an error in archiving 'migrations' table
* Remove deprecated flag in neutron.py
* Clean up allocation when update available resources
* [placement] Mark HTTP error responses for translation
* [placement] prevent a KeyError in webob.dec.wsgify
* Body Verification of api-ref os-volume-attachments.inc
* Add functional regression test for bug 1595962
* Use tempest tox with regex first
* libvirt: add ps2mouse in choice for pointer\_model
* Doc fix for Nova API Guide, added missing word
* conf: Make list->dict conversion more specific
* Revert "tox: Don't create '.pyc' files"
* Improve help text for xenapi\_session\_opts
* Improve help text for service options
* Correct image.inc for heading
* Complete verification for os-cloudpipe.inc
* Use assertEqual() instead of assertDictEqual()
* Fix typo of stevedore
* [placement] functional test for report client
* Add regression test for immediate server name update
* Fixed suspend for PCI passthrough
* libvirt: Rewrite test\_rescue and test\_rescue\_config\_drive
* Guard against failed cache refresh during inventory
* More conservative allocation updates
* [placement] Correct serialization of inventory collections
* Switching expression order within if condition
* Correct sort\_key and sort\_dir parameter for flavor
* Correct address, version parameter in ips.inc
* Use to\_policy\_values for policy credentials
* Doc fix for Nova API Guide, fixed wording
* Nova shelve creates duplicated images in cells
* More conservative inventory updates
* Fix server group name on api-ref
* Update BuildRequest if instance currently being scheduled
* Fix reno for removal of nova-manage service command
* Add note about display\_name in \_populate\_instance\_names
* Extended description for sync\_power\_state\_pool\_size option
* Use recursive obj\_reset\_changes in BuildRequest
* HyperV: ensure config drives are copied as well during resizes
* [placement] make PUT inventory consistent with GET
* Fill destination check data with VNC/SPICE listen addresses
* Revert "libvirt: move graphic/serial consoles check to pre\_live\_migration"
* Fix MonitorMetric obj\_make\_compatible
* Using assertIsNotNone() instead of assertIsNot(None,)
* [api-ref] fix availability\_zone for server create
* Fix SafeConfigParser DeprecationWarning in Python 3.2
* Set 'serial' to new volume ID in swap volumes
* Fix policy tests for project\_id enforcement
* neutron: don't trace on port not found when unbinding ports
* Remove RateLimitFault class
* Rate limit is removed , update doc accordingly
* Fix a typo from ID to Id
* context: change the name 'rule' to 'action' in context.can
* Add description for v2.20 changes in api-ref
* Add sync\_power\_state\_pool\_size option
* Additional logging for placement API
* Fix resizing in imagebackend.cache()
* [placement] cleanup some incorrect comments
* Updated from global requirements
* Compute: ensure that InvalidDiskFormat is handled correctly
* Add keypairs\_links into resp
* Add hypervisor\_links into hypervisor v2.33
* Throw exception if numa\_nodes is not set to integer greater than 0
* Add reserved param for v2.4
* Add more description on v2.9 history
* libvirt: inject files when config drive is not requested
* Pin maximum API version of microversion
* XenAPI: resolve the fetch\_bandwidth failure
* Fix api-ref doc for server-rebuild
* [api-ref] Update configuration file
* fix broken link in api-ref
* Trivial fix remove not used var in parameters
* Trival fix a typo
* Increase BDM column in build\_requests table
* VMware: Refactor the image transfer
* Pass GENERATE\_HASHES to the tox test environment
* [placement] add two ways to GET allocations
* Handle ObjectActionError during cells instance delete
* [placement] Add some tests ensuring unicode resource provider info
* cleanup: separate the creation of a local root to it's own method
* standardize release note page ordering
* Remove misleading warning message
* Add deprecated\_reason for use\_usb\_tablet option
* db: retry on deadlocks while adding an instance
* virt: handle unicode when logging LifecycleEvents
* Ensure ResourceProvider/Inventory created before add Allocations record
* Libvirt: Correct PERF\_EVENTS\_CPU\_FLAG\_MAPPING
* Enable py3 tests for unit.api.openstack.compute.test\_console\_output
* Implement setup\_networks\_on\_host for Neutron networks
* Add tests for safe\_connect decorator
* libvirt: improve logging for shared storage check
* Cleanup allocation todo items
* [placement] Allow inventory to violate allocations
* Refresh info\_cache after deleting floating IP
* Remove deprecated configuration option network\_device\_mtu
* Example & Parameter verification of os-security-group-default-rules.inc
* [placement] clean up some nits in the requestlog middleware
* correctly join the usage to inventory for capacity accounting
* Annotate db models that have moved to the nova\_api db
* Stop using mox in virt/libvirt/test\_imagecache.py
* Stop using mox in unit/fake\_processutils.py
* [api-ref]: Correcting server\_groups\_list parameter's type
* Fix race condition bug during live\_snapshot
* ironic: Rename private methods for instance info
* [placement] Fix misleading comment in wsgi loader
* Remove mox from api/openstack/compute/test\_networks.py
* Remove mox from api/openstack/compute/test\_rescue.py
* Remove mox from api/openstack/compute/test\_image\_size.py
* Remove mox from api/openstack/compute/test\_extended\_ips.py
* Remove mox from nova/tests/unit/virt/xenapi/test\_driver.py
* Remove mox from unit/api/openstack/compute/test\_hide\_server\_addresses.py
* fixing block\_device\_mapping\_v2 data\_type
* Updated from global requirements
* Add bigswitch command to compute rootwrap filters
* libvirt: add hugepages support for Power
* incorrect description in nova-api.log about quota check
* Removed enum duplication from nova.compute
* Remove unused conf

14.0.0.0b3
----------

* Remove deprecated cinder options
* Simple instance allocations from resource tracker
* Add support for allocations in placement API
* Add create\_all and delete\_all for AllocationList
* Pull from cell0 and build\_requests for instance list
* Remove hacked test that fails with latest os-brick
* Report compute node inventories through placement
* Delete BuildRequest regardless of service\_version
* Fix service version lookups
* Remove BuildRequest when scheduling fails
* Run cell0 db migrations during nova-manage simple\_cell\_setup
* Move cell message queue switching and add caching
* Add basic logging to placement api
* Fixed indentation
* Update placement config reno
* Ignore generated merged policy files
* Register keystone opts for placement sample config
* Remove deprecated neutron options
* ironic\_host\_manager: fix population of instances info on start
* Eliminate additional DB queries in nova lists
* Remove the incomplete wsgi script placement-api.py
* ironic\_host\_manager: fix population of instances info on schedule
* rt: ensure resource provider records exist from RT
* Allow linear packing of cores
* Return 400 error for non-existing snapshot\_id
* create placement API wsgi entry point
* Fix qemu version check
* Documentation for the vendordata reboot
* Add more vd2 unit tests
* Add a TODO and add info to a releasenote
* [placement] remove a comment that is no longer a todo
* Make api-ref bug link point to nova
* Api-ref: Improve os-migrateLive input parameters
* Fix a typo in the driver.py file
* New discover command to add new hosts to a cell
* Clean up instance mappings, build requests on quota failure
* Not allow overcommit ratios to be negative
* Updated from global requirements
* Use StableObjectJsonFixture from o.vo
* test\_keypairs\_list\_for\_different\_users for v2.10
* Fix using filter() to meet python2,3
* Emit warning when use 'user\_id' in policy rule
* Adds nova-policy-check cmd
* Reduce code complexity - api.py
* Use cls in class method instead of self \_delete\_domain is a class method, so cls should be used instead of self
* Revert "Optional separate database for placement API"
* Changed exception catching order
* Add BuildRequestList object
* In InventoryList.find() raise NotFound if invalid resource class
* Updated from global requirements
* Imported Translations from Zanata
* TrivialFix: Remove cfg import unused
* Add oslopolicy script runs to the docs tox target
* Add entry\_point for oslo policy scripts
* Tests: use fakes.HTTPRequest in compute tests
* Remove conversion from dict to object from xenapi live\_migration
* Hyper-V: properly handle shared storage during migrations
* TrivialFix: Remove logging import unused
* Hyper-V: properly handle UNC instance paths
* Get ready for os-api-ref sphinx theme change
* Update link in general purpose feature matrix
* List system dependencies for running common tests
* [api-ref]: Update link reference
* Abort on HostNotCompatibleWithFixedIpsClient
* Add warning if metadata\_proxy\_shared\_secret is not configured
* devspec: remove unused dev\_count in devspec
* TrivialFix: removed useless storing of sample directory
* [api-guide]: Update reference links
* Fix link reference in Nova API version
* Provide more duplicate VLAN network error info
* Correct microversions URL in api\_plugins.rst
* Create Instance from BuildRequest if not in a cell
* Added todo for deletion LiveMigrateData.detect\_implementation usage
* driver.pre\_live\_migration migrate\_data is always an object
* Manage db sync command for cell0
* Updated common create server sample request because of microversion 2.37
* Remove TODO for service version caching
* removed db\_exc.DBDuplicateEntry in bw\_usage\_update
* Add online migration to move instance groups to API database
* Remove locals() for formatting strings
* Hyper-V: update live migrate data object
* Config options consistency of notifications.py
* Add networks to quota's update json-schema when network quota enabled
* rt: isolate report and query sched client tests
* rt: remove ComputeNode.create\_inventory
* rt: rename test\_tracker -> test\_resource\_tracker
* rt: remove old test\_resource\_tracker.py
* Updated from global requirements
* Remove deprecated security\_group\_api config option
* Added min\_version field to 'host\_status' in 'api-ref'
* Make InstanceGroup object favor the API database
* Doc: Update PCI configuration options
* Don't maintain user\_id and project\_id in context
* Add support for usages in the placement API
* Add a Usage and UsageList object
* Add support for inventories to placement API
* Check capacity and allocations when changing Inventory
* Add release note to warn about os-brick lock dir
* config options: improve help netconf
* Config options consistency for consoleauth.py
* Support Identity v3 when connecting to Ironic
* Copy edit feature classification
* don't report network limits after 2.35
* Adding details in general purpose feature matrix [1]
* Improve placement API 404 and 405 response tests
* doc: fix disk=0 use case in flavor doc
* Config options: improve libvirt help text (1)
* Dump json for nova.network.model.Model objects
* Improve error message for empty cached\_nwinfo
* Return HTTP 400 on list for invalid status
* Move some flavor fakes closer to where they are being used
* Replace flavors.get\_all\_flavors\_sorted\_list() with object call
* Refactor and objectify flavor fakes used in api tests
* Fix 'No data to report' error
* Change api-site to v2.1 format
* Refuse to run simple\_cell\_setup on CellsV1
* In placement API send microversion header when error
* libvirt: Improve mocking of imagebackend disks
* Updated flags for XVP config options
* Add unit tests for nova.virt.firewall.IpTablesFirewallDriver (Part 4)
* [libvirt] Remove live\_migration\_flag & block\_migration\_flag
* placement: add filtering by attrs to resource\_providers
* Add support for resource\_providers urls
* Remove nova/api/validator.py
* Updated from global requirements
* Change default value of live\_migration\_tunnelled to False
* Remove code duplication in enums
* [vncproxy] log for closing web is misleading
* Return None in get\_instance\_id\_by\_floating\_address
* Make simple\_cell\_setup work when multiple nodes are present
* Add REST API support for get me a network
* plugins/xenserver: Resolve PEP8 issues
* Fix migration list + MigrationList operation
* rt: Create multiple resize claim unit test
* rt: Refactor unit test for trackable migrations
* VIF: add in missing translation
* Clean imports in code
* Fix neutron security group tests for 5.1.0 neutronclient
* modify description of "Inject guest networking config"
* os-vif: do not set Route.interface if None
* Check opt consistency for neutron.py
* Improve help text for compute manager options
* Make simple\_cell\_setup idempotent
* Add cell\_v2 verify\_instance command
* Remove unnecessary debug logs of normal API ops
* Replace mox with mock in test\_validate\_bdm
* Replace mox with mock in test\_cinder
* Allow Nova Quotas to be Disabled
* Allow authorization by user\_id for server evacuate
* Allow authorization by user\_id for server update
* Allow authorization by user\_id for server delete
* Allow authorization by user\_id for server changePassword action
* Update binding:profile for SR-IOV ports on resize-revert
* Verified deprecation status for vnc options
* Add tests for user\_id policy enforcement on trigger\_crash\_dump
* Allow authorization by user\_id for server shelve action
* Allow authorization by user\_id for force\_delete server
* Allow authorization by user\_id for server resize action
* Allow authorization by user\_id for server pause action
* Add tests for user\_id policy enforcement on stop
* Fix consistency in crypto conf
* Add placement API web utility methods
* Improve help text for XenServer Options
* Improve help text for xenapi\_vm\_utils\_opts
* network: fix handling of linux-bridge in os-vif conversion
* Fix consistency in API conf
* Improve consistency in WSGI opts
* Add unit tests for nova.virt.firewall.IpTablesFirewallDriver (Part 3)
* Improve help text for xenapi\_opts
* Maintain backwards compat for listen opts
* Allow authorization by user\_id for server rescue action
* Allow authorization by user\_id for server rebuild
* Allow authorization by user\_id for server suspend action
* Allow authorization by user\_id for server lock action
* Optional separate database for placement API
* Replace fake\_utils by using Fixture
* virt/image: between two words without a space in output message
* config options: improve help text of database (related) options (2/2)
* config options: improve help text of database (related) options (1/2)
* Remove hacking check [N347] for config options
* Skipping test\_volume\_backed\_live\_migration for live\_migration job
* rt: New unit test for rebuild\_claim()
* List instances for secgroup without joining on rules
* Improve help text for vmwareapi\_opts
* Updated from global requirements
* vnc host options need to support hostnames
* Removed flag "check\_opt\_group\_and\_type" from pci.py
* Removed flag "check\_opt\_group\_and\_type"
* libvirt: convert over to use os-vif for Linux Bridge & OVS
* Remove left over conf placeholders
* libvirt: Rename import of nova.virt.disk.api in driver
* Fix server operations' policies to admin only
* Add support for vd2 user context to other drivers
* api-ref: Example verification for os-simple-tenant-usage.inc
* Remove unused exception: ImageNotFoundEC2
* Fix opt description for s3.py
* virt/hardware: Check for threads when "required"
* Improve consistency in VNC opts
* Improve help text for compute\_opts
* Config options: Improve help text for console options
* Config options: Consistency check for remote\_debug options
* docs: update code-review guide for config options
* Add separate create/delete policies to attach\_interface
* Fix handling of status in placement API json\_error\_formatter
* Use constraints for all tox environments
* Move JSON linting to pep8
* HyperV: remove instance snapshot lock
* rt: Move monitor unit tests into test\_tracker
* rt: Move unit tests for update usage for instance
* rt: Move unit tests for update mig usage
* rt: Remove useless unit test in resource tracker
* rt: Remove dup tests in test\_resource\_tracker
* rt: Remove incorrect unit test of resize revert
* rt: Refactor test\_dupe\_filter unit test
* rt: Remove duplicate unit test for missing mig ctx
* rt: Refactor resize claim abort unit test
* rt: Refactor resize\_claim unit test
* Set enforce\_type=True in method flags
* Use constraints for releasenotes
* Add some logging and a comment for shelve/unshelve operations
* Run shelve/shelve\_offload\_instance in a semaphore
* Check opt consistency for api.py
* Allow empty CPU info of hypervisors in API response
* Config options consistency of rdp.py
* Improve consistency in workarounds opts
* Refresh README and its docs links
* Correct InventoryList model references
* instance.name should be blank if instance.id is not set
* Cells: Handle delete with BuildRequest
* Add NoopConductorFixture
* Make notification objects use flavor capacity attributes
* Fix busted release notes
* config options: Improve help for conductor
* Config options: base path configuration
* PCI: Fix network calls order on finish\_revert\_resize()
* Remove deprecated legacy\_api config options
* Config Options: Improve help text for Ipv6 options
* Update tags for Image file url from filesystems config option
* Check options consistency in hyperv.py
* Improve help text for floating ips options
* config options: Improve help for base
* Improve consistency in API
* cleanup: some update xml cases in test\_migration
* Use stashed volume connector in \_local\_cleanup\_bdm\_volumes
* Ironic: allow multiple compute services
* api-ref: Parameter verification for os-simple-tenant-usage.inc
* Ironic: report node.resource\_class
* network: introduce helper APIs for dealing with os-vif objects
* ironic: Cleanup instance information when spawn fails
* update wording around pep8 exceptions
* Remove backward compatibility with pre-grizzly releases
* use the HostPortGroupSpec.vswitchName instead of HostPortGroup.vswitch.split
* Replace functions 'Dict.get' and 'del' with 'Dict.pop'
* Updated from global requirements
* Strict ImageRef validation to UUID only
* Add the ability to configure glanceclient debug logging
* Deprecate cert option
* Merged barbican and key\_manager conf files into one
* Config options consistency of pci.py
* config option: rename libvirt iscsi\_use\_multipath
* Fix require thread policy for multi-NUMA computes
* Allocate PCI devices on migration
* TrivialFix: Fixed a typo in nova/test.py
* Updated from global requirements
* Improve help text of image\_file\_url
* Ironic: enable multitenant networking
* libvirt: Remove some unnecessary mocking in test\_driver
* libvirt: Pass object to \_create\_images\_and\_backing in test
* libvirt: Reset can\_fallocate in test setUp()
* libvirt: Create console.log consistently
* Fixed invalid UUIDs in unit tests
* Remove deprecated manager option in cells.py
* Refactor deallocate\_fixed tests to use one mock approach instead of three
* Improve consistency in virt opts
* Updated header flag in SSL opts
* Updated from global requirements
* Don't cache RPC pin when service\_version is 0
* Imported Translations from Zanata
* Remove white space between print and ()
* Flavor: correct confusing error message about flavorRef
* Consistency changes for osapi config options
* Fixed typos in nova: compute, console and conf dir
* Add objects.ServiceList.get\_all\_computes\_by\_hv\_type
* Add InstanceList.get\_uuids\_by\_host() call
* Conf options: updated flags for novnc
* Address feedback on cell-aggregate-api-db patches
* Updated from global requirements
* Add data migration methods for Aggregate
* Config options: Consistency check for quota options
* Add server name verification in instance search
* Fix typo in DeviceDetachFailed exception message
* Straddle python-neutronclient 5.0 for testing
* Initialise oslo.privsep early in main
* Cells: Simple setup/migration command
* Aggregate create and destroy work against API db
* Make Aggregate.save work with the API db
* Improve help text for vmware
* Config options consistency of exceptions.py
* Help text for the mks options
* Trivial option fixes
* Properly quote IPv6 address in RsyncDriver
* rbd\_utils: wrap blocking calls in tpool.Proxy()
* Resolve PCI devices on the host during Guest boot-up
* Fixed typos in nova, nova/api, nova/cells directory
* Fix misspellings
* Trivial: add 'DEPRECATED' for os-certificates API ref
* Mention proxy API deprecation microversion in api-ref
* xenserver: fix an output format error in cleanup\_smp\_locks
* Add log for instance without host field set
* Improve consistency in crypto
* Deprecate barbican options
* Improve consistency in flavors
* Improve the help text for the guestfs options
* Reminder that release notes are built from commits
* Add initial framing of placement API
* Add missing ComputeHostNotFound exception in live-migration
* Free new pci\_devices on revert-resize
* Use oslo\_config new type PortOpt for port options
* Updated from global requirements
* Remove unused imports in api/openstack/fakes.py
* Add docs about microversion testing in Tempest
* Remove leftover list\_opts entry points
* Remove nova.cache\_utils oslo.config.opts entrypoint
* Remove nova.network namespace from nova-config-generator.conf
* Remove neutronv2.api oslo.config.opt entry point
* Follow up on Update binding:profile for SR-IOV ports
* Improve consistency in servicegroup opts
* Improve help text for cloudpipe
* Remove the useless version calculation for proxy api deprecated version
* numa: remove the redundant check for hw\_cpu/hw\_mem list
* Add support for oslo.context 2.6.0
* Update tags for Cache config option
* Remove unused validation code for quota\_sets
* Revert "Don't assert exact to\_dict output"
* cleanup\_live\_migration\_destination\_check spacing
* Default image.size to 0 when extracting v1 image attributes
* Add details to general purpose feature matrix
* Adding functional tests for 2.3 microversion
* compute: Skip driver detach calls for non local instances
* libvirt: Fix invalid test data
* libvirt: Fix fake \_disk\_info data in LibvirtDriverTestCase
* Don't set empty kernel\_id and ramdisk\_id to glance image
* Config options consistency for cell.py
* Refuse to have negative console ttls
* Option Consistency for availability\_zone.py
* Add a small debug line to show selection location
* Fix wrong override value of config option vswitch\_name
* Fix wrong override value of config option proxyclient\_address
* Call release\_dhcp via RPC to ensure correct host
* Adjust MySQL access with eventlet
* Improve consistency in cert
* Updated from global requirements
* rt: don't log pci\_devices twice when updating resources
* Config options consistency for configdrive.py
* Remove deprecated ironic.api\_version config option
* Improve the help text for compute timeout\_opts
* Deprecate the nova-manage commands that rely on nova-network
* Improve consistency in xenserver
* Add the 'min' param to IntOpts where applicable
* Remove unused config option 'fake\_call'
* Make Aggregate metadata functions work with API db
* Use deprecated\_reason for network quota options
* "nova list-extensions" not showing summary for all
* Fix typos in deprecates-proxy-apis release note
* Enable deferred IP on Neutron ports
* Improve help text for XenServer pool opts
* remove config option iqn\_prefix
* Deprecate os-certificates
* Update RequestSpec nested flavor when a resize comes in
* New style vendordata support
* Add metadata server fixture
* Improve help text for quota options
* Improve help text for consoleauth config options
* Bump Microversion to 2.36 for Proxy API deprecation
* api: use 'if else' instead of 'try exception' to get password value
* Add better help to rdp options
* Adding details in general purpose feature matrix
* Enables Py34 tests for unit.api.openstack.compute.test\_server\_actions
* Filter network related limits from limits API
* Filter network related quotas out of quotas API
* Deprecate Baremetal and fping API
* Deprecate volumes related APIs
* Deprecate SecurityGroup related proxy API
* Deprecated floating ip related proxy APIs
* Complete verification of os-instance-actions.inc
* Check opt group and type for nova.conf.service.py
* Fix links to network APIs from api-ref
* Add comment about how status field changed
* Fix database poison warnings, part 13
* Deprecate network quota configuration
* Verify os-aggregates.inc on sample files
* Cleanup: validate option at config read level
* :Add missing %s in print message
* api-ref: unify the no response output in delete operation
* Return 400 when SecurityGroupCannotBeApplied is raised
* network: handle forbidden exception from neutron
* Avoid update resource if compute node not updated
* Document update\_task\_state for ComputeDriver.snapshot
* Config Option consistency for crypto.py
* Fix database poison warnings, part 12
* Don't check cinder volume states during attach
* Clean up test\_check\_attach\_availability\_zone\_differs
* Fix database poison warnings, part 11
* Fix opt description and indentation for flavors.py
* Remove redundant flag value check
* Improve help context of ironic options
* Update instance node on rebuild only when it is recreate
* Remove unneeded bounds-checking code
* Improve the help text for the linuxnet options (4)
* Don't assert exact to\_dict output
* Fix database poison warnings, part 10
* config options: help text for enable\_guestfs\_debug\_opts
* Fix database poison warnings, part 9
* Improve help text of s3 options
* Remove deprecated config option volume\_api\_class
* Fix inappropriate notification send
* libvirt: Fix signature and behaviour of fake get\_disk\_backing\_file
* libvirt: Pass path to Image base class
* Remove max\_size argument to images.fetch and fetch\_to\_raw
* Update tox.ini: Constraints are possible for api\* jobs
* Separate api-ref for list security groups by server
* Deprecate FixedIP related proxy APIs
* Deprecated networks related proxy APIs
* Check option descriptions and indentations for configdriver.py
* Make Aggregate host operations work against API db
* libvirt: open RBD in read-only mode for read-only operations
* Remove unnecessary code added for ec2 deprecation
* Enhance notification doc generation with samples
* Depracate Images Proxy APIs
* Correct the network config option help text
* config options: improve help for noVNC
* Replace deprecated LOG.warn with LOG.warning
* Fixed typos in api-ref and releasenotes directory
* Fix invalid import order and remove import \*
* Improve the help text for the network options (4)
* Add async param to local conductor live\_migrate\_instance
* libvirt: update guest time after suspend
* libvirt: Modify the interface address object assignment
* Update binding:profile for SR-IOV ports
* Port nova test\_serversV21.Base64ValidationTest to Python 3
* Refactor instance action notification sample test
* Config option update tasks for availability\_zone
* Expand initial feature classification lists
* Add prototype feature classification matrix
* [libvirt] Live migration fails when config\_drive\_format=iso9660
* Modify docstring of numa\_get\_reserved\_huge\_pages method
* Use constraints for coverage job
* Remove compute host from all host aggregates when compute service is deleted
* Fix incorrect cellid numbering for NUMA memnode
* Fix opt descripton for cells.py
* Fix host mapping saving
* Example and body verification of os-quota-sets.inc
* Remove deprecated network\_api\_class option
* neutron: destroy VIFs if allocating ports fails
* Validate pci\_passthrough\_whitelist when starting n-cpu
* Rename compute manager \_check\_dev\_name to \_add\_missing\_dev\_names
* Remove unused context argument to \_default\_block\_device\_names()
* Fix typo in AdminPasswordController

14.0.0.0b2
----------

* Use from\_environ when creating a context
* Pass kwargs through to base context
* Fix opt description and check deprecate status for hyperv.py
* VMware: Enable disk.EnableUUID=True in vmx
* hyper-v: device tagging
* Add release notes for notification transformation
* Assert reservation\_id in notification sample test
* Remove redundant DEPRECATED tag from help messages
* Fix PUT server tag 201 to return empty content
* Clean up helper methods in ResourceProvider
* Transform instance.restore notifications
* neutron: delete VIFs when deallocating networking
* Add VirtualInterface.destroy()
* Make notifications module use flavor capacity attributes
* Make ironic driver use flavor fields instead of legacy ones
* Make xenapi driver use flavor fields instead of legacy ones
* Make libvirt driver use flavor fields instead of legacy ones
* Make hyperv driver use flavor fields instead of legacy ones
* Make vmware driver use flavor fields instead of legacy ones
* Bump service version for BuildRequest deletion
* Stop instance build if BuildRequest deleted
* Add block\_device\_mappings to BuildRequest
* Improve help text of flavors config options
* Improve help text for cinder config options
* Microversion 2.35 adds keypairs pagination support
* Fix up legacy resource fields in simple-tenant-usage
* Use flavor attributes instead of deprecated instance resources
* Typo fix: remove multiple whitespace
* network: handle unauthorized exception from neutron
* Fix the broken links
* 'limit' and 'marker' support for db\_api and keypair\_obj
* Improve help text for exceptions
* Improve help text for compute running\_deleted\_opts
* rest api version bumped for async pre live migration checks
* Add user\_id request parameter in os-keypairs list
* Revert "Detach volume after deleting instance with no host"
* Don't overwrite MarkerNotFound error message
* tox: Use conditional targets
* tox: Don't create '.pyc' files
* Improve help text for allocation\_ratio\_opts
* Release note for vzstorage volume driver
* Fix typo in \_update\_usage\_from\_migrations
* Transform instance.resize notifications
* Refactors nova.cmd utils
* Replace DOS line ending with UNIX
* migration volume failed for invalid type
* api-ref: fix wrong description about response example in os-hypervisor
* api-ref: body verification of os-agents
* Fix wrong JSON format in API samples
* Implement ResourceProvider.destroy()
* Add Allocation and AllocationList objects
* Deprecate nova-manage vm list command
* Remove live-migration from nova-manage man page
* Deprecate the quota\_driver config option
* Allow irrelevant,self-defined specs in ComputeCapacityFilter
* Transform instance.pause notifications
* Fix opt description for scheduler.py
* Verify "needs:check\_deprecation\_status" for serial\_console.py
* API: catch InstanceNotReady exception
* Transform instance.shelve notifications
* Replace unicode with six.text\_type
* Added support for new block device format in vmops
* XenAPI: add unit test for plugin bandwidth
* api-ref: unify the delete response infomation
* Add nova-manage quota\_usage\_refresh command
* Quota changes for the nova-manage quota\_usage\_refresh command
* Remove DictCompat from SecurityGroup
* Replace use of eval with ast.literal\_eval
* libvirt: fix missed test in migration
* Improve the help text for the network options (3)
* Correct reraising of exception
* api-ref: Parameter verification for servers-actions.inc Part 1
* Body verification of os-interface.inc
* Parameter verification of os-instance-actions.inc
* xvp: change the default xvp conf path to CONF.xvp group
* libvirt:code flow problem in wait\_for\_job
* Clean up service version history comments
* Add a ResourceProviderList object
* Refactor block\_device\_mapping handling during boot
* Remove spaces around keyword argument
* Use ovo in test\_obj\_make\_compatible()
* Improve the help text for the network options (2)
* Update mutable-config reno with LM timeout params
* Added better error messages during (un)pinning CPUs
* Remove duplicate policy test
* Complete verification for os-virtual-interfaces
* api-ref: os-volumes.inc
* Enable python34 tests for nova.tests.unit.pci.test\_manager and test\_stats
* api-ref: merge multiple create to servers.inc
* Improve the help text for configdrive options
* Revert "Remove manual creation of console.log"
* Fix invalid import order
* Fix invalid import order
* Fix invalid import order
* config options: improve help for notifications
* Fix invalid import order
* Fix invalid import order
* Remove unused itype parameter from get migration context
* Do not try to backport when db has older object version
* Detach volume after deleting instance with no host
* Transform instance.suspend notifications
* Hacking check for \_ENFORCER.enforce()
* Remove final use of \_ENFORCER.enforce
* Hacking check for policy registration
* Extract \_update\_ports\_for\_instance
* Extract port create from allocate\_for\_instance
* Improve help text for resource tracker options
* Transform instance.power\_on notifications
* Add a py35 environment to tox
* api-ref: add note about os-certificates API
* XenAPI: UT: Always mock logging configuration
* Fix api\_validation for Python 3
* api-ref: verify assisted-volume-snapshots.inc
* Delete reduplicate code in test\_compute\_mgr.py
* Port test\_hacking to Python 3
* Fix comment for version 1.15 ComputeNodeList
* Microversion 2.33 adds pagination support for hypervisors
* VMware: create vif with resource limitations
* policy: clean-up
* Make VIF.address unique with port id for neutron
* Device tagging metadata API support
* trivial: remove unnecessary mock from servers API test
* Return HTTP 200 on list for invalid status
* Complete verification for os-floating-ips-bulk
* Transform instance.update notification
* Pre-add instance actions to avoid merge conflicts
* Transform instance.delete notifications
* XenAPI:  Add UT for independent compute option
* Log DB exception if VIF creation fails
* Fixes compute API unit tests for python3
* Reduce complexity in \_stub\_allocate\_for\_instance
* Reorder allocate\_for\_instance preamble
* Make \_validate\_requested\_network\_ids return a dict
* Extract \_validate\_requested\_network\_ids
* Create \_validate\_requested\_port\_ids
* Extract \_filter\_hypervisor\_macs
* Always call port\_update in allocate\_for\_instance
* Device tagging API support
* Mapping power\_state from integer to string
* Compute manager device tagging support
* trivial: comment about vif object address field
* Example verification for os-fixed-ips.inc
* Revert "Detach volume after deleting instance with no host"
* policy: Replaces 'authorize' in nova-api (part 5)
* libvirt: add todo about bdms in \_build\_device\_metadata
* libvirt: virtuozzo instance rescue mode support
* api-ref: os-certificates.inc
* policy: Replaces 'authorize' in nova-api (part 4)
* Make LM timeout params mutable
* Help text for the ephemeral storage options
* Config Options: Improve help text for debugger
* Make Ironic options definitions consistent
* Fix some typos
* Add namespace oslo.db.concurrency in nova-config-generator.conf
* Remove mox in tests/unit/objects/test\_quotas
* Remove network information from IOVisor vif
* Add automatic switching to postcopy mode when migration is not progressing
* Extend live-migration-force-complete to use postcopy if available
* Add a test utility for checking mock calls with objects
* Remove invalid test for config option scheduler\_host\_manager
* Complete verification for api-ref os-flavor-extra-specs
* policy: Replaces 'authorize' in nova-api (part 3)
* libvirt: Add migration support for perf event support
* Libvirt driver implementation of device tagging
* Add policy sample generation
* Cleanup instance device metadata object code
* libvirt: virtuozzo instance resize support
* Fix test\_ipv6 and simplify to\_global()
* Remove russian from unit/image/test\_glance.py
* Py3: fix serial console output
* \_security\_group\_get\_by\_names cleanup
* Add reminder comments for compute rpcapi version bump
* Update get\_instance\_diagnostics for instance objects
* Improve help text for wsgi options
* Don't immediately null host/node when shelving
* Evaluate 'task\_state' in resource (de)allocation
* Add new configuration option to turn auto converge on/off
* Add new configuration option to turn postcopy on/off
* Improve nova.rpc conf options documentation
* Fix spelling mistake
* Add ability to select specific tests for py34
* Remove mox from unit/compute/test\_compute.py (4)
* Remove mox from unit/compute/test\_compute.py (end)
* Remove mox from unit/compute/test\_compute.py (11)
* Remove mox from unit/compute/test\_compute.py (10)
* Remove mox from unit/compute/test\_compute.py (9)
* Remove mox from unit/compute/test\_compute.py (8)
* Remove mox from unit/compute/test\_compute.py (7)
* Remove mox from unit/compute/test\_compute.py (6)
* Remove mox from unit/compute/test\_compute.py (5)
* UT: cleanup typo in libvirt test\_config
* Remove mox from unit/compute/test\_compute.py (3)
* Remove mox from unit/compute/test\_compute.py (2)
* Remove mox from unit/compute/test\_compute.py (1)
* Improve image signature verification failure notification
* libvirt: attach configdrive after instance XML
* libvirt: add nova volume driver for vzstorage
* Moving test helpers to a common place
* On port update check port binding worked
* Refactor to create \_ensure\_no\_port\_binding\_failure
* policy: Replaces 'authorize' in nova-api (part 2)
* XenAPI: Add option for running nova independently from hypervisor
* XenAPI: Stream config drive to XAPI
* XenAPI: Perform disk operations in dom0
* Port test\_ipv6 to py3 and simplify to\_global()
* api-ref: Example verification for os-agents.inc
* Allow monitor plugins to set own metric object
* api-ref: correct the order of APIs in server-tags
* Remove unused LOG
* Remove unnecessary \_\_init\_\_
* Release notes: fix typos
* Make print py3 compatible
* libvirt: fix disk size calculation for VZ container instances
* Fix error message for VirtualInterfaceUnplugException
* libvirt: Add boot ordering to individual disks
* image\_meta: Add hw\_rescue\_device and hw\_rescue\_bus
* collapse servers.ViewBuilderV21 into servers.ViewBuilder
* remove personality extension
* remove preserve-ephemeral rebuild extension
* remove access\_ips extension
* Bump the service version for get-me-a-network support
* neutron: handle 'auto' network request in allocate\_for\_instance
* Add unit tests for nova.virt.firewall.IpTablesFirewallDriver (Part 2)
* libvirt: split out code for recovering after migration tasks
* libvirt: split out code for processing migration tasks
* libvirt: split off code for updating migration stats in the DB
* libvirt: split off code for updating live migration downtime
* api-ref: verify images.inc
* libvirt: split out code for determining if migration should abort
* libvirt: split out code for detecting live migration job type
* policy: Replaces 'authorize' in nova-api (part 1)
* Check if flavor.vcpus is more than MAX\_TAP\_QUEUES
* policy: Add defaults in code (part 6)
* objects: Add devices\_metadata to instance object
* objects: new InstanceDeviceMetadata object
* db: add a device\_metadata column to instance\_extra
* libvirt: add perf event support when create instance
* Improve help text of crypto.py
* objects: adding an update method to virtual\_interface
* Rename driver method check\_can\_live\_migrate\_destination\_cleanup
* api-ref: added docs for microversion 2.26
* policy: Add defaults in code (part 5)
* policy: Add defaults in code (part 4)
* policy: Add defaults in code (part 3)
* policy: Add defaults in code (part 2)
* add ploop support into qemu-img info
* policy: Add defaults in code (part 1)
* Handle UnableToAutoAllocateNetwork in \_build\_and\_run\_instance
* Add note about preserve\_ephemeral limitations
* Add console auth tokens db api methods
* Remove mox from unit/virt/libvirt/volume/\*.py
* Port cinder unit tests to Python 3
* Port test\_pipelib and test\_policy to Python 3
* Adding missing log translation hints
* Add instance groups tables to the API database
* Make live migration checks async
* Check for None max\_count for Python 3 compat
* Updated from global requirements
* fix developer docs on API
* libvirt: virtlogd: use "log" element in char devices
* Fix ConsoleAuthTokens to work for all console types
* remove os-disk-config part 4
* remove os-disk-config part 3
* remove load\_standard\_extensions method
* Modify "policy.conf" to "policy.json"
* Ensures that progress\_watermark and progress\_time are updated
* Add a note for policy enforcement by user\_id
* XenAPI: Support neutron security group
* Added instance actions for conductor
* Stop using mox stubs in nova/tests/unit/test\_metadata.py
* remove support for legacy v2 generator extensions
* Remove duplicate unit test resource tracker
* Prevent instance disk overcommit against itself
* api-ref: parameter verification os-agents
* make failures on api\_samples more clear
* api-ref, os-services.inc
* api-ref: docs for microversion v2.28
* Update dhcp\_opts on both create and update
* api-ref: Improve os-instance\_usage\_audit\_log samples
* Add ironic mac address when updating and creating
* pci: Deprecate is\_new from pci requests
* Enhance notification sample test base
* Handle multiple samples per versioned notification
* Transform wrap\_exception notification to versioned format
* XenAPI: OVS agent updates the wrong port with Neutron
* Stop using mox from unit/fake\_server\_actions.py
* objects: you want'em
* libvirt: enhance method to return pointer\_model from image prop
* Improve help text for service group options
* Updated from global requirements
* Skip network allocation if 'none' is requested
* Separete notification object version test
* [typo] replaced comupte to compute in test
* api-ref, os-availability-zone.inc
* Config: no need to set default=None
* Add delete\_, update\_ and add\_ inventory to ResourceProvider
* libvirt: fix typos in comments
* Remove the nova.compute.resources entrypoint
* Re-deprecate use\_usb\_tablet config option
* Log the network when neutron won't apply security groups
* api-ref: parameter verification os-fixed-ips
* Add CellMappingList object
* Add console auth tokens table and model
* live migration check source failed caused bdm.device\_path lost
* Use is\_valid\_ipv4 from oslo.utils
* Include exception in \_try\_deallocate\_network error log
* Remove mox from tests/unit/virt/test\_imagecache.py
* Fix docstring nits from ResourceProvider.set\_inventory() review
* fix errors in revert resize api docs
* Add set\_inventory() method on ResourceProvider
* Improve the help text for cells options (8)
* VMware: Fix bug of TypeError when getting reference of VCenter cluster is None
* XenAPI: Integers returned from XAPI are actually strings
* Remove virt.block\_device.\_NoLegacy exception
* rename libvirt has\_default\_ephemeral
* Remove ec2\_code from exception
* Add specific lazy-load method for instance.tags
* Don't attempt to lazy-load tags on a deleted instance
* Pre-load tags when showing server details
* Policy-in-code servers rules
* Fix image meta which is sent to glance v2
* Extract update\_port call into method
* Refactor to create \_populate\_mac\_address
* Rename \_populate\_mac\_address adding pci
* Rename created\_port to created\_port\_id
* Flip allocate\_for\_instance create or update if
* libvirt: cleanup baselineCPU return value checking
* Updated from global requirements
* Remove mox from tests/unit/objects/test\_aggregate.py
* Handle keypair not found from metadata server
* Skip network validation if explicitly requesting no networks
* nova-net: handle 'auto' network request in allocate\_for\_instance
* neutron: validate auto-allocate is available
* Add helpers to NetworkRequest(List) objects for auto/none cases
* Remove api\_rate\_limit config option
* Tear down of os-disk-config part 2
* Tear down os-disk-config part 1
* Disallow instance tag set for invalid instance states
* Make instance as second arg in compute api calls
* TrivialFix: Remove extra comma from json
* Skip NFS and Ceph in live migration job test run
* Added missed response to test\_server\_tags
* api-ref: console types
* api-ref: add version 2.3 parameters to servers
* Remove extra expected error code (413) from image metadata
* Use instance object instead of db record
* Publish proxy APIs deprecation in api ref doc
* Fix outdated parameter network\_info description in virt/driver
* api-ref: Fix parameters in os-instance-usage-audit-log
* Remove python code validation specific to legacy\_v2
* Remove DictCompat from instance\_info\_cache
* Remove redundant test in test\_resource\_tracker
* nova shared storage: rbd is always shared storage
* Modify the disk bus and device name for Aarch64
* Remove mox from unit/compute/test\_compute\_mgr.py (end)
* Remove mox in tests/unit/objects/test\_instance\_faults
* Remove mox from unit/compute/test\_compute\_mgr.py (6)
* Remove mox from unit/compute/test\_compute\_mgr.py (8)
* Remove mox from unit/compute/test\_compute\_mgr.py (7)
* Trivial-Fix: Fix typos
* Fix some typos
* Remove mox from unit/compute/test\_compute\_mgr.py (5)
* Remove mox from unit/compute/test\_compute\_mgr.py (4)
* Remove mox from unit/compute/test\_compute\_mgr.py (3)
* Remove mox from unit/compute/test\_compute\_mgr.py (2)
* Updated from global requirements
* Make Aggregate.get\_by\_uuid use the API db
* api-ref: parameter  verification for os-aggregates
* Improve help text for neutron\_opts
* remove processing of blacklist/whitelist/corelist extensions
* fix OS-SCH-HNT:scheduler\_hints location in sample
* Fix reno from hyper-v-remotefx
* Yield the thread when verifying image's signature
* Remove invalid test methods for config option port\_range
* libvirt: Prevent block live migration with tunnelled flag
* Trivial: remove none existing py3 test from tests-py3.txt
* Make host as second arg in compute api calls
* Stop using mox stubs in tests/unit/fake\_notifier
* Remove unused \_get\_flags method from integrated\_helpers
* Enable all extension for all remaining sample tests
* tox.ini: Remove unnecessary comments in api-ref target
* Stop using mox stubs in nova/tests/unit
* Updated from global requirements
* Raise exception if BuildRequest deleted twice
* Replace mox with mock for xenapi vm\_utils.lookup
* Detach volume after deleting instance with no host
* pci: Allow updating pci\_requests in instance\_extra
* Change default fake\_ server status to ACTIVE
* Fix update inventory for multiple providers
* Default to using glance v2
* Enable all extension for remaining server API tests
* Enable all extension for server API tests part-1
* Remove mox from unit/compute/test\_compute\_mgr.py (1)
* Fixes py3 unit tests for nova.tests.unit.test\_block\_device.\*
* Reno for mutable-config
* Remove invalid test of config option default\_notification\_level
* Improve the help text for cells options (7)
* test: pass enable\_pass as kwarg in test\_evacuate
* Remove config option config\_drive\_format's invalid value test
* test: remove invalid test method in libvirt/test\_imagebackend
* xenapi: Remove invalid values for config option image\_compression\_level
* Remove mox from api/openstack/compute/test\_pci.py
* Stop using mox from openstack/compute/test\_cells.py
* Enable all extension for server actions sample tests
* Enable all extension for Flavor API sample tests
* Fix resource tracking for instances with no numa topology
* Clarified "user" to plural type
* Revert "Optimize \_cleanup\_incomplete\_migrations periodic task"
* Remove unused authorizer methods
* Remove legacy v2 policy rules
* Add unit tests for nova.virt.firewall.IpTablesFirewallDriver (Part 1)
* Make create\_inventory() handle name change
* Add ResourceProvider.save()
* Remove the skip\_policy\_check flags
* api-ref: verify keypairs
* Make Xenplugin to work with glance v2 api
* Trival: version history 2.30 is not indented as others
* Do not register notification objects
* Move notification objects to a separate package
* Move notification related code to separate package
* Adjust field types and defaults on Inventory
* Add InventoryList.find() method
* Add a get\_by\_uuid for aggregates
* Imported Translations from Zanata
* get rid of the old \_vhd methods
* Make Hyper-V to work with glance v2 api
* Stop using mox stubs in stub\_out\_key\_pair\_funcs
* Remove v2 extension setting from functional tests
* Add name and generation to ResourceProvider object
* Remove duplicate test of DELETED instances
* Added support for new block device format in Hyper-V
* Enable mutable config in Nova
* Improve help text for availability zones options
* tests: make XMLMatches work with Python3
* Catch PciRequestAliasNotDefined exception
* api-ref: parameter verification for os-hypervisors
* xen: skip two more racey mox py34 test classes
* libvirt: handle reserved pages size
* Fix nova-compute start failed when reserved\_huge\_pages has value
* Make the base options definitions consistent
* virt: set address space & CPU time limits when running qemu-img
* Remove manual creation of console.log
* Fix imagecache.get\_cache\_fname() to work in python3
* Remove policy checkpoints for SecurityGroupAPI and NetworkAPI
* Remove policy checkpoints from ComputeAPI
* Stop using mox from objects/test\_instance.py (3)
* Stop using mox from objects/test\_instance.py (2)
* Stop using mox from objects/test\_instance.py (1)
* Fix wrong patch of unittest in unit/test\_metadata.py
* Remove code referencing inventory table in cell DB
* Handle SetAdminPasswdNotSupported raised by libvirt driver
* Prevent boot if ephemeral disk size > flavor value
* [libvirt] Incorrect parameters passed to migrateToURI3
* Revert inventory/allocation child DB linkage
* Only chown console log in rescue
* Don't chown a config disk which already exists
* Don't overwrite config disk when using Rbd
* Add 'update' method to GlanceImageServiceV2
* Add 'create' method to GlanceImageServiceV2
* Add 'detail' method to GlanceImageServiceV2
* Add 'delete' method to GlanceImageServiceV2
* Add 'download' method to GlanceImageServiceV2
* Add 'show' method to GlanceImageServiceV2
* Split the glance API path based on config
* Remove image\_meta
* add "needs:\*" tags to the config option modules
* api-ref method verification for os-cells
* API change for verifying the scheduler when live migrating
* Stop using mox stubs in volume/encryptors/test\_base.py
* Introduce a CONF flag to determine glance client version
* fix a typo in comment
* Fix white spaces in api-ref
* Updated from global requirements
* virt/hardware: Add diagnostic logs for scheduling
* Use assertNotIn instead of assertTrue(all(A != B))
* Use assert(Not)Equal instead of assertTrue(A == X)
* Use assertLess(Equal) instead of assertTrue(A > X)
* Use assertGreater(A, X) instead of assertTrue(A > X)
* Fall back to flat config drive if not found in rbd
* libvirt: Fix the content of "disk.config" lost after migrate/resize
* remove /v2.1/{tenant\_id} from all urls
* Remove "or 'reserved'" from \_create\_volume\_bdm
* pci: Move PCI devices and PCI requests into migration context
* Updated from global requirements
* Fixes invalid uuid usages in test\_neutronv2
* Clarify message for Invalid/Bad Request exception
* Cancelled live migration are not in progress
* set wrap\_width for config generator to 80
* API change for verifying the scheduler when evacuating
* Fix invalid uuid warnings in virt testcases

14.0.0.0b1
----------

* Remove mox from nova/tests/unit/virt/libvirt/test\_utils.py
* Fix multipath iSCSI encrypted volume attach failure
* libvirt: add "get\_job\_info" to Guest's object
* Modify 'an network' to 'a network'
* Remove legacy v2 API code completely
* Remove the usage of RateLimitingMiddleware
* Remove unused inner\_app\_v21 and ext\_mgr
* Remove legacy API code from sample tests
* Remove InstanceUsageAuditLogTest for legacy API
* Change instance\_claim parameter from instance\_ref to instance
* Make AggregateList.get\_ return API & cell db items
* Make Aggregate.get operation favor the API db
* Add aggregates tables to the API db
* Microversion 2.28 changes cpu\_info string to JSON object
* libvirt: Skip CPU compatibility check for emulated guests
* Specify the default cdrom type "scsi" for AARCH64
* Remove mox from nova/tests/unit/test\_iptables\_network.py
* Updated from global requirements
* pci: Make sure PF is 'available' when last VF is freed
* pci: related updates are done without DB lookups
* pci: make sure device relationships are kept in memory
* Remove mox from nova/tests/unit/virt/libvirt/test\_vif.py
* verify api-ref os-migrations.inc
* Nova UTs broken due to modifying loopingcall global var
* Remove mox from unit/api/openstack/compute/test\_consoles.py
* Stop using mox from virt/libvirt/storage/test\_lvm.py
* Update functional tests for fixtures 3
* Stop using mox in test\_firewall
* Add tests to attach/detach vols for shelved server
* Remove unused \_vlan\_is\_disabled test flag
* libvirt: New configuration classes to parse device address element
* Fixed clean up process in confirm\_resize() after resize/cold migration
* VMware: remove dead code in test\_get\_vm\_create\_spec()
* Remove mox from compute/test\_scheduler\_hints.py
* Updated from global requirements
* Remove normal API operation logs from API layer
* Remove unused LOG from v2.1 API code
* Adds RemoteFX support to the Hyper-V driver
* libvirt: fix serial ports lost after hard-reboot
* Stop using mox stubs in test\_server\_usage.py
* Remove mox from compute/test\_instance\_usage\_audit\_log.py
* api-ref: os-consoles.inc
* Add proxy middleware to application pipeline
* api-ref: Example verification for os-interface.inc
* Remove redundant orphan instances unit test
* Remove duplicate migration RT unit tests
* Redundant test of CPU resources in test\_tracker
* Remove duplicate test of RT.stats.current\_workload
* Remove duplicate test of claim context manager
* Remove pointless "additive claims" unit test
* Remove oversubscribe test in test\_resource\_tracker
* api: Improve the \_check\_multiple\* function names readability
* api-ref verify servers-action-deferred-delete.inc
* Fix the order of expected error codes
* Remove DictCompat from NetworkRequest
* api-ref: Add a sample test for os-interface
* Use oslo\_log instead of logging
* Verify requested\_destination in the scheduler
* Add requested\_destination field to RequestSpec
* Remove mox from compute/test\_extended\_ips\_mac.py
* Ironic nodes with instance\_uuid are not available
* Updated from global requirements
* Fixes python 3 urllib quote / unquote usage
* Make compute nodes update their own inventory records
* Remove unused WsgiLimiter
* Remove unused args from RateLimitingMiddleware
* Remove unused use\_no\_auth from wsgi\_app\_v21()
* Fix incorrectly named vmwareapi test
* Make Inventory and ResourceProvider objects use the API DB instead
* Rename ImageCacheManager.\_list\_base\_images to \_scan\_base\_images
* Remove all references to image\_popularity from image cache
* Remove image cache image verification
* Fix test\_age\_and\_verify\_swap\_images
* api and availablity\_zone opt definition consistent
* Rename Image.check\_image\_exists to Image.exists()
* Remomve mox from api/openstack/compute/test\_console\_output.py
* Remove mox from api/openstack/compute/test\_config\_drive.py
* VMware: set service status based on vc connection
* Return 400 HTTP error for invalid flavor attributes
* Get transport\_url from config in Cells v2 cell map utility
* Support for both microversion headers
* Fix unit test after the replace of key manager
* Fix "KeyError: u'instance\_id'" in string format operation
* Save all instance extras in a single db call
* Remove APIRouter of legacy v2 API code
* Remove legacy v2 API tests which use wsgi\_app()
* limits.inc example verification
* Remove duplicate unit test in test\_tracker
* Remove delete stubs in test\_resource\_tracker
* Remove service crud from test\_resource\_tracker
* Remove conductor from test\_resource\_tracker
* Remove StatsDicTestCase from test\_resource\_tracker
* rt-unit: Replace hard-coded strings with constants
* Remove useless test of incorrect stats value
* Remove RT duplicate unit test for PCI stats
* Remove more duplicate RT unit tests
* Removes test\_claim\_saves\_numa\_topology()
* objects: added 'os\_secure\_boot' property to ImageMetaProps object
* Trivial: Fixes serial console minor nits
* Revert "glance:add helper method to get client version"
* Add length check in comparing object lists
* Update Support Matrix
* Improve the help text for the rdp options
* No disable reason defined for new services
* api-ref: limits.inc validate parameters
* Make available to build docs with python3
* Updated from global requirements
* remove db2 support from tree
* Adds Hyper-V imagecache cleanup
* raise exception ComputeHostNotFound if host is not found
* Skip instance name templating in API cell
* Add http\_proxy\_to\_wsgi to api-paste
* Stop using mox stubs in test\_pipelib.py
* api-ref: Parameter verification for os-interface.inc
* devspec: remove unused VIRTFN\_RE and re
* Remove duplicate test of set inst host/node
* Remove SchedulerClientTrackerTestCase
* Move unit tests of set\_instance\_host\_and\_name()
* Remove MissingComputeNodeTestCase for res tracker
* Remove tests for missing get\_available\_resource()
* api-ref, os-fping.inc
* Pass OS\_DEBUG to the tox test environment
* Hyper-V: Implement nova rescue
* Add resource provider tables to the api database
* HyperV: Nova serial console access support
* Let setup.py compile\_catalog process all language files
* use\_neutron\_default\_nets: StrOpt ->BoolOpt
* api-ref: Add fault parameter details
* be more explicit that rate limits are gone in v2.1
* Warn when using null cache backend
* Enable 'null' value for user\_data in V2.1 API
* Updated from global requirements
* fix Quota related error return incorrect problem
* Add online migration to move keypairs from main to API database
* Completed migrations are not "in progress"
* Make flavor-manage api call destroy with Flavor object
* Move is\_volume\_backed\_instance to compute.utils
* Updated from global requirements
* api-ref: verify flavors.inc
* Fix use of invalid assert calls
* Config options: remove import\_opts from cloudpipe section
* Enables Py34 tests for unit.api.openstack.compute.test\_server\_tags
* Fix the versions API for api-ref
* Update link for hypervisor support matrix message
* api-ref: complete verification of baremetal api
* Keep BuildRequest db entry around longer
* Drop fields from BuildRequest object and model
* Resize API operation passing down original RequestSpec
* Augment release note for import\_object\_ns removal
* pci: add safe-guard to \_\_eq\_\_ of PciDevice
* deprecate config option "fatal\_exception\_format\_errors"
* config options: centralize exception options
* libvirt: Add serial ports to the migration data object
* Hyper-V: Fixes disk overhead claim issue
* Config options: move set default opt of db section to centralized place
* [Trivial] Fix a grammar error in comments
* api-ref: Example verification for servers-action-shelve.inc
* [Ironic] Correct check for ready to deploy
* api-ref: Fix parameters in servers-action-shelve.inc
* api-ref: parameter  verification for os-server-groups
* api-ref: servers-action-evacuate.inc
* remove FlavorCreateFailed exception
* Add tests for floating\_ip private functions
* Trivial: remove os-security-groups needs:method\_verification line
* Add RC file for excluding tempest tests for LVM job
* Move config options from nova/api directory (5)
* libvirt: add method to configure max downtime when migrating
* libvirt: add "abort\_job" to Guest's object
* libvirt: add method "migrate" to Guest's object
* Only attempt to inject files if the injection disk exists
* Remove deprecated option libvirt.remove\_unused\_kernels
* Rename Raw backend to Flat
* deprecate s3 image service config options
* Cold migrate using the RequestSpec object
* Add a RequestSpec generation migration script
* Enables Py34 tests for unit.compute.test\_compute
* Fixes invalid uuid usages in functional tests
* Make neutronapi get\_floating\*() methods return objects
* Switch api unit tests to use v2.1 API
* Remove mox used in tests/unit/api/openstack/compute/test\_server\_start\_stop
* Remove marker from nova-manage cells\_v2 map\_instances UI
* api-ref: complete verification for os-flavor-access
* Make some build\_requests columns nullable
* Add message queue switching through RequestContext
* trivial: remove unused argument from a method
* baseproxy: stop requiring CONF.verbose
* Cleanup validation logic in \_get\_requested\_networks
* api-ref: complete verification of servers-action-crash-dump.inc
* migrate to os-api-ref
* api-ref: image.inc - Update method validation
* config options: centralize section "database" + "api\_database"
* api-ref: parameter  verification for os-quota-sets
* Fix network mtu in network\_metadata
* Add a note about egress rules to os-security-group-rules api-ref
* ironic: fix call to \_cleanup\_deploy on config drive failure
* Follow-up for the API config option patch
* api-ref: reorder parameters.yaml
* Network: fix typo
* Add online migration to store keypairs with instances
* Make Keypair object favor the API database
* api-ref: ips.inc example verification
* Fix spelling mistake in libvirt
* Body Verification of os-aggregates.inc
* Move placement api request logging to middleware
* conf: Move cloudpipe options to a group
* conf: Address nits in I92a03cb
* Fix corrupt "host\_aggregates\_map" in host\_manager
* Fix spelling mistake
* api-ref: Example verification for os-volume\_attachments.inc
* api-ref: Parameter verification for os-volume\_attachments.inc
* Remove fake\_imagebackend.Raw and cleanup dependent tests
* Remove unused arguments to images.fetch and images.fetch\_to\_raw
* api-ref: finish validation for os-server-external-events.inc
* report info if parameters are out of order
* Method verification of os-floating-ips-bulk.inc
* api-ref: os-volumes.inc method verification
* config options: move s3 related options
* deprecate "default\_flavor" config option
* config options: centralize default flavor option
* Return HTTP 400 on boot for invalid availability zone
* Config options: remove import\_opts from completed section
* Fix migration query with unicode status
* Config options: centralize cache options
* Change 5 space indent to 4 spaces
* Remove deprecated "memcached\_server" in Default section
* Updated from global requirements
* Add a functional test for instance fault message with retry
* api-ref: complete verification for extensions resource
* live-migration ceph: fix typo in ruleset parsing
* api-ref: os-floating-ip-dns.inc method verification
* api-ref: Method verification for servers-actions
* Eager load keypairs in instance metadata
* Complete method verification of os-networks
* Method verification of os-security-group-default-rules
* virt: reserved number of mempages on compute host
* deprecate "file transfer" feature for Glance images
* centralized conf: nova/network/rpcapi.py
* Config options: centralize remotefs libvirt options (end)
* Config options: centralize smbfs libvirt options (16)
* imagebackend: Check that the RBD image exists before trying to cleanup
* Rewrite \_cleanup\_resize and finish\_migration unit tests to use mock instead of mox
* Remove mox in test\_volume\_snapshot\_create\_outer\_success
* api-ref: Method verification for os-volume\_attachments.inc
* Improve the help text for the API options (4)
* Improve the help text for the API options (3)
* api-ref: ips.inc parameter verification
* Add Keypairs to the API database
* Create Instances with keypairs
* Method verification for server-action-deferred-delete
* method verification for server-action-remote-consoles
* method verification of os-server-external-events
* method verification of os-instance-usage-audit-log
* Add keypairs to Instance object
* Complete method verification of os-baremetal-nodes.inc
* api-ref: parameter validation for os-security-group-rules
* Fixed missing variable
* api-ref: Method verification for os-floating-ips
* force\_live\_migration remove redundant check
* pci: create PCI tracker in RT.\_init\_compute\_node
* Fix race condition for live-migration-force-complete
* api-ref: servers-action-shelve.inc
* Added fault response parameter to Show Server Details API
* pci: Remove unused 'all\_devs' method
* Corrected the typo
* Denormalize personality extension
* method verification of os-assisted-volume-snapshots
* api-ref: os-certificates.inc method verification
* Complete method verification of os-cloudpipe.inc
* Fix service version to update the DB
* method verification for servers-action-fixed-ip
* Added new exception to handle CinderClientException
* Drop paramiko < 2 compat code
* Config options: centralize scality libvirt options (15)
* Compute: Adds driver disk\_gb instance overhead estimation
* config options: move image\_file\_url download options
* crypto: Add support for Paramiko 2.x
* Denormalize extensions for clarity
* Complete method verification of os-fping
* Complete method verification of os-security-group-rules
* Fix invalid uuid warnings
* Correct some misspell words in nova
* Remove 404 for list and details actions of servers
* Improve the help text for the API options (2)
* Improve the help text for the API options (1)
* Complete method verification of os-migrations
* Move config options from nova/api directory (4)
* api-ref: perform all 4 phases of verification for action console output
* api-ref: add url parameter to expand all sections
* api-ref: complete verification for diagnostics.inc
* api-ref: update parameter validation on servers
* Complete method verification of os-tenant-networks
* trivial: removed unused networks var from os-tenant-networks:create
* Complete method verification of os-security-groups
* Move config options from nova/api directory (3)
* Move config options from nova/api directory (2)
* Move config options from nova/api directory (1)
* api-ref: method verification and fixes for servers.inc
* Instance mapping save, properly load cell mapping
* Fix exception when vcpu\_pin\_set is set to ""
* config: remove deprecated ironic.client\_log\_level
* Complete method verification of os-quotas
* Compelete method verification of os-servers-admin
* Complete method verification of os-shevle
* Add api-sample test for showing quota detail
* Remove legacy v2 tests which use APIRouter
* pci: eliminate DB lookup PCI requests during claim
* pci: pass in instance PCI requests to claim
* Remove rate\_limit param in builder
* Remove comment on v3 API
* Not talking about V2 API code in review doc guide
* Add keypairs to instance\_extra
* Trivial: No need to exclude TestMoveClaim from py34 tests
* Remove 400 as expected error
* Cleaned up request and response formats page
* Complete method verification of os-agents
* update servers policy in code to use formats
* Complete method verification of os-fixed-ips
* Consolidate image\_href to image uuid validation code
* Fix TestNeutronv2.test\_deallocate\_for\_instance\_2\* race failures
* Centralize config option for nova/network/driver.py
* Don't raise error when filtering on custom metadata
* Config options: centralize quobyte libvirt options (14)
* Config options: centralize volume nfs libvirt options (13)
* Config options: centralize volume net libvirt options (12)
* Config options: centralize iser libvirt options (11)
* Config options: centralize iscsi libvirt options (10)
* Config options: centralize glusterfs libvirt options (9)
* Config options: centralize aoe vol libvirt options (8)
* Config options: centralize volume libvirt options (7)
* Config options: centralize vif libvirt options (6)
* Config options: centralize utils libvirt options (5)
* Config options: centralize lvm libvirt options (4)
* Remove legacy v2 unit tests[q-v]
* Remove legacy v2 unit tests[f-n]
* Remove Limits dependency of legacy v2 API code
* Remove mox in unit/virt/xenapi/test\_agent.py
* Set migration status to 'error' on live-migration failure
* Add pycrypto explicitly
* Centralize vif,xenpool & vol\_utils config options
* Config options: centralize imagecache libvirt options (3)
* Config options: centralize imagebackend libvirt options (2)
* Remove the legacy v2 API entry from api-paste.ini
* Update stable API doc to indicate code removal
* Config options: centralize driver libvirt options (1)
* UEFI - instance terminates after boot
* Fix unit tests for v2.1 API
* Remove legacy v2 unit tests[a-e]
* Config options: Centralize servicegroup options
* libvirt: release serial console ports when destroying guests
* Remove mox from tests/unit/network/test\_api.py
* Remove legacy v2 API functional tests
* fix wrong key name in test code
* Remove the legacy v2 API test scenarios from API sample tests
* Remove 413 expect in servers.py
* Remove core extension list
* rt: remove unused image\_meta parameter
* Fail to start nova-api if no APIs were able to be started
* Test that nova-api ignores paste failures, but continues on
* libvirt: introduces module to handle domain xml migration
* Trivial: dead code
* Fix database poison warnings, part 8
* docs: link to Laski's cells talk from the Austin summit
* compute: Retain instance metadata for 'evacuate' on shared storage
* Archive instance\_actions and instance\_actions\_event
* Add os-interface functional negative tests
* api-ref: verify os-server-groups.inc
* Avoid unnessary \_get\_power\_state call
* Remove mox in test\_certificates.py
* api-ref: verfiy limits body
* api-ref: body verification of ips.inc
* Change message format of Forbidden
* Updated from global requirements
* api-ref verify of servers-admin-action.inc
* pci: Allow to assign pci devices in pci device list
* Fix typo in support-matrix.ini: re(set)=>(re)set
* Add ability to filter migrations by instance uuid
* Wrong mocks, wrong mock order
* verify api-ref metadata.inc
* verify api-ref os-server-password.inc
* Updated from global requirements
* Fix database poison warnings, part 7
* Declare nova.virt namespace
* [doc] fix 5 typos
* Make compute rpcapi 'live\_migration' backward compatible
* Replace key manager with Castellan
* Deprecate Nova Network
* verify api-ref os-instance-usage-audit-log.inc
* Only reset dns\_name when unbinding port if DNS is integrated
* Changed the storage size from GB to GiB
* Remove unused FAKE\_UUID variables
* Deprecated the concept of extensions in v2.1
* Fix database poison warnings, part 6
* Fix database poison warnings, part 5
* Avoid unconditional warnings in nova-consoleauth
* libvirt: remove version checks for hyperv PV features
* libvirt: remove version checks for libvirt disk discard feature
* libvirt: remove version checks for block job handling
* libvirt: remove version checks for PCI device detach
* libvirt: remove version checks for live snapshot feature
* libvirt: add explicit check for min required QEMU version
* libvirt: increase min required libvirt to 1.2.1
* network: Fix nova boot with multiple security-groups
* Updated config description on live snapshot
* Fix NoSuchOptError when referring to conf.neutron.auth\_plugin
* api-ref host verification (os-hosts.inc)
* api-ref verify os-floating-ip-pools.inc
* Complete Verification of server-metadata
* Complete method Verification of os-hypervisors
* Fix invalid uuid warnings in compute api testcases
* Fix invalid uuid warnings
* complete Method Verification of aggregates
* Complete Method Verification of ips
* Fix resize to same host failed using anti-affinity group
* Complete method Verification of consoles
* Config options: Centralize netconf options
* Remove 413 as expected error code
* Complete Verification of os-server-password
* Complete Verification of os-hosts
* Add links to API guide to describe links
* Complete Method Verification of os-interface
* Complet Method Verification of flavor-access
* Complete Verification of os-virtual-interfaces
* Complet Method Verification of os-instance-actions
* Complete Verification of os-flavor-extra-specs
* Fix database poison warnings, part 4
* Complet Method Verification of flavor
* Complet Method Verification of server group
* Trivial: fix mock decorator order
* Add test for nova-compute and nova-network main database blocks
* Prevent nova-api from dying if enabled\_apis is wrong
* Complet Method Verification of keypair
* Complet Method Verification of availability-zone
* Complet Method Verification of simple tenant usage
* remove the use of import\_object\_ns
* Fixed typo in word "were"
* Complet Method Verification of os-services
* Complet Method Verification of server diag
* Remove mox in tests/unit/compute/test\_host\_api.py
* Config options: completing centralize neutron options
* Add instances into dict when handle exception
* Complet Method Verification of limits
* Improve the help text for the compute rpcapi option
* Move config options from nova/compute/rpcapi.py file
* Updated from global requirements
* deprecate nova-all
* Remove unused base\_options param from \_get\_image\_defined\_bdms
* Change BuildRequest to contain a serialized instance
* Split out part of map\_cell\_and\_hosts to return a uuid
* Add manage command for cell0
* Config options: centralize section "ssl"
* config options: centralize security\_group\_api opt
* Imported Translations from Zanata
* Stop using mox stubs in test\_multinic.py
* libvirt: deprecate use\_usb\_tablet in favor of pointer\_model
* Config options: Centralize neutron metadata options
* add tags to files for the content verification phase
* Config options: Centralize compute options
* Add 415 to list of exceptions for microversions devref
* Added validation for rescue image ref
* Final warnings removals for api-ref
* Clean port dns\_name in case of port detach
* Fix remaining json reference warnings
* Add validations for volume\_size and destination\_type
* Remove duplicate api ref for os-networks/actions
* Fix all remaining sample file path
* Stop using mox stubs in test\_access\_ips.py
* Stop using mox stubs in test\_admin\_password.py
* libvirt - Add log if libguestfs can't read host kernel
* Fix sample file path for 4 files
* Fix invalid uuid warnings in objects testcases
* Fix invalid uuid warnings in server-group unit tests
* Create image for suspended instance booted from volume
* Fix content and sample file for keypair, migration, networks
* Fix sample file path for os-i\* API
* Fix the parameters for os-agents API
* Fix sample file path for fixed, floating ips API
* Fix sample path for aggregate, certificate, console
* Add remaining image API ref
* Fix the schema of assisted\_volume\_snapshots
* config options: conductor live migrate options
* xenapi: Fix xmlrpclib marshalling error
* fix samples references in security group files
* fix samples references in os-services
* Fix api samples references in 3 more files
* Fix reverse\_upsize\_quota\_delta attempt to look up deleted flavors
* Fix api ref for os-hosts, os-quota-sets and os-fping
* Fix api ref for os-cells, os-cloudpipe and server-action-shelve
* Fix api sample references in 2 more files
* Updated from global requirements
* hardware: thread policy default value applied even if specified
* Fix api ref for ips, limits, metdata and agent
* virt: use more realistic fake network / VIF data
* Fix json response example heading in api ref
* Fix database poison warnings, part 3
* Remove 40X and 50X from Normal response codes
* Specify normal status code on os-baremetal-nodes
* Remove unused rotation param from \_do\_snapshot\_instance
* Remove unused filter\_class\_names kwarg from get\_filtered\_hosts
* Remove deprecated ability to load scheduler\_host\_manager from path
* Fix "Creates an aggregate" parameters
* Unavailable hosts have no resources for use
* HyperV: Add SerialConsoleOps class
* HyperV: Add serial console handler class
* HyperV: Add serial console proxy
* fix samples references for 2 files
* Update servers.inc to be as accurate as api-site
* Fix database poison warnings, part 2
* Fix "Creates an agent build" parameters
* Update get\_by\_project\_id on InstanceMappingList
* Clean up cell handling in nova-manage cell\_v2 map\_instances
* Properly clean up BDMs when \_provision\_instances fails
* clean up versions.inc reference document
* Collection of CSS fixes
* Fixes unexpectedly passing functional test
* move sphinx h3 to '-' instead of '^'
* fix blockquote font size
* Add 'Show All' / 'Hide All' toggle
* use 'required' instead of 'optional' for parameters
* Fix css references to the glyphicons font
* Initial use of microversion\_parse
* Changed an HTTP exception to return proper code
* Compute API: omit disk/container formats when creating images of snapshots
* Fix formatting of rst in parameters.yaml
* Add instance/instance\_uuid to build\_requests table
* network: make nova to handle port\_security\_enabled=False
* BaseCoreFilter docstring and formating improved
* Fix NoMoreNetworks functional test traces
* Fix typo in nova release notes
* Updated from global requirements
* Fix generation of Guru Meditation Report
* Fix invalid uuid warnings in cell api testcases
* cleanup some issues in parameters.yaml
* Import RST files for documentation
* add combined parameters.yaml file
* claims: Do not assume image-meta is a dict
* Fix nova opts help info
* Fix doc build if git is absent
* Add checks for driver attach\_interfaces capability
* Updated from global requirements
* Add AllServicesCurrent fixture
* Improve the help text for the linuxnet options (3)
* Improve the help text for the linuxnet options (2)
* Fix signature of copy\_image
* libvirt: remove live migrate workaround for an unsupported ver
* libvirt: move graphic/serial consoles check to pre\_live\_migration
* Fix invalid uuid warnings in api testcases
* Minor updates to the how\_to\_get\_involved docs
* Put more into compute.api.\_populate\_instance\_for\_create
* Remove unused parameter from \_get\_requested\_instance\_group
* Improved test coverage
* Check API versions intersects
* virt/hardware: Fix 'isolate' case on non-SMT hosts
* Migrate compute node resource information to Inventory objects
* Drop compute node uuid online migration code
* increase error handling for dirty files
* config options: centralize 'spice' options
* Fix max concurrent builds's unlimited semaphore
* VMware: add in context for log messages
* XenAPI: specify block size for writing config drive
* Fix database poison warnings
* Make swap-volume an admin-only API by default
* Updated from global requirements
* Improve the help text for the linuxnet options (1)
* Config options: Centralize network options
* Config options: centralize base path configuration
* Add new NeutronFloatingIP object
* Add "\_\_repr\_\_" method to class "Service"
* remove alembic from requirements.txt
* Config options: centralize section "xvp"
* Imported Translations from Zanata
* Updated from global requirements
* allow samples testing for PUT to not have a body
* libvirt: delete the last file link in \_supports\_direct\_io()
* db: retry instance\_info\_cache\_update() on deadlock
* Moved tags filtering tests to TestInstanceTagsFiltering test case
* Move config options from nova/network/linux\_net.py
* Remove nova-manage service subcommand
* config options: centralize quota options
* DB API changes for the nova-manage quota\_usage\_refresh command
* Improve the help text for the network options (1)
* Fix typo in compute node mega join comments
* Add api-ref/build/\* to .gitignore
* Improve help text for the network object options
* Config options: Centralize console options
* Config options: Centralize notification options
* Remove mox from tests/unit/network/security\_group/test\_neutron\_driver.py
* Added server tags support in nova-api
* Added server tags controller
* Added db API layer to add instance tag-list filtering support
* Improve 'workarounds' conf options documentation
* Config options: centralize "configdrive" options
* config options: centralize baseproxy cli options
* Check if a exception has a code on it before read the code
* Fix import statement order in nova/rpc.py
* Document our policy on fixing v2.0 API bugs
* Config options: Centralize neutron options
* Remove mox from tests/unit/compute/test\_compute\_xen.py
* Fix typo in comments of affinity and anti-affinity
* Fix up online\_data\_migrations manage command to be consistent
* Adds missing discoverable rules in policy.json
* Config options: Centralize ipv6 options
* config options: centralize xenserver vmops opts
* Config options: Centralize xenapi driver options
* config options: centralize xenserver vm\_utils opts
* Remove flavor seeding from the base migration
* Rely on devstack to skip rescue tests for cells v1
* Replace topic with topics for messaging.Notifier
* Updated from global requirements
* Fix test for empty policy rules
* Improve 'monkey\_patch' conf options documentation
* conf: Remove 'destroy\_after\_evacuate'
* config options: Move crypto options into a group
* config options: centralize section: "crypto"
* config options: Centralise 'monkeypatch' options
* config options: Centralise 'utils' options
* doc: clean up oslo-incubator related stuff
* config option generation doesn't work with a generator
* Add link to the latest nova.conf example
* Change the nova tempest blacklist to use to idempotent ids
* HyperV: Refactor livemigr, avoiding getting disk paths remotely
* Remove DictCompat from mapping objects
* Enhance value check for option notify\_on\_state\_change
* Fix flavor migration tests and edge case found
* config options: Centralize upgrade\_levels section
* config options: Centralize mks options
* Remove DictCompat from S3 object
* config options: Centralize vmware section
* config options: centralize section "service"
* Define context.roles using base class
* TrivialFix: removed unnecessary cycle in servicegroup/test\_api.py
* Handle pre-migration flavor creation failures in the crusty old API
* config options: centralize section "guestfs"
* config options: centralize section "workarounds"
* config options: Centralize 'nova.rpc' options
* Cleanup NovaObjectDictCompat from BandwidthUsage
* config options: fix the missed cli options of novncproxy
* Add metadata objects for device tagging
* Nuke cliutils from oslo-incubator
* libvirt: pci detach devices should use dev.address
* Fix stale file handle error in resource tracker
* Updated from global requirements
* config options: Centralize xenapi torrent options
* Fix: unable to delete instance when cinder is down
* Block flavor creation until main database is empty
* Further hack up the n.t.unit.db.fakes module of horribleness
* Add flavor migration routine
* Make Flavor create() and destroy() work against API DB
* Move config options from nova/objects/network.py
* Add tag column to vifs and bdm
* Remove extensible resource tracking
* Fix error message of nova baremetal-node-delete
* Enhanced error handling for rest\_parameters parser
* Fix not supported error message
* config options: Centralise 'image\_file\_url' options
* neutron: Update the port with a MAC address for PFs
* Remove mox from tests/unit/network/test\_rpcapi.py
* Remove mox from tests/unit/objects/test\_migration.py
* The 'record' option of the WebSocketProxy should be string
* config options: centralize section: "glance"
* Move resource provider staticmethods to proxies
* Add Service.get\_minimum\_version\_multi() for multiple binaries
* remove the ability to disable v2.1
* Make git clean actually remove covhtml
* Set 'libvirt.sysinfo\_serial' to 'none' in RealTimeServersTest
* Make compute\_node\_statistics() use new schema
* remove glance deprecated config
* Config options: Centralize consoleauth options
* config options: centralize section "cloudpipe"
* After migrate in-use volume the BDM information lost
* Allow to update resource per single node
* pci: Add utility method for getting the MAC addr

13.0.0
------

* Imported Translations from Zanata
* VMware: Use Port Group and Key in binding details
* Config options: Centralize resource tracker options
* Fixed incorrect behavior of xenapi driver
* Remove DictCompat from ComputeNode
* config options: Centralise 'virt.imagecache' options
* neutron: pci\_request logic considers 'direct-physical' vnic type
* config options: remove the scheduler import\_opt()s
* Improve the help text for hyperv options (3)
* Improve the help text for hyperv options (2)
* Improve the help text for hyperv options (1)
* Imported Translations from Zanata
* Remove a redundant 'that'
* Cleanup NovaObjectDictCompat from NumaTopology
* Fix detach SR-IOV when using LibvirtConfigGuestHostdevPCI
* Stop using mox in test\_security\_groups
* Cleanup the exception LiveMigrationWithOldNovaNotSafe
* Add sample API content
* Create api-ref docs site
* Config options: Centralize debugger options
* config options: centralize section: "keymgr"
* libvirt: fix ivs test to use the ivs vif object
* libvirt: pass a real instance object into vif plug/unplug methods
* Add a vnic type for PF passthrough and a new libvirt vif driver
* libvirt: live\_migration\_flags/block\_migration\_flags default to 0
* Imported Translations from Zanata
* config options: Centralize xenapi options
* Populate instance\_mappings during boot
* libvirt: exercise vif driver 'plug' method in tests
* config options: centralize xenserver options
* Fix detach SR-IOV when using LibvirtConfigGuestHostdevPCI
* Reduce number of db calls during image cache manager periodic task
* Imported Translations from Zanata
* Update cells blacklist regex for test\_server\_basic\_ops
* Update cells blacklist regex for test\_server\_basic\_ops
* Remove mox from tests/functional/api\_sample\_tests/test\_cells.py
* Remove mox from tests/unit/api/openstack/compute/test\_baremetal\_nodes.py
* Config options: Centralize ldapdns options
* Add NetworkRequestList.from\_tuples helper
* Stop providing force\_hosts to the scheduler for move ops
* Enforce migration tests for api database
* Objectify test\_flavors and test\_flavors\_extra\_specs
* Allow ironic driver to specify cafile
* trivial: Fix alignment of wsgi options
* config options: Remove 'wsgi\_' prefix from opts
* VMware: Always update image size for sparse image
* VMware: create temp parent directory when booting sparse image
* VMware: Use datastore copy when the image is already in vSphere
* Imported Translations from Zanata
* Fix typos in document
* Removes some redundant words
* Stop providing force\_hosts to the scheduler for move ops
* Include CellMapping in InstanceMapping object
* Make flavor extra\_specs operations work against the API DB
* Make Flavor access routines work against API database
* Clarify the \`\`use\_neutron\`\` option upgrade notes

13.0.0.0rc2
-----------

* Imported Translations from Zanata
* Try to repopulate instance\_group if it is None
* Try to repopulate instance\_group if it is None
* modify duplicate // to / in doc
* change host to host\_migration
* Fixup test\_connection\_switch functional test
* Fix SAWarning in \_flavor\_get\_by\_flavor\_id\_from\_db
* Update 'os-hypervisors.inc' in api-ref
* Fix os-server-groups.inc
* cinder: accommodate v1 cinder client in detach call
* Move config options from nova/network/manager.py
* Change adminPass for several server actions
* Fix os-virtual-interfaces and flavors api-ref
* Make FlavorList.get\_all() return results from the API and main DBs
* Objectify some tests in test\_compute and test\_flavors
* Objectify test\_instance\_type\_extra\_specs
* Add a DatabasePoisonFixture
* config options: Use OptGroup for listing options
* Live migration failure in API leaves VM in MIGRATING state
* Fix flavor-access and flavor-extras api-ref
* Fix diagnostics, extensions api ref
* Fix typo 'mappgins' to 'mappings'
* Imported Translations from Zanata
* Fix hosts and az api samples
* Change "libvirt.xml" back to the original after doing unrescue
* Fix os-service related reference missing
* Add 'binary' and 'disable-reason' into os-service
* Remove unused argument v3mode
* Clean up the TestGlanceClientWrapper retry tests
* stop setting mtu when plugging vhost-user ports
* config options: Move wsgi options into a group
* Rewrite 'test\_filter\_schedule\_skipping' method using Mock
* Remove stub\_compute config options
* Added missing "=" in debug message
* libvirt: serial console ports count upper limit needs to be checked
* Imported Translations from Zanata
* Return 400 on boot for invalid image metadata
* Fix JSON format of server\_concepts
* Remove /v1.1 endpoint from api-guide
* config options: centralize section: "rdp"
* Fixes hex decoding related unit tests
* Fix conversion of config disks to qcow2 during resize/migration
* xenapi: Fix when auto block\_migration in the API
* xenapi: Fix up passing of sr\_uuid\_map
* xenapi: Fix the live-migrate aggregate check
* Add rebuild action descriptions in support-matrix
* Config options: centralize section "hyperv"
* Removal of unnecessary \`import\_opt\`s for centralized config options
* Imported Translations from Zanata
* Fixes bug with notify\_decorator bad getattr default value
* config options: centralize section "monitors"
* config options: Centralise floating ip options
* Fix API Error on hypervisor-uptime API
* VMware: make the opaque network attachment more robust
* Add functional test for v2.7
* avoid microversion header in functional test
* Add backrefs to api db models
* Update reno for stable/mitaka
* stop setting mtu when plugging vhost-user ports
* Removes redundant object fields
* Blacklist TestOSAPIFixture.test\_responds\_to\_version in python3
* Fix conversion of config disks to qcow2 during resize/migration
* Remove auto generated module api documentation
* Imported Translations from Zanata
* Mark 2.25 as Mitaka maxmium API version
* Add a hacking check for test method closures
* Make Flavor.get operations prefer the API database
* xenapi: Fix when auto block\_migration in the API
* xenapi: Fix up passing of sr\_uuid\_map
* Update to openSUSE versions
* xenapi: Fix the live-migrate aggregate check
* Error on API Guide warnings
* Add Newton sanity check migration
* Add placeholder migrations for Mitaka backports
* Update .gitreview for stable/mitaka
* Set RPC version aliases for Mitaka

13.0.0.0rc1
-----------

* Fix reno reverts that are still shown
* Wait for device to be mapped
* Add a prelude section for Mitaka relnotes
* Fix reno for RC1
* libvirt: Fix ssh driver to to prevent prompting
* Support-matrix of vmware for chap is wrong
* Imported Translations from Zanata
* <VMWare> Allocate free bus for new SCSI controller
* config options: centralize cinder options
* Add os-brick rootwrap filter for privsep
* Fix retry mechanism for generator results
* Add a cell and host mapping utility to nova-manage
* Add release note for policy sample file update
* Fix vmware quota extra specs reno formatting
* Avoid lazy-loads of ec2\_ids on Instance
* Replace deprecated LOG.warn with LOG.warning
* libvirt: Allow use of live snapshots with RBD snapshot/clone
* Typo fix in documentation
* Redundant parentheses removed
* Trivial: Use exact docstring for quota module
* Replace deprecated LOG.warn with LOG.warning
* Revert "virt: reserved hugepages on compute host"
* Make tuple actually a tuple
* xenapi: Image cache cannot be disabled
* VMware: enable a resize of instance with no root disk
* fixed typo in word "OpenStack"
* hyper-v: Copies back files on failed migration
* Add functional test for OverQuota
* Translate OverLimit exceptions in Cinder calls
* Add regression test for Cinder 403 forwarding
* register the config generator default hook with the right name
* pci - Claim devices outside of Claim constructor
* Get instance security\_groups from already fetched instance
* Use migrate\_data.block\_migration instead of block\_migration
* Fix pre\_live\_migration result processing from legacy computes
* Add reno for disco driver
* linux\_net: use new exception for ovs-vsctl failures
* Insure resource tracker updated for deleted instances
* VMware: use datacenter path to fetch image
* libvirt: check for optional LibvirtLiveMigrateData attrs before loading
* Change SpawnIsSynchronous fixture return
* Report instance-actions for live migration force complete API
* Add release notes for security fixes in 13.0.0 mitaka GA
* API: Raise up HTTPNotFound when no availabe while get\_console\_output
* libvirt: Comment non-obvious security implications of migrate code
* Update the doc of notification
* fixed log warning in sqlalchemy/api.py
* Add include\_disabled parameter to service\_get\_all\_by\_binary
* Imported Translations from Zanata
* Set personality/injected\_files to empty list if not specified
* Fix processing of libvirt disk.info in non-disk-image cases
* pci: avoid parsing whitelist repeatedly
* Add Forbidden to caught cinder exceptions
* Missing info\_cache.save() in db sqlalchemy api
* tests: Add some basic compute\_api tests for attaching volumes
* Clean up networks with SR-IOV binding on reschedule
* virt: refactor method compute\_driver\_matches
* Make force\_ and ignore\_hosts comparisons case insensitive
* xenapi: fix when tar exits early during download
* Address nits in I83a5f06ad
* Fix config generation for Neutron auth options
* Remove an unused method in FakeResourceTracker
* Rework 'limited' and 'get\_limit\_and\_marker'
* plugins/xenserver: Resolve PEP8 issues
* Remove unused variable and redundant code path
* Soft delete instance group member when delete instance
* VMware: Refactor the formatting instance metadata
* Remove sizelimit.py in favor of oslo\_middleware.sizelimit
* libvirt: make snapshots call suspend() instead of reimplementing it
* Use generic wrapper for cinder exceptions
* Add ppc64le architecture to some libvirt unit tests
* Add Database fixture to sync to a specific version
* Drop the use of magic openstack project\_id
* Aggregate object fixups
* Address nits in Ia2296302
* Remove duplicated oslo.log configuration setup
* libvirt: Always copy or recreate disk.info during a migration
* nova-manage: Print, not raise, exceptions
* virt: reserved hugepages on compute host
* XenAPI:Resolve Nova/Neutron race condition
* Don't use locals() and globals(), use a dict instead
* update the deprecated \`\`security\_group\_api\`\` and \`\`network\_api\_class\`\`
* [Ironic]Match vif-pif mac address before setting 'vif\_port\_id'
* Correct the wrong usage of 'format' jsonschema keyword in servers API
* Add ComputeNode and Aggregate UUID operations to nova-manage online migrations
* Extend FakeCryptoCertificate.cert\_not\_valid\_after to 2 hours
* Revert "functional: Grab the service version from the module"
* libvirt: Fix resize of instance with deleted glance image
* Reno for libvirt libosinfo with OS
* Fix hyperv use of deprecated network\_api\_class
* Fix v2.12 microversion REST API history doc
* Add docstrings for nova.network.base\_api.get\_vifs\_by\_instance
* Style improvements
* Reno for Ironic api\_version opt deprecation
* Release notes: online\_data\_migrations nova-manage command
* nova-manage: Declare a PciDevice online migration script
* test\_fields: Remove all 'Enum' subclass tests
* Make test cases test\_crypto.py from NoDBTestCase
* Ironic: remove backwards compatibility code
* Ironic: Use ironicclient native retries for connection errors
* RT: aborting claims clears instance host and NUMA info
* Provide correct connector for evacuate terminate
* Reset instance progress when LM finishes
* Forbid new legacy notification event\_type
* VMware: Remove VMwareHTTPReadFile
* API: Mapping ConsoleTypeInvalid exception to HTTPBadRequest
* VMware: remove deprecation warnings from oslo\_versionedobjects
* Reject empty-named AZ in aggregate metadata
* add checking for new image metadata property 'hw\_cpu\_realtime\_mask'
* Remove unused methods in nova/utils.py
* Fix string interpolations at logging calls
* Generate better validation error message when using name regexes
* Return 400 for os-virtual-interfaces when using Neutron
* Dump metric exception text to logs
* Updated from global requirements
* Use SensitiveStringField for BlockDeviceMapping.connection\_info
* Add index on instances table across deleted/created\_at columns
* Tweak the resize\_confirm\_window help text
* Enable rebuild tests in cellsv1 job
* libvirt: clean up help text for live\_migration\_inbound\_addr option
* Add release note for nova using neutron mtu value for vif plugging
* deprecate security\_group\_api config option
* update tests for use\_neutron=True; fix exposed bugs
* deprecate \`\`volume\_api\_class\`\` and \`\`network\_api\_class\`\`
* deprecate \`\`compute\_stats\_class\`\` config option
* Deprecate the \`\`vendordata\_driver\`\` config option
* Deprecate db\_driver config option
* deprecate manager class options
* remove default=None for config options
* Check 'destination\_type' instead of 'source\_type' in \_check\_and\_transform\_bdm
* Documentation fix regarding triggering crash dump
* Use db connection from RequestContext during queries
* Ironic: Clean up if configdrive build fails
* Revert "Generate better validation error message when using name regexes"
* Add unit tests for live\_migration\_cleanup\_flags
* Replaced unittest and unittest2 to testtools
* Sample nova.conf file has missing/duplicated config options

13.0.0.0b3
----------

* Fix missing of unit in HostState.\_\_repr\_\_()
* Make InstanceMappings.cell\_id nullable
* Create BuildRequest object during boot process
* Add BuildRequest object
* Api\_version\_request.matches does not accept a string or None
* Added Keystone and RequestID headers to CORS middleware
* Generate better validation error message when using name regexes
* XenAPI: introduce unit test for XenAPI plugins
* Abstract a driver API for triggering crash dump
* Fix evacuate support with Nova cells v1
* libvirt: don't attempt to get baseline cpu features if host cpu model is None
* Ensure there are no unreferenced closures in tests
* libvirt: set libvirt.sysinfo\_serial='none' for virt driver tests
* libvirt: Add ppc to supported arch for NUMA
* Use new inventory schema in all compute\_node gets
* Remove unused libvirt \_get\_all\_block\_devices and \_get\_interfaces
* Use new inventory schema in compute\_node\_get\_all()
* Deprecate nova.hooks
* Adjust resource-providers models for resource-pools
* Fix Cells RPC API by accepting a RequestSpec arg
* API: Improve os-migrateLive input parameters
* Allow block\_migration and disk\_over\_commit to be None
* Update time is not updated when metadata of aggregate is updated
* complete the removal of api\_version from rest client parameters
* objects: add HyperVLiveMigrateData stub
* functional: Grab the service version from the module
* Added missed '-' to the rest api history doc
* Gracefully handle cancelling all events more than once
* Cleanup service.kill calls in functional tests
* Do not use constraints for venv
* VMware: Use actual VM state instead of using the instance vm\_state
* Do not pass call\_xenapi unmarshallable type
* check max\_net\_count against min\_count when booting
* objects: Allow instance to reset the NUMA topology
* Mark 'network\_device\_mtu' as deprecated
* Add service binary/host to service is down log for context
* Abort an ongoing live migration
* Add new APIs and deprecate old API for migrations
* Deprecate conductor manager option
* Xen: Calculate block\_migration if it's None
* Libvirt: Calculate block\_migration if it's None
* NUMATopologyFilter raise exception and not continue filter next node
* Updated from global requirements
* Add specific method to lazy-load instance.pci\_devices
* Move logging outside of LibvirtConfigObject.to\_xml
* Update the help for deprecated glance host/port/protocol options
* Added missing execution of the test
* Add build\_requests database table and model
* Make db.aggregate\_get a reader not a writer
* Remove an unnecessary variable in a unit test
* Remove duplicate test case flavor\_create
* Don't lazy-load instance.services if the instance is deleted
* Add functional regression test for list deleted instances on v2.16
* Use constant\_time\_compare from oslo.utils
* Remove APIRouterV3
* reduce pep8 requirements to just hacking
* fix usage of opportunistic test cases with enginefacade
* add regression test for bug #1541691
* Creates flavor\* tables in API database
* Add test for unshelve in the conductor API
* add a place for functional test to block specific regressions
* make microversion a client level construct for tests
* Allocate uuids for aggregates as they are created or loaded
* bug and tests in 'instance\_info\_cache'
* fix typo in comment
* Fix conductor to \*really\* pass the Spec obj
* Updated from global requirements
* Catch iscsi VolumeDeviceNotFound when detaching
* Add note about using OS-EXT-\* prefix for attribute naming
* Remove use of \`list\` as variable name
* resource-provider versioned objects
* Fix networking exceptions in ComputeTestCase
* Fix online\_data\_migrations() not passing context
* Fix two bugs in online\_data\_migrations()
* Make online\_data\_migrations do smaller batches in unlimited case
* Use MTU value from Neutron in OVS/LB VIF wiring
* tox: Remove 'oslo.versionedobjects' dependency
* Fix API Guide doc
* Add functional regression test for bug 1552888
* Fix an unnecessary interpolation
* Change wording of microversion bump about 503
* Validate subs in api samples base class to improve error handling
* Add a column for uuid to aggregate\_hosts
* Hyper-V: Removes pointless check in livemigrationops
* XenAPI: Fix VIF plug and unplug problem
* Update ComputeNode values with disk allocation ratios in the RT
* Update HostManager and DiskFilter to use ComputeNode disk ratio
* Add disk\_allocation\_ratio to ComputeNode
* config options: Centralise 'virt.disk' options
* config options: Centralise 'virt.netutils' options
* Improve 'virt.firewall' conf options documentation
* config options: Centralise 'virt.firewall' options
* Improve 'virt.images' conf options documentation
*  config options: Centralise 'virt.images' options
* Update wrong comment
* Fix misuse of assertTrue in console and virt tests
* Failed migration shoudn't be reported as in progress
* Fix missing of unit in debug info
* always use python2.7 for pep8
* servicegroup: remove the zookeeper driver
* Hacking: check for deprecated os.popen()
* Log successful reverts\_task\_state calls
* Hyper-V: os\_win related updates
* Partial revert of ec2 removal patch
* Fixed leaked UnexpectedMethodCallErrors in test\_compute
* Unshelve using the RequestSpec object
* Provide ReqSpec to live-migrate conductor task
* Fix cell capacity when compute nodes are down
* Fix misleading test name
* Default "discoverable" policies to "@"
* build smaller name regexes for validation
* Add reno for block live migraton with cinder volumes
* Remove support for integer ids in compute\_api.get
* Add annotation to the kill() method
* Add missing os types: suseGuest64/suseGuest
* Hypervisor support matrix: add feature "trigger crash dump"
* Update example policy.json to remove "" policies
* Fixed arguement order in remove\_volume\_connection
* Add better help text to scheduler options (7)
* Add better help text to scheduler options (6)
* RT: Decrese usage for offloaded instances
* Allow saving empty pci\_device\_pools in ComputeNode object
* Add StableObjectJsonFixture and use it in our base test class
* nova-manage: Add hooks for running  data-migration scripts
* always use pip constraints
* Update instance host in post live migration even when exception occurs
* Use imageutils from oslo.utils
* Remove duplicate key from dictionary
* reset task\_state after select\_destinations failed
* Pass bdm info to \_get\_instance\_disk\_info method
* Fix create snapshot failure on VMs with SRIOV
* Reorder name normalization for DNS
* Allocate UUID for compute node
* rpc.init() is being called twice per test
* Use instance hostname for Neutron DNS unit tests
* objects: Rename PciDevice \_migrate\_parent\_addr  method
* Use assertRaises() to check specific exception
* libvirt: make live\_migration\_uri flag dependent on virt\_type
* Remove unused CONF imports
* Add /usr/local/{sbin,bin} to rootwrap exec\_dirs
* write live migration progress detail to DB in migration monitor
* Add migration progress detail in DB
* Tolerate installation of pycryptodome
* neutron: handle attach interface case with no networks
* Move Disk allocation ratio to ResourceTracker
* Updated from global requirements
* HyperV: Fix vm disk path issue
* Removal of unnecessary \`import\_opt\`s for cells config options
* Fix 500 error for showing deleted flavor details
* Fix \_compare\_result type handling comparison
* neutron: remove redundant request.network\_id assignment
* Fix reported ppc64le bug on video selection
* Improve 'virt.driver' conf options documentation
* Improve unit tests for instance multiple create
* Change populate\_security\_groups to return a SecurityGroupList
* Fix error message in imagebackend
* config options: Centralise 'virt.driver' options
* Avoid lazy-loading flavor during usage audit
* resource\_providers, allocations and inventories models
* Revert "Add new test\_rebuild\_instance\_with\_volume to cells exclude list"
* Update the CONF import path for VNC
* Improve 'vnc' conf options documentation
* Remove discoverable policy from server:migrations resource
* Improve the help text for cells options (6)
* Improve the help text for cells options (5)
* Improve the help text for cells options (4)
* Improve the help text for cells options (3)
* Improve the help text for cells options (2)
* Allow block live migration of an instance with attached volumes
* Implement an indexed ResourceClass Enum object
* Add check to limit maximum value of max\_rows
* Fix spelling mistake
* Add methods for RequestContext to switch db connection
* virt: osinfo will report once if libosinfo is not loaded
* Replace eventlet-based raw socket client with requests
* Add a tool for reserving migration placeholders during release time
* libvirt: check for interface when detach\_interface fails
* libvirt: implement LibvirtConfigGuestInterface.parse\_dom
* Filter APIs out from services list
* Config options: centralize options in conductor api
* Improve the help text for cells options (1)
* VMware: add release notes for the limits
* Get a ReqSpec in evacuate API and pass it to scheduler
* Fixes cells py3 unit tests
* Fixes network py3 unit tests
* Fixes Python 3 unit tests for nova.compute
* Add new test\_rebuild\_instance\_with\_volume to cells exclude list
* Add some obvious detail to nw\_info warning log
* Fix fallocate test on newer util-linux
* Remove \_create\_local function
* Trivial logic cleanup in libvirt pre\_live\_migration
* Return HTTP 400 for invalid server-group uuid
* Properly inject network\_data.json in configdrive
* enginefacade: remove 'get\_session' and 'get\_api\_session'
* enginefacade: 'request\_spec' object
* Add new API to force live migration to complete
* Add new DB API method to retrieve migration for instance
* Imported Translations from Zanata
* Updated from global requirements
* Sync L3Driver, NullL3 interface with LinuxNetL3
* Top 100 slow tests: api.openstack.compute.test\_api
* Top 100 slow tests: api.openstack.compute.test\_versions
* Top 100 slow tests: legacy\_v2.test\_servers
* Top 100 slow tests: api.openstack.compute.test\_flavor\*
* Top 100 slow tests: api.openstack.compute.test\_image\_size
* Top 100 slow tests: api.openstack.compute.test\_volumes
* Confusing typo fixed
* doc: all\_tenants query option incorrectly identified as non-admin
* Update driver support matrix for Ironic
* parametrize max\_api\_version in tests
* libvirt: Race condition leads to instance in error
* Avoid lazy-loads in metadata requests
* Join flavor when re-querying instance for floating ip association
* Allow all api\_samples tests to be run individually
* Make os-instance-action read deleted instances
* enginefacade: 'flavor'
* Updated from global requirements
* Use instance hostname for Neutron DNS
* libvirt: Make behavior of os\_require\_quiesce consistent
* Split-network-plane-for-live-migration
* Database not needed for most cells messaging tests
* libvirt: use osinfo when configuring the disk bus
* libvirt: use osinfo when configuring network model
* Database not needed for test class: ConsoleAPITestCase
* Database not needed for test class: ConductorImportTest
* virt: adjusting the osinfo tests to use fakelibosinfo
* Database not needed for RPC serializer tests
* Database not needed for most crypto tests
* Database not needed for most nova manage tests
* ebtables/libvirt workaround
* Test that new tables don't use soft deletes
* Use instance in setup\_networks\_on\_host
* enginefacade: test\_db\_api cleanup, missed decorators
* Database not needed for test class: PciGetInstanceDevs
* Add test coverage to functional api tests \_compare\_result method
* Remove and deprecate conductor provider\_fw\_rule\_get\_all()
* Remove prelude from disk-weight-sch reno
* Enable volume operations for shelved instances
* Gracefully handle a deleting instance during rebuild
* remove the unnecessary parem of set\_vm\_state\_and\_notify
* tests: adding fake libosinfo module
* config options: Centralise 'vnc' options
* config options: Make noVNC proxy into vnc group
* Improve 'pci' conf options documentation
* config options: centralize section "wsgi"
* libvirt: deprecate live/block\_migration\_flag opts
* Tidy up scheduler\_evolution.rst
* config options: add hacking check for help text length
* xrange() is renamed to range() in Python 3
* Do not use "file" builtin, but "open" instead
* Fix some word spellings in messages
* No need to have ironicclient parameter in methods
* Add a TODO to make ComputeNode.cpu\_info non-nullable
* Fix missing marker functions in nova/pci
* Adding volume operations for shelved instances
* Optimize Instance.create() for optional extra fields
* Optimize servers path by pre-joining numa\_topology
* Trivial: Remove a duplicated word
* Update the home-page
* Add better help text to scheduler options (5)
* Switch to oslo.cache lib
* Remove all remaining references to Quantum
* doc: remove detail about extensions
* Add description for trigger crash dump
* Object: Give more helpful error message in TestServiceVersion
* Spread allocations of fixed ips
* Updated from global requirements
* Stop using mox (scheduler)
* Fix xvpvncproxy config path when running n-xvnc
* Optimize the instance fetched by floating\_ips API
* Improve efficiency of Migration.instance property
* Prevent \_heal\_instance\_info\_cache() periodic lazy-loads
* Revert "Added new scheduler filter: AggregateTypeExtraSpecsAffinityFilter"
* Remove unused provider firewall rules functionality in nova
* enginefacade: 'instance\_tags'
* Apply scheduler limits to Exact\* filters
* Fix typos in nova/scheduler and nova/virt
* Replace exit() by sys.exit()
* Trivial: Fix a typo in test\_policy.py
* neutronv2: Allow Neutron to specify OVS/LB bridge
* HyperV: do not log twice with different level
* Replace stubs.Set with stub\_out (db)
* Add a disk space weight-based scheduler
* Fix up live-migration method docstrings
* Libvirt: Support ovs fp plug in vhostuser vif
* xenapi: simplify swap\_xapi\_host()
* Allow sending the migrate data objects over the wire
* Added new scheduler filter: AggregateTypeExtraSpecsAffinityFilter
* Replace "all\_mappings" variable by "block\_device\_mappings"
* Add better help text to scheduler options (4)
* Migrate from keystoneclient to keystoneauth
* fast exit dhcpbridge on 'old'
* Ironic: Lightweight fetching of nodes
* Fix RequestSpec \_from\_db\_object
* doc:Ask reviews to reject new legacy notifications
* Generate doc for versioned notifications
* doc: add devref about versioned notifications
* Adds json sample for the versioned notifications
* relocate os\_compute\_api:servers:discoverable
* libvirt: convert to use instance.image\_meta property
* Updated from global requirements
* doc: fix malformed api sample
* Persist the request spec during an instance boot
* Revise the compute\_upgrade\_levels\_auto release note
* Adding guard on None value for some helpers method
* Return HTTP 400 if volume size is not defined
* API: Rearrange HTTPBadRequest raising in \_resize
* remove the wrong param of fake\_db\_migration initiation
* Enable all extension for server PUT API sample tests
* Config options: centralize options in availability\_zones
* We now require gettext for dev environments
* Revert "Pass host when call attach to Cinder"
* update feature support matrix documentation
* Config options: centralize section "cells"
* Use uuidsentinel in host\_status test
* remove not used tpl
* Return 409 instead of 503 when cidr conflict
* releasenotes: Note on CPU thread pinning support
* Use extra\_data\_func to get fingerprints of objects
* Use stevedore for scheduler driver
* Use stevedore for scheduler host manager
* Enables conductor py3 unit tests
* REST API changes for user settable server description
* Use get\_notification\_transport() for notifications
* Stop using stubs.Set in vmwareapi unit tests
* Add tests for nova.rpc module
* libvirt: check min required qemu/kvm versions on ppc64/ppc64le
* VMware: Handle image size correctly for OVA and streamOptimized images
* enginefacade: 'instance\_group'
* enginefacade: 'floating\_ip'
* enginefacade: 'compute\_node'
* enginefacade: 'service'
* Hyper-V: Trace original exception before converting exception
* Fixed incorrect names/comments for API version 2.18
* Remove mox from tests/unit/objects/test\_keypair.py
* API: Remove unexpected from errors get\_console\_output
* Updated from global requirements
* Fix docstrings for sphinx
* Make project\_id optional in v2.1 urls
* remove not used tpl file
* Log retries at INFO level per guidelines
* make logic clearer about template selection
* Add ITRI DISCO os-brick connector for libvirt
* Fix misleading comment of pci\_stats
* cleanup: remove python 2.6 compat assertNotIsInstance
* Add better help text to scheduler options (3)
* (lxc) Updated regex to ignore failing tests
* Add better help text to scheduler options (2)
* Add better help text to scheduler options (1)
* Note in HypervisorSupportMatrix for Libvirt/LXC shutdown kernel bug
* Ceph for live-migration job
* enginefacade: 'security\_group'
* enginefacade: 'instance'
* enginefacade: 'fixed\_ip'
* enginefacade: 'quota' and 'reservation'
* Python3: Replace dict.iteritems with six.iteritems
* Updated from global requirements
* Object: Fix wrong usage migrate\_data\_obj
* \_can\_fallocate should throw a warning instead of error
* VMware: no longer convert image meta from dict to object
* cleanup: add comments about the pre/post extension processing
* cleanup: remove custom serializer support
* Add description for server query
* remove docs about format extensions
* Remove catching of ComputeHostNotFound exception
* Return empty object list instead []
* cleanup: remove configurable action\_peek
* libvirt: use native AIO mode for cinder volumes
* libvirt: use native AIO mode for image backends
* Issue an info log msg when port quota is exceeded
* Validate translations
* Imported Translations from Zanata

13.0.0.0b2
----------

* doc: add client interactive guideline for microversions
* doc: add version discovery guideline in api concept doc
* doc: completes microversion use-cases in api concept doc
* Fix indents of servers-detail-resp.json
* libvirt: make snapshot use RBD snapshot/clone when available
* Improve the help text for the cert options
* cleanup: remove infrastructure for content/type deserializer
* Pass host when call attach to Cinder
* Pass attachment\_id to Cinder when detach a volume
* libvirt: Fix/implement revert-resize for RBD-backed images
* Added super() call in some of the Model's child
* enginefacade: 'ec2\_instance' and 'instance\_fault'
* cleanup: collapse wsgi serializer test hierarchy
* Add service status notification
* cleanup: remove wsgi serialize/deserialize decorators
* enginefacade: 'block\_device\_mapping'
* Fix invalid import order
* Add a REST API to trigger crash dump in an instance
* libvirt: adding a class to retrieve hardware properties
* virt: introduce libosinfo library to set hardware policy
* pci: changing the claiming and allocation logic for PF/VF assignment
* pci: store context when creating pci devices
* Make emitting versioned notifications configurable
* Add infra for versioned notifications
* Make sure that we always have a parent\_addr set
* change set\_stubs to use stub\_out in vmwareapi/stubs.py
* Add note to ComputeNode.numa\_topology
* Reno for lock policy
* Clean up nova/conf/scheduler.py
* Reno for Xen rename
* config options: Make xvp proxy into vnc group
* XenAPI: Fix race on rotate\_xen\_guest\_logs
* Add exception handling in \_cleanup\_allocated\_network
* hardware: check whether realtime capable in API
* Remove releasenotes/build between releasenotes runs
* Add python3\* packages to development quickstart guide
* Make sure full stack trace is logged on RT update failure
* Changed filter\_by() to filter() during filtering instances in db API
* config options: Centralise PCI options
* HyperV: Set disk serial number for attached volumes
* Use "regex" of StrOpt to check option "port\_range"
* enable uefi boot
* VMware: convert to use instance.image\_meta property
* Config drive: convert to use instance.image\_meta property
* Use of six.PY3 should be forward compatible
* Add host\_status attribute for servers/detail and servers/{server\_id}
* Revert "Workaround reno reverts by accepting warnings"
* Adds relase notes for soft affinity feature
* libvirt: handle migrate\_data as object in cleanup method
* Create filter\_properties earlier in boot request
* Parse availability\_zone in API
* Add object and database support for host\_status API
* Workaround reno reverts by accepting warnings
* ports & networks gather should validate existance
* objects: add virtual 'image\_meta' property to Instance object
* compute: convert manager to use nova.objects.ImageMeta
* Replace stubs.Set with stub\_out (os)
* Fix Mock assert\_called\_once\_with() usage
* ServerGroupsV213SampleJsonTest should actually test v2.13
* Move config options from nova/cert directory
* Remove dead code from reserve\_block\_device\_name rpcapi
* Adapt the code to the new get\_by\_volume BDM functions
* Fix undetected races when getting BDMs by volume id
* Fix instance not destroyed after successful evacuation
* Use TimeFixture from oslo\_utils in functional tests
* Fix indexing of dict.keys() in python3
* libvirt: add a new live\_migration\_tunnelled config
* libvirt: force config related migration flags
* libvirt: force use of direct vs p2p migration
* libvirt: force use/non-use of NON\_SHARED\_INC flag
* libvirt: parse live migration flags at startup
* enginefacade: 'aggregate'
* Add helper shim for getting items
* hacking: check for common double word typos
* Fix backing file detection in libvirt live snapshot
* trivial: Add additional logs for NUMA scheduling
* Add 'hw:cpu\_threads\_policy=isolate' scheduling
* Replaces itertools.izip with six.moves.zip
* Clean up network resources when reschedule fails
* Replace stubs.Set with stub\_out (fakes)
* Add maximum microversions for each releases
* Remove "or 'reserved'" condition from reserve\_block\_device\_name
* live-migration hook ansible 2.0 compaitability
* update min tox version to 2.0
* pci: adding support to specify a device\_type in pci requests
* Block flaky python34 test : vmwareapi.test\_configdrive.ConfigDriveTestCase
* Actually pass the migration data object down to the virt drivers
* nova conf single point of entry: fix error message
* Fix sphinx warnings from signature\_utils
* Sets binding:profile to empty dic when unbinding port
* Use timedelta.total\_second instead of calculating
* Use stub\_out and mock to remove mox:part 3
* Replaces \_\_builtin\_\_ with six.moves.builtins
* Remove mm-ctl from network.filters
* Add mm-ctl to compute.filters
* Add reviewing point related to REST API
* Stop using mox stubs in nova.tests.unit.console
* pci: do not filter out any SRIOV Physical Functions
* objects: update the old location parent\_addr only if it has value
* Add xenapi support for XenapiLiveMigrateData objects
* Fixes Hyper-V unit tests for latest os\_win release
* Add 'hw:cpu\_thread\_policy=require' scheduling
* add "hw\_firmware\_type" image metadata
* Docstring change for consistency
* Add tests for metadata functions
* libvirt: fix TypeError calling \_live\_migration\_copy\_disk\_paths
* Add DiskFormat as Enum in fields
* Remove DictCompat from EC2 objects
* Remove DictCompat from DNSDomain
* Add description on how to run ./run\_test.sh -8
* Propagate qemu-img errors to compute manager
* Change assertEqual(True/False) to assertTrue/False
* objects: adding a parent\_addr field to the PciDevice object
* Add caching of service\_min\_versions in the conductor
* Scheduler: enforce max attempts at service startup
* Fix unit tests on Mac OS X
* Stop using mox stubs in nova.tests.unit.api.openstack.compute.test\_services
* libvirt: add discard support for attached volumes
* Remove DictCompat from CellMapping
* Remove NovaObjectDictCompat from Aggregate
* XenAPI: Cope with more Cinder backends
* single point of entry for sample config generation
* Remove Deprecated EC2 and ObjectStore impl/tests
* libvirt: add realtime support
* Imported Translations from Zanata
* libvirt: update to min required version to 0.10.2
* Remove null AZ tests from API tests
* Replace stubs.Set with stub\_out (functional tests)
* Updated from global requirements
* doc: minor corrections to the API version docco
* Refactor \_load\_support\_matrix
* Fix format conversion in libvirt snapshot
* Fix format detection in libvirt snapshot
* api: add soft-affinity policies for server groups
* scheduler: fill RequestSpec.instance\_group.members
* scheduler: add soft-(anti-)affinity weighers
* Implements proper UUID format for compute/test\_stats\*
* Add image signature verification
* Convert nova.tests.unit.image.fake.stub\_out\_image\_service to use stub\_out
* Block more flaky py34 tests
* Replace deprecated library function os.popen() with subprocess
* Remove mox and Stubs from tests/unit/pci/test\_manager.py
* Correct the code description
* Fix advice for new contribs
* libvirt: better error for bad live migration flag
* Add argument to support-matrix sphinx extension
* Wrong URL reported by the run\_tests.sh message
* Make use of 'InstanceNUMACell.cpu\_policy' field
* Add 'cpu\_policy' and 'cpu\_thread\_policy' fields
* Add 'CPUThreadAllocationPolicy' enum field
* Blacklist flaky tests and add warning
* Modify Scheduler RPC API to use RequestSpec obj
* Implements proper UUID format for test\_compute\_mgr
* Remove get\_lock method and policy action
* libvirt: sort block\_device\_list in volume\_in\_mapping log
* Stop explicitly running test discovery for py34
* introduce \`\`stub\_out\`\` method to base test class
* Cleanup NovaObjectDictCompat from security\_group\_rule
* Remove useless header not need microversion
* Implements proper UUID format for test\_compute
* Move Process and Mentoring pages to devref
* Document restrictions for working on cells v1
* api-guide: add a doc on users
* Assignment (from method with no return) removed
* remove use of \_get\_regexes in samples tests
* Improve 'virt' conf options documentation
* config options: Centralise 'virt.hardware' options
* Get list of disks to copy early to avoid multiple DB hits
* Remove non-unicode bind param warnings
* Fix typo, ReST -> REST
* Wrong spelling of defined
* libvirt: fix typo in test\_init\_host\_migration\_flags
* docs: update refs to mitaka release schedule
* doc: add how to arrange order of scheduler filters
* libvirt: only get instance.flavor if needed in get\_disk\_mapping
* Replace backtick with apostrophe in lazy-loading debug log
* libvirt: fix TypeError in find\_disk\_dev\_for\_disk\_bus
* Fix RPC revision log entry for 4.6
* signature\_utils: move to explicit image metadata
* Unreference mocks are listed in the wrong order
* remove API v1.1 from testing
* remove /v1.1 from default paste.ini
* libvirt: verify cpu bw policy capability for host
* Implements proper UUID format for test\_compute\_cells and test\_compute\_utils
* Add the missing return value in the comment
* Updated from global requirements
* xen: block BootableTestCase from py34 testing
* Modify conductor to use RequestSpec object
* db: querry to retrieve all pci device by parent address
* db: adding columns to PciDevice table
* Replace except Exception with specific exception
* pci: minor fix to exception message format
* Python 3 deprecated the logger.warn method in favor of warning
* Check added for mandatory parameter size in schema
* Remove redundant driver initialization in test
* enginefacade: 'instance\_metadata'
* Misspelling in messages
* Add lock to host-state consumption
* Add lock to scheduler host state updating
* Allow virt driver to define binding:host\_id
* [python3] Webob request body should be bytes
* Replace copy.deepcopy of RequestContext with copy.copy
* DriverBlockDevice must receive a BDM object, not a dict
* Misspelling in message
* Wrong usage of "a"
* Remove unused logging import and LOG global var
* Reduce the number of db/rpc calls to get instance rules
* Use is\_supported() to check microversion
* SameHostFilter should fail if host does not have instances
* VMware: add method for getting hosts attached to datastore
* Trivial: Fix wrong comment in service version
* signature\_utils: handle ECC curve unavailability
* Updated from global requirements
* tests: Remove duplicate check
* enginefacade: 'bw\_usage', 'vol\_usage' and 's3\_image'
* VMware: improve instance names on VC
* VMware: add in folder support on VC
* VMware: cleanup unit test global variable
* signature\_utils: refactor the list of ECC curves
* Nuke EC2 API from api-paste and remove wsgi support
* Remove cruft for things o.vo handles
* Make scheduler\_hints schema allow list of id
* Change logging level for 'oslo\_db'
* Remove unused compute\_api in ServerUsageController
* network: Don't repopulate instance info cache from Neutron ports
* Fix doc comment for get\_available\_resource
* objects: lazy-load instance.security\_groups more efficiently
* VMware: cleanup unit tests
* Use SpawnIsSynchronousFixture in most unit tests
* Use stub\_out and mock to remove mox: part 1
* Disable the in tree EC2 API by default
* deprecate old glance config options
* remove temporary GlanceEndpoint object
* convert GlanceClientWrapper to endpoint
* Use stub\_out and mock to remove mox: part 2
* Add a compute API to trigger crash dump in instance
* Make libvirt driver return migrate data objects for source and dest checks
* Use TimeFixture from oslo\_utils to override time in tests
* enginefacade: 'vif' and 'task\_log'
* review guide: add location details for config options
* libvirt: wrapper list\_guests to Host's object
* remove vestigial XML\_NS\_V11 variable
* remove unused EXTENSION\_DESERIALIZE\_\* constants
* config options: Centralise 'virt.ironic' options
* remove unused pipeline\_factory\_v3 alias
* remove unused methods from integrated\_helpers test class
* remove unused extends\_name attribute
* Add upload/download vhd2 interfaces
* Replace unicode with six.text\_type
* conductor: fix unbound local variable request\_spec
* Use just ids in all request templates for flavors/images
* extract non instance methods
* remove unused trigger\_handler
* remove unused update\_dhcp\_hostfile\_with\_text method
* remove nova-cert from most functional tests
* enginefacade: 'migration'
* XenAPI: Fix race in rotate\_xen\_guest\_logs
* libvirt: introduce "pause" to Guest's object
* libvirt: introduce "shutdown" to Guest's object
* libvirt: introduce "snapshot" to Guest's object
* libvirt: introduce thaw filesystems
* libvirt: introduce freeze filesystems
* libvirt: replace direct libvirt's call AbortJobBlock
* Allow to update 'v2.1' links in sample files
* Do not update links for 'versions' tests
* centeralized conf:compute/emphemeral\_storage\_encryption
* Add instance.save() when handling reboot in init instance
* Add transitional support for migrate data objects to compute manager
* Implements proper UUID format for few objects tests
* Filter by leased=False when allocating fixed IPs
* Increase informations in nova-net warnings
* docs: add concept guide for certificate
* Fix reclaim\_instance\_interval < 0 never delete instance completely
* Updated from global requirements
* Add placeholders for config options
* Implements proper UUID format for the fake\_network
* Refresh stale volume BDMs in terminate\_connection
* Block requests 2.9.0
* Implements proper UUID format for the test\_compute\_api
* Remove onSharedStorage from evacuate API
* Fix CPU pinning for odd number of CPUs w hyperthreading
* hardware: stop using instance cell topology in CPU pinning logic
* Check context before returning cached value
* deprecate run\_tests.sh
* remove archaic references to XML in api
* simplify the request / response format document
* Add signature\_utils module
* Remove XML description from extension concept
* remove ctype from classes
* Remove cells service from api samples that don't test cells
* Add uuidsentinel test module
* Remove the wrong usage of api\_major\_version in api sample tests
* Updated from global requirements
* Fix wrong method name in doc filter\_scheduler
* doc: update threading.rst
* Makes GET extension info sample tests run for v2 also
* update api\_samples code to use better variables
* Remove incorrect comments about file injection
* Remove a restriction on injection files
* Remove unnecessary log when search servers
* Deprecated tox -downloadcache option removed
* rework warning messages for extension whitelist/blacklist
* Make sure bdm.volume\_id is set after auto-creating volumes
* Replace safe\_utils.getcallargs with inspect.getcallargs
* Fix wrap\_exception to get all arguments for payload
* Add hypervisor, aggregates, migration description
* retool xen glance plugin to work with urls
* always create clients with GlanceEndpoint
* Implement GlanceEndpoint object
* Clean up glance url handling
* Use RequestSpec in the ChanceScheduler
* Modify left filters for RequestSpec
* Modify NUMA, PCI and num\_instances filters for RequestSpec
* Improve inject\_nmi() in libvirt driver and add tests
* Report compute-api bugs against nova
* XenAPI: Expose labels for ephemeral disks
* Fix use of safeutils.getcallargs
* Cache SecurityGroupAPI results from neutron multiplexer
* Remove the executable bit from several python files
* Optimize \_cleanup\_incomplete\_migrations periodic task
* [Py34] api.openstack.compute.legacy\_v2.test\_servers.Base64ValidationTest
* [Py34] api.openstack.test\_faults.TestFaultWrapper
* [Py34] Enable api.openstack.test\_wsgi unit test
* default host to service name instead of uuid
* Remove start\_service calls from the test case
* Add SIGHUP handlers for compute rpcapi to console and conductor
* Cache the automatic version pin to avoid repeated lookups
* virt: allow for direct mounting of LocalBlockImages
* Use testscenarios to set attributes directly
* update API samples to use endpoints
* Updated from global requirements
* Add project-id and user-id when list server-groups
* Fixes Python 3 compatibility for filter results
* Remove duplicate default=None for option compute\_available\_monitors
* Disable IPv6 on bridge devices
* Don't load deleted instances
* Improve Filter Scheduler doc clarity
* libvirt: report pci Type-PF type even when VFs are disabled
* Remove deprecated neutron auth options
* Fix capitalization of IP
* Add separated section for configure guest os
* Add separated section for extra specs and image properties
* Add a note about fixing "db type could not be determined" with py34
* neutron: skip test\_deallocate\_for\_instance\_2\* in py34 job
* tighten regex on objectify
* Replace os.path.join() for URLs
* Add hv testing for ImageMetaProps.\_legacy\_property\_map
* Edit the text to be more native-English sounding
* docs: add test strategy and feature classification
* Fix the endpoint of /v2 on concept doc
* Drop JSON decoding for supported\_instances
* docs: update old stuff in version section
* Scheduler: honor the glance metadata for hypervisor details
* Implements proper UUID format for the ComputeAPITestCase
* docs: add microversions description in the concept doc
* Make admin consistent
* Add more concepts for servers
* Make "ReSTful service" consistent
* Add retry logic for detaching device using LibVirt
* Fix Exception message consistency with input protocol
* Remove SQLite BigInteger/Integer translation logic
* xen: Drop JSON for supported\_instances
* vmware: Drop JSON for supported\_instances
* ironic: Drop JSON for supported\_instances
* hyperv: Drop JSON for supported\_instances
* libvirt: Drop JSON for supported\_instances
* Drop JSON for stats in virt API
* Replaces izip\_longest with six.moves.zip\_longest
* Fixes dict keys and items references for Python 3
* Scheduler: correct control flow when forcing host
* Replaces longs with ints
* neutron: only get port id when listing ports in validate\_networks
* neutron: only list ports if there is a quota limit when validating
* Add reviewing point related to REST API
* Revert "Enable options for oslo.reports"
* Fix wrong CPU metric value in metrics\_filter
* Reset the compute\_rpcapi in Compute manager on SIGHUP
* Remove the unused sginfo rootwrap filter
* docs: ensure third party tests pass before +2
* Config options: centralize section "scheduler"
* add api-samples tox target
* Remove Instance object flavor helper methods only used in tests
* Remove unnecessary extra instance saves during resize
* docs: using the correct format and real world example for fault message
* VMware: cleanup ExtraSpecs
* Remove HTTPRequestEntityTooLarge usage in test
* Enables py3 unit tests for libvirt.host module
* Replaces \_\_builtin\_\_ with six.moves.builtins
* Converting nova.virt.hyperv to py3
* Hyper-V: removes \*Utils modules and unit tests
* docs: update services description for concept guide
* docs: remove duplicated section about error handling
* Remove Useless element in migrate\_server shcema
* Optimize "open" method with context manager
* trivial: Add some logs to 'numa\_topology\_filter'
* Updated from global requirements
* Docs: update the concept guide for Host topics
* Cleanup of compute api reboot method
* Hyper-V: adds os-win library
* Remove description about image from faults section
* api-guide: add note about users
* Updated from global requirements
* xenapi: Add helper function and unit tests for client session
* Config options: centralize section "scheduler"
* Ironic: Workaround to mitigate bug #1341420
* Libvirt: Support fp plug in vhostuser vif
* Remove version from setup.cfg

13.0.0.0b1
----------

* Add note for automatic determination of compute\_rpc version by service
* Add note for Virtuozzo supporting snapshots
* Add note for HyperV 2008 drop of support
* Imported Translations from Zanata
* Add note for removing conductor RPC API v2
* Add note for dropping InstanceV1 objects
* Add note for force\_config\_drive opt change
* Add note for deprecating local conductor
* Revert "Detach volume after deleting instance with no host"
* force releasenotes warnings to be treated as errors
* Fix reno warning for API DB relnote
* Adding a new vnic\_type for Ironic/Neutron/Nova integration
* Use o.vo DictOfListOfStringsField
* libvirt: remove todo note not useful anymore
* Modify metric-related filters for RequestSpec
* Modify default filters for RequestSpec
* servicegroup: stop zombie service due to exception
* Add persistence to the RequestSpec object
* Updated from global requirements
* add hacking check for config options location
* Correct some nits for moving servers in concept doc
* use graduated oslo.policy
* TrivialFix: remove 'deleted' flag
* Make server concept guide use 'server' consistently
* api-guide: fix up navigation bar
* Use version convert methods from oslo\_utils.versionutils
* docs: reorder move servers text
* docs: add clarifications to move servers
* Change some wording on server\_concepts.rst
* Cleanup unused test code in test\_scheduler.py
* Modify Aggregate filters for RequestSpec
* Add code-review devref for release notes
* Hyper-V: refines the exceptions raised in the driver
* Use o.vo FlexibleBooleanField
* docs: describe migration and other movement concepts
* Double 'an' in message
* Unify on \_schedule\_instances
* Add review guideline to microversion API
* Remove the TestRemoteObject class
* Catch FixedIpNotFoundForAddress when create server
* doc: add server status to concept.rst
* docs: update the concept guide shelve actions
* Fixed incorrect name of 'tag' and 'tag-any' filters
* Fix resource tracker VCPU counting
* Add relnote for change in default setting
* use NoDBTestCase for KeypairPolicyTest
* doc: change policies.rst to indicate API links
* Remove useless code in \_poll\_volume\_usage function
* Neutron: add logging context
* Remove unused param of CertificatesController
* Add user data into general concept
* Fix a typo in api-guide doc
* Make some classes inherit from NoDBTestCase
* XenAPI: Workaround for 6.5 iSCSI bug
* NFS setup for live-migration job
* Fix ebtables-version release note
* config options: enhance help text of section "serial\_console"
* Updating nova config-reference doc
* Updated from global requirements
* Prevent redundant instance.update notifications
* VMware: fix docstring for cluster management
* api: remove re-declared type in migrate schema
* enginefacade: 'agent' and 'action'
* config options: centralize section "serial\_console"
* Replaced private field in get\_session/engine with public method
* SR-IOV: Improve the vnic type check in the neutron api
* Simplified boolean variable check
* update connect\_volume test
* Enable options for oslo.reports
* Reverse sort tables before archiving
* scheduler: fix incorrect log message
* Updated from global requirements
* Add release note for API DB migration requirements
* Replaced deprecated timeutils methods
* Multinode job for live-migration
* Use o.vo VersionPredicateField
* Use flavor instead of flavour
* Corrected few grammatical nitpics
* Add more 'actions' for server concepts doc
* libvirt: mlnx\_direct vif type removal
* xen: mask passwords in volume connection\_data dict
* Updated from global requirements
* Use --concurrent with ebtables
* Removed extra spaces from double line strings
* Change test function name to make more sense
* Change Invalid exception to a specified exception
* Add 'lxd' to the list of recognized hypervisors
* Add microversions schema unit test for None
* Clean up legacy multi-version test constructs
* Fix Nova's indirection fixture override
* Remove skips for resize tests from tempest-dsvm-cells-rc
* Modify Affinity filter for RequestSpec
* Prepare filters for using RequestSpec object
* Use ServiceList object rather than direct db call
* Add relnote for ERT deprecation
* Remove IN-predicate warnings
* docs: update the API faults concept guide
* Deprecate nova-manage service subcommand
* Double detach volume causes server fault
* Use JSON format instead of json format
* Network: add in missing translation
* cells is a sad panda about scheduler hints
* VMware: expand support for Opaque networks
* Fix is\_volume\_backed\_instance() for unset image\_ref
* Add \_LE to LOG.error statement in nova/service
* Add service records for nova-api services
* Added method is\_supported to check API microversions
* enginefacade: 'host\_mapping'
* Removes support for Hyper-V Server 2008 R2
* Fix the bug of "Error spelling of 'explicitely'"
* Claims: fix log message
* Fix paths for api-guide build
* Remove flavors.get\_flavor() only used in tests
* VMware: Raise DiskNotFound for missing disk device
* Remove two unneeded db lookups during delete of a resizing instance
* Fix pci\_stats logging in resource tracker
* live-mig: Mark migration as failed on fail to schedule
* Move the Migration set-status-if-exists pattern to a method
* Don't track migrations in 'accepted' state
* live-migrate: Change the status Migration is created with
* compute: split check\_can\_live\_migrate\_destination
* Replace N block\_device\_mapping queries with 1
* Add "unreleased" release notes page
* Add reno for release notes management
* XenAPI: Correct hypervisor type in Horizon's admin view
* Fix typo in test\_post\_select\_populate
* Rearranges to create new Compute API Guide
* Added CORS support to Nova
* Aggregate Extra Specs Filter should return if extra\_specs is empty
* cells: skip 5 networking scenario tests that use floating IPs
* force\_config\_drive: StrOpt -> BoolOpt
* Updated from global requirements
* Add test coverage for both types of not-found-ness in neutronclient for floating
* Fix impotent \_poll\_shelved\_instances tests
* Fix race in \_poll\_shelved\_instances task
* Handle a NeutronClientException 404 Error for floating ips
* Handle DB failures in servicegroup DB driver
* Hook for live-migration job
* Omit RescheduledException in instance\_fault.message
* Remove duplicate server.kill on test shutdown
* make the driver.Scheduler as abstract class
* Fix a spelling mistake in the log
* objects: remove remote\_object\_calls from \_BaseTestCase
* Repair and rename test\_is\_volume\_backed\_instance\_no\_bdms()
* Use ObjectVersionChecker fixture from oslo.versionedobjects
* VMware: add in vif resource limitations
* Untie subobject versions
* Block oslo.messaging 2.8.0
* Split up test\_is\_volume\_backed\_instance() into five functions
* Avoid the dual-naming confusion
* enginefacade: 'provider\_fw', 'console\_pool' and 'console'
* enginefacade: 'network'
* clean up regex in tempest-dsvm-cells-rc
* skip lock\_unlock\_server test for cells
* ScalityVolume:fix how remote FS mount is detected
* OpenStack typo
* Remove duplicate keys in policy.json
* Add missing policy rules
* devref:Don't suggest decorate private method
* VMware: use a constant for 'iscsi'
* Config drive: make use of an instance object
* Fix attibute error when cloning raw images in Ceph
* Properly log BlockDeviceMappingList in \_create\_block\_device\_mapping
* Exclude all BDM checks for cells
* glance:add helper method to get client version
* enginefacade: 'dnsdomain' and 'ec2'
* enginefacade: 'certificate' and 'pci\_device'
* enginefacade: 'key\_pair' and 'cell'
* enginefacade: 'instance\_mapping'
* enginefacade: 'cell\_mapping'
* enginefacade: 'instance\_info' and 'instance\_extra'
* Use EngineFacade from oslo\_db.enginefacade
* VMware: fix trivial indentations
* Remove flavors.get\_all\_flavors() only used in tests
* Make lock policy default to admin or owner
* libvirt:Fix a typo of test cases
* Deprecate local conductor mode
* Deprecate Extensible Resource Tracker
* Change image to instance in comment
* VMware: use oslo\_config new type PortOpt
* Remove vcpu resource from extensible resource tracker
* Add logging to snapshot\_volume\_backed method
* Remove unnecessary destroy call from Ironic virt driver
* cells: add debug logging to bdm\_update\_or\_create\_at\_top
* Drop Instance v1.x support
* Check prefix with startswith() instead of slicing
* Add debug logging for when boot sequence is invalid in \_validate\_bdm
* remove the redundant policy check for SecurityGroupsOutputController
* virt: add constraint to handle realtime policy
* libvirt: add cpu schedular priority config
* libvirt: rework membacking config to support future features
* Do not mask original spawn failure if shutdown\_instance fails
* Point to cinder options in nova block alloc docs
* Fix booting fail when unlimited project quota
* Remove useless get\_instance\_faults()
* Remove "Can't resolve label reference" warnings
* Remove reservation\_id from the logs when a schedule fails
* Use RequestSpec object in HostManager
* Use RequestSpec object in the FilterScheduler
* Add ppcle architectures to libvirt blockinfo
* Deprecated: failIf
* Imported Translations from Zanata
* Remove obj\_relationships from objects
* Delete dead test code
* Add tempest-dsvm-lxc-rc
* Mark set-admin-password as complete for libvirt in support matrix
* Hypervisor support matrix: define pause & unpause
* Revert "Implement online schema migrations"
* Fix the os-extended-volumes key reference in the REST API history docs
* Remove get\_all method from servicegroup API
* Remove SoftDeleteMixin from NovaBase
* libvirt: support snapshots with parallels virt\_type
* Use oslo.config choices kwarg with StrOpt for servicegroup\_driver
* Imported Translations from Zanata
* Add -constraints sections for CI jobs
* Add "vnc" option group for sample nova.conf file
* Updated from global requirements
* Expands python34 unit tests list
* Fix missing obj\_make\_compatible() for ImageMetaProps object
* Fix error handling in nova.cmd.baseproxy
* Change 'ec2-api' stackforge url to openstack url
* Fixes Python 3 str issue in ConfigDrive creation
* Revert "Store correct VirtCPUTopology"
* Enable all extension for image API sample tests
* Add tags to .gitignore
* Updated from global requirements
* Add a nova functional test for the os-server-groups GET API with all\_projects parameter
* Image meta: treat legacy vmware adapter type values
* Attempt rollback live migrate at dest even if network dealloc fails
* hacking check for contextlib.nested for py34 support
* Print number of rows archived per table in db archive\_deleted\_rows
* Updated from global requirements
* Fix more inconsistency between Nova-Net and Neutron
* Fix metadata service security-groups when using Neutron
* Remove redundant deps in tox.ini
* Add some tests for map\_dev
* Clean up tests for dropping obj\_relationships
* Fix up Service object for manifest-based backports
* Fix service\_version minimum calculation for compute RPC
* docs: add the scheduler evolution plans
* Revert "virt: Use preexec\_fn to ulimit qemu-img info call"
* Updated from global requirements
* Ensure Glance image 'size' attribute is 0, not 'None'
* Ignore errorcode=4 when executing \`cryptsetup remove\` command
* libvirt: Don't attempt to convert initrd images
* Revert "Fixes Python 3 str issue in ConfigDrive creation"
* Monkey patch nova-ec2 api
* Compute: remove unused parameter

12.0.0
------

* Omnibus stable/liberty fix
* Drop outdated sqlite downgrade script
* Updated from global requirements
* Fix Status-Line in HTTP response
* Imported Translations from Zanata
* Default ConvertedException code to 500
* Updated from global requirements
* VMware: fix bug for config drive when inventory folder is used
* Fix a typo
* code-review guidelines: add checklist for config options
* Add a code-review guideline document
* virt: Use preexec\_fn to ulimit qemu-img info call
* Clean up some Instancev1 stuff in the tests
* Updated from global requirements
* Replaces contextlib.nested with test.nested
* Sync cliutils from oslo-incubator
* Make archive\_deleted\_rows\_for\_table private

12.0.0.0rc2
-----------

* load consoleauth\_topic option before using it
* Revert "[libvirt] Move cleanup of imported files to imagebackend"
* Add more documentation for RetryFilter
* Fix InstanceV1 backports to use context
* Imported Translations from Zanata
* Add test of claim context manager abort
* Log DBReferenceError in archive\_deleted\_rows\_for\_table
* Use DBReferenceError in archive\_deleted\_rows\_for\_table
* Add testresources used by oslo.db fixture
* Remove unused context parameter from db.archive\_deleted\_rows\* methods
* xenapi\_device\_id integer, expected string
* Fix InstanceV1 backports to use context
* Drop unused obj\_to\_primitive() override
* Updated from global requirements
* libvirt: remove unnecessary else in blockinfo.get\_root\_info
* Make test cases in test\_test.py use NoDBTest
* XenAPI: Fix unit tests for python34
* docs: re-organise the API concept docs
* VMware: specify chunk size when reading image data
* Make ConsoleauthTestCase inherit from NoDBTest
* Change a test class of consoleauth to no db test
* Imported Translations from Zanata
* Catch 3 InvalidBDM related exc when boot instance
* Move create vm states to svg diagram
* Ironic: Fix bad capacity reporting if instance\_info is unset
* Revert "[libvirt] Move cleanup of imported files to imagebackend"
* Honor until\_refresh config when creating default security group
* remove sphinxcontrib-seqdiag
* [Py34] nova.tests.unit.api.openstack.test\_common
* [Py34] Enable api.openstack.test\_mapper unit test
* [Py34] Enable test\_legacy\_v2\_compatible\_wrapper
* Extend the ServiceTooOld exception with more data
* Make service create/update fail if version is too old
* Allow automatic determination of compute\_rpc version by service
* Add get\_minimum\_version() to Service object and DB API
* Correct memory validation for live migration
* devref: change error messages no need microversion
* Replace f.func\_name and f.func\_code with f.\_\_name\_\_ and f.\_\_code\_\_
* Imported Translations from Zanata
* Add a note about the 500->404 not requiring a microversion
* Ensure Nova metrics derived from a set of metrics
* Updated from global requirements
* Fixes Python 3 str issue in ConfigDrive creation
* Make secgroup rules refresh with refresh\_instance\_security\_rules()
* Remove unused refresh\_security\_group\_members() call
* Imported Translations from Zanata
* Check DBReferenceError foreign key in Instance.save
* Fix Instance unit test for DBReferenceError
* Ironic: Fix bad capacity reporting if instance\_info is unset
* libvirt: check if ImageMeta.disk\_format is set before accessing it
* libvirt: check if ImageMeta.disk\_format is set before accessing it
* Rollback is needed if initialize\_connection times out
* Updated from global requirements
* Add Pillow to test-requirements.txt
* VMware: raise NotImplementedError for live migration methods
* xapi-tools: fixes cache cleaner script
* Cleanup of Translations
* Add Pillow to test-requirements.txt
* Update rpc version aliases for liberty
* Remove orphaned code related to extended\_volumes
* Add checkpoint logging when terminating an instance
* Add checkpoint logging when building an instance in compute manager
* Removed unused method from compute/rpcapi
* Remove unused read-only cell code
* Change warn to debug logs when migration context is missing
* Use os-testr for py34 tox target
* Add sample config file to nova docs
* Remove lazy-loading property compute\_task\_api from compute api
* Remove conductor 2.x RPC API
* Reserve 10 migrations for backports
* Use StrOpt's parameter choices to restritct option auth\_strategy
* vmware: set default value in fake \_db\_content when creating objects
* Avoid needless list copy in 'scheduler\_host\_subset\_size' case
* libvirt: Log warning for wrong migration flag config options
* Slightly better translation friendly formatting
* Identify more py34 tests that already pass
* rebuild: Apply migration context before calling the driver
* hardware: improve parse\_cpu\_spec to handle exclusion range
* Correct Instance type check to work with InstanceV1
* Imported Translations from Zanata
* Correct Instance type check to work with InstanceV1
* Only create volumes with instance.az if cinder.cross\_az\_attach is False
* Fix the help text of monkey\_patch config param
* Rollback of live-migration fails with the NFS driver
* Set TrustedFilter as experimental
* doc: gmr: Update instructions to generate GMR error reports
* rebuild: Apply migration context before calling the driver
* Fix MetricWeigher to use MonitorMetricList
* VMware: update log to be warning
* Add more help text to the cinder.cross\_az\_attach option
* Cleanup of Translations
* Revert "Deprecate cinder.cross\_az\_attach option"
* Fix some spelling typo in manual
* Fix NoneType error when calling MetricsWeigher
* wsgi: removing semicolon
* Fix logging\_sample.conf to use oslo\_log formatter
* Remove unused \_check\_string\_length()
* Deprecate cinder.cross\_az\_attach option
* Neutron: update cells when saving info\_cache
* Fix MetricWeigher to use MonitorMetricList

12.0.0.0rc1
-----------

* Imported Translations from Zanata
* Detach volume after deleting instance with no host
* Remove unnecessary call to info\_cache.delete
* Filter leading/trailing spaces for name field in v2.1 compat mode
* Give instance default hostname if hostname is empty
* If rescue failed set instance to ERROR
* Add some devref for AZs
* Change parameter name in utility function
* RT: track evacuation migrations
* rebuild: RPC sends additional args and claims are done
* Cells: Limit instances pulled in \_heal\_instances
* Open Mitaka development
* Fix order of arguments in assertEqual
* devref: update the nova architecture doc
* Imported Translations from Zanata
* Fix quota update in init\_instance on nova-compute restart
* net: explicitly set mac on linux bridge
* live-migration: Logs exception if operation failed
* libvirt: add unit tests for the designer utility methods
* Add test cases for some classes in objects.fields
* Change ignore-errors to ignore\_errors
* libvirt: fix direct OVS plugging
* claims: move a debug msg to a warn on missing migration
* Fix order of arguments in assertEqual
* Remove duplicate VALID\_NAME\_REGEX
* Pep8 didn't check api/openstack/common.py
* Updated from global requirements
* libvirt: Add unit tests for methods
* Devref: Document why conductor has a task api/manager
* Imported Translations from Zanata
* Fix nova configuration options description
* libvirt:on snapshot delete, use qemu-img to blockRebase if VM is stopped
* Allow filtering using unicode characters
* Updated from global requirements
* Imported Translations from Zanata
* Test both NoAuthMiddleware and NoAuthMiddlewareV3
* Remove redundant variable 'context'
* Add 'OS-EXT-VIF-NET:net\_id' for v21 compatible mode
* libvirt: Add NUMA cell count to cpu\_info
* Xenapi: Don't access image\_meta.id when booting from a volume
* Imported Translations from Zanata
* Fix typo in HACKING.rst
* Remove comment in wrong place
* Fix string formatting in api/metadata/vendordata\_json.py
* Raise exception.Migration earlier in REST API layer
* Remove "shelved\_image\_id" key from instance system metadata
* Only set access\_ip\_\* when instance goes ACTIVE
* VMware: fix typo in comment
* RT: Migration resource tracking uses migration context
* compute: migrate/resize paths properly handle stashed numa\_topology
* Claims: Make sure move claims create a migration context records
* libvirt:update live\_migration\_monitor to use Guest
* VMware: create method for getting datacenter from datastore
* User APIRouterV21 instead of APIRouterV3 for v2.1 unittests
* Remove TestOpenStackClientV3 from nova functional tests
* Rename all the ViewBuilderV3 to ViewBuilderV21
* libvirt: Split out resize\_image logic from create\_image
* Reuse method to convert key to passphrase
* Creating instance fail when inject ssh key in cells mode
* Fix the usage output of the nova-idmapshift command
* Make test\_revoke\_cert\_project\_not\_found\_chdir\_fails deterministic
* Reduce the number of Instance.get\_by\_uuid calls
* Remove 'v3' from comments in Nova API code
* xapi: cleanup volume sr on live migration rollback
* Hyper-V: Implements attach\_interface and detach\_interface method
* Remove unnecessary 'context' param from quotas reserve method call
* VMware: Replace get\_dynamic\_properties with get\_object\_properties\_dict
* VMware: Replace get\_dynamic\_property with get\_object\_property
* Return empty PciDevicePoolList obj instead of None
* libvirt: add debug logging for lxc teardown paths
* Add API schema for different\_cell filter
* Add microversion bump exception for scheduler-hint
* Use six.text\_type instead of str in serialize\_args
* Set vif and allocated when associating fixed ip
* Fix ScaleIO commands in rootwrap filters
* Add missing information to docstring
* Add microversion rule when adding attr to request
* Check unknown event name when create external server event
* Don't expect meta attributes in object\_compat that aren't in the db obj
* CONF.allow\_resize\_to\_same\_host should check only once in controller
* Updated from global requirements
* Fix debug log format in object\_backport\_versions()
* Add version 3.0 of conductor RPC interface
* Remove and deprecate conductor object\_backport()
* Invalidate AZ cache when the instance AZ information is different
* Consolidate code to get the correct availability zone of an instance
* Fix order of arguments in assertEqual
* Ironic: Call unprovison for nodes in DEPLOYING state
* libvirt: use guest as parameter for get serial ports
* Separate API schemas for v2.0 compatible API
* api: allow any scheduler hints
* API: Handle InstanceUnknownCell exceptions
* Updated from global requirements
* Add some explanation for the instance AZ field
* Remove 'v3' from extension code
* Remove more 'v3' references from the code
* Sorting and pagination params used as filters
* Freeze v1 Instance and InstanceList schema hashes
* Imported Translations from Transifex
* Remove unused parameter overwrite in elevated
* Add missing delete policies in the sample file
* Fix a few typos
* ironic: convert driver to use nova.objects.ImageMeta
* objects: convert config drive to use ImageMeta object
* VMware: ensure that instance is deleted when volume is missing
* libvirt:Rsync compression removed
* xenapi: Support extra tgz images that with only a single VHD
* Hyper-V: Fixes snapshoting inexistent VM issue
* Hyper-V: Adds RDPConsoleOps unit tests
*  Rectify spelling mistake in nova
* libvirt: Add a finish log
* Remove old unused baremetal rootwrap filters
* Relax restrictions on server name
* network\_request\_obj: Clean up outdated code
* Object: Fix KeyError when loading instance from db
* Add os-brick's scsi\_id command to rootwrap
* Expose keystoneclient's session and auth plugin loading parameters
* Remove and deprecate conductor compute\_node\_create()
* Drop unused conductor manager vol\_usage\_update() mock
* Add constraint target to tox.ini
* nova-net: fix missing log variable in deallocate\_fixed\_ip
* Provide working SQLA\_VERSION attribute
* Don't "lock" the DB on expand dry run
* New sensible network bandwidth quota values in Nova tests
* Fix Cells gate test by modifying the regressions regex
* Add functional test for server group
* Reject the cell name include '!', '.' and '@' for Nova API
* Hyper-V: Adds HyperVDriver unit tests
* claims: Remove compat code with instance dicts
* Add Instance and InstanceList v2.0 objects
* Teach conductor to do manifest-based object\_class\_action() things
* Make the conductor fixture use version manifests
* Update objects test infrastructure for multiple versions
* Refactor Instance tests to use objects.Instance
* Fix an issue with NovaObjectRegistry hook
* Pull out the common bits of InstanceList into \_BaseInstanceList
* Pull out the common bits of Instance into \_BaseInstance
* Clarify max\_local\_block\_devices config option usage
* Allow to use autodetection of volume device path
* Remove the blacklisted nova-cells shelve tests
* Update from global requirements
* objects: Hook migration object into Instance
* Fix order of arguments in assertEqual
* Fix order of arguments in assertEqual
* Detach and terminate conn if Cinder attach fails
* [libvirt] Move cleanup of imported files to imagebackend
* hyperv: convert driver to use nova.objects.ImageMeta

12.0.0.0b3
----------

* Add notes explaining vmware's suds usage
* Adds instance\_uuid index for instance\_system\_metadata
* Handle nova-compute failure during a soft reboot
* Fix mistake in UT:test\_detach\_unattached\_volume
* Fix RequestSpec.instance\_group hydration
* Remove unused root\_metadata method of BlockDeviceMappingList
* Add JSON-Schema note to api\_plugins.rst
* Compute: update finish\_revert\_resize log to have some context
* Revert "Remove references to suds"
* Fix API directories on the doc
* Fix incomplete error message of quota exceeded
* Add secgroup param checks for Neutron
* Implement manifest-based backports
* Delete orphaned instance files from compute nodes
* Fixed incorrect keys in cpu\_pinning
* api: deprecate the api v2 extension configuration
* Remove the v3 word from help message of api\_rate\_limit option
* Use the same pci\_requests field for all filters and HostManager
* objects: Add MigrationContext object
* Don't query database with an empty list of tags for creation
* Remove duplicate NullHandler test fixture
* Add migration policy to upgrades devref
* Add warning log when deprecated v2 and v3 code get used
* Update ComputeNode values with allocation ratios in the RT
* Update HostManager and filters to use ComputeNode ratios
* Add cpu\_allocation\_ratio and ram\_allocation\_ratio to ComputeNode
* VMware: adds support for rescue image
* filter pre\_assigned\_dev\_names when finding disk dev
* Fix order of arguments in assertEqual
* Fix order of arguments in assertEqual
* Fix order of arguments in assertEqual
* rt: Rewrite abort and update\_usage tests
* Cleanup RT \_instance\_in\_resize\_state()
* Compute: be consistent with logs about NotImplemented methods
* VMware: pass network info to config drive
* Remove/deprecate conductor instance\_update()
* Make compute manager instance updates use objects
* xenapi: add necessary timeout check
* Fix permission issue of server group API
* Make query to quota usage table order preserved
* Change v3 to v21 for devref api\_plugins.rst
* Remove duplicate exception
* Don't trace on InstanceInfoCacheNotFound when refreshing network info\_cache
* Cells: Improve block device mapping update/create calls
* Rm openstack/common/versionutils from setup.cfg
* Add a warning in the microversion docs around the usage of 'latest'
* Fix exception message mistake in WSGI service
* Replace "vol" variable by "bdm"
* Remove v3 references in unit test 'contrib'
* Removed unused dependency: discover
* Rename tests so that they are run
* Adds unit tests to test\_common.py
* db: Add the migration\_context to the instance\_extra table
* tests: Make test\_claims use Instance object
* api: use v2.1 only in api-paste.ini
* VMware: Update to return the correct ESX iqn
* Pass block\_device\_info when delete an encrypted lvm
* Handle neutron exception on bad floating ip create request
* API: remove unused parameter
* Consider that all scheduler calls are IO Ops
* Add RequestSpec methods for primitiving into dicts
* Add a note about the 400 response not requiring a microversion
* api: deprecate the concept of extensions in v2.1
* Fix precedence of image bdms over image mappings
* Cells: remove redundant check if cells are enabled
* Strip the extra properties out when using legacy v2 compatible middleware
* Remove unused sample files from /doc dir
* Expose VIF net-id attribute in os-virtual-interfaces
* libvirt: take account of disks in migration data size
* Add deprecated\_for\_removal parm for deprecated neutron\_ops
* Use compatibility methods from oslo
* compute: Split the rebuild\_instance method
* Allow for migration object to be passed to \_move\_claim
* rt: move filtering of migration by type lower in the call stack
* rt: generalize claim code to be useful for other move actions
* libvirt: make guest to return power state
* libvirt: move domain info to guest
* Xen: import migrated ephemeral disk based on previous size
* cleanup NovaObjectDictCompat from external\_event
* cleanup NovaObjectDictCompat from agent
* Catch invalid id input in service\_delete
* Convert percent metrics back into the [0, 1] range
* Cleanup for merging v2 and v2.1 functional tests
* Remove doc/source/api and doc/build before building docs
* Fixes a typo on nova.tests.unit.api.ec2.test\_api.py
* Add a note about the 403 response not requiring a microversion
* Pre-load expected attrs that the view builder needs for server details
* Remove 'Retry-After' in server create and resize
* Remove debug log message in SG API constructor
* Updated from global requirements
* Refactor test cases for live-migrate error case
* Fixes Bug "destroy\_vm fails with HyperVException"
* libvirt: refactor \_create\_domain\_setup\_lxc to use Image.get\_model
* Set task\_state=None when booting instance failed
* libvirt: Fix snapshot delete for network disk type for blockRebase op
* [Ironic]Not count available resources of deployed ironic node
* Catch OverQuota in volume create function
* Don't allow instance to overcommit against itself
* n-net: add more debug logging to release\_fixed\_ip
* Fix scheduler code to use monitor metric objects
* objects: add missing enum values to DiskBus field
* Move objects registration in tests directory
* xenapi: convert driver to use nova.objects.ImageMeta
* libvirt: convert driver to use nova.objects.ImageMeta
* Updated from global requirements
* VMware: Delete vmdk UUID during volume detach
* Move common sample files methods in test base class
* Share server POST sample file for microversion too
* Fix remote\_consoles microversion 2.8 not to run on /v3
* Remove merged sample tests and file for v2 tests
* Move "versions" functional tests in v2.1 tests
* Nil out inst.host and inst.node when build fails
* Fix link's href to consider osapi\_compute\_link\_prefix
* Fix abnormal quota usage after restore by admin
* Specify current directory using new cwd param in processutils.execute
* Remove and deprecate unused conductor method vol\_usage\_update()
* Replace conductor proxying calls with the new VolumeUsage object
* Add a VolumeUsage object
* Updated from global requirements
* Move CPU and RAM allocation ratios to ResourceTracker
* Pull the all\_tenants search\_opts checking code into a common utility
* Gate on nova.conf.sample generation
* libvirt: use proper disk\_info in \_hard\_reboot
* Update obj\_reset\_changes signatures to match
* libvirt: only get bdm in \_create\_domain\_setup\_lxc if booted from volume
* libvirt: \_create\_domain\_setup\_lxc needs to default disk mapping as a dict
* libvirt: add docstring for \_get\_instance\_disk\_info
* Add rootwrap daemon mode support
* Removed duplicated keys in dictionary
* Xenapi: Correct misaligned partitioning
* libvirt:Remove duplicated check code for config option sysinfo\_serial
* Test cases for better handling of SSH key comments
* Allow compute monitors in different namespaces
* cleanup NovaObjectDictCompat from hv\_spec
* cleanup NovaObjectDictCompat from quota
* Correct a wrong docstring
* Create RequestSpec object
* Clarify API microversion docs around handling 500 errors
* libvirt: Fix KeyError during LXC instance boot
* Xenapi: Handle missing aggregate metadata on startup
* Handle NotFound exceptions while processing network-changed events
* Added processing /compute URL
* libvirt: enable live migration with serial console
* Remove the useless require\_admin\_context decorator
* Correct expected error code for os-resetState action
* libvirt: add helper methods for getting guest devices/disks
* compute: improve exceptions related to disk size checks
* Improve error logs for start/stop of locked instance
* pci: Remove nova.pci.device module
* pci: Remove objects.InstancePCIRequests.save()
* Remove unused db.security\_group\_rule\_get\_by\_security\_group\_grantee()
* Revert "Make nova-network use conductor for security groups refresh"
* Make compute\_api.trigger\_members\_refresh() issue a single db call
* Fix cells use of legacy bdms during local instance delete operations
* Hyper-V: Fixes serial port issue on Windows Threshold
* Consolidate initialization of instance snapshot metadata
* Fix collection of metadata for a snapshot of a volume-backed instance
* Remove unnecessary ValueError exception
* Update log's level when backup a volume backend instance
* The API unit tests for serial console use http instead of ws
* Drop scheduler RPC 3.x support
* Move quota delta reserve methods from api to utils
* nova.utils.\_get\_root\_helper() should be public
* Host manager: add in missing log hints
* Removing extension "OS-EXT-VIF-NET" from v2.1 extension-list
* nova-manage: fix typo in docstring about mangaging
* hyper-v: mock time.sleep in test\_rmtree
* Remove tie between system\_metadata and extra.flavor
* Fixes Hyper-V boot from volume fails when using ephemeral disk
* Re-write way of compare APIVersionRequest's
* Store "null api version" as 0.0
* add docstring to virt driver interface (as-is) [1 of ?]
* Remove last of the plugins/v3 from unit tests
* Rename classes containing 'v3' to 'v21'
* Move the v2 api\_sample functional tests
* Updated from global requirements
* Add logging when filtering returns nothing
* libvirt: cleanup() serial\_consoles after instance failure
* Don't query database with an empty list of tags for IN clause
* Libvirt: Make live\_migration\_bandwidth help msg more meaning
* Move V2.1 API unittest to top level directory
* Neutron: Check port binding status
* Move legacy v2 api smaple tests
* conductor: update comments for rpc and use object
* Load flavor when getting instances for simple-tenant-usage
* Make pagination tolerate a deleted marker
* Updated from global requirements
* Cleanup HTTPRequest for security\_groups test
* Add api samples impact to microversion devref
* Use min and max on IntOpt option types
* Add hacking check for eventlet.spawn()
* Updated from global requirements
* neutron: filter None port\_ids from ports list in \_unbind\_ports
* VMware: treat deletion exception with attached volumes
* VMware: ensure that get\_info raises the correct exception
* Allow resize root\_gb to 0 for volume-backed instances
* Limit parallel live migrations in progress
* Validate quota class\_name
* Move V2 API unittests under legacy\_v2 directory
* Updated from global requirements
* Replace get\_cinder\_client\_version in cinder.py
* Avoid querying for Service in resource tracker
* Remove/deprecate unused parts of the compute node object
* Make ComputeNode.service\_id nullable to match db schema
* Add missing rules in policy.json
* Add V2.1 API tests parity with V2 API tests
* Fixed indentation
* Simplify interface for creating snapshot of volume-backed instance
* Add instance action events for live migration
* Remove 'v3' directory for v2.1 json-schemas
* Move v2.1 code to the main compute directory - remove v3 step3
* libvirt: qemu-img convert should be skipped when migrating
* Add version counter to Service object
* Fix the peer review link in the 'Patches and Reviews' policy section
* Handle port delete initiated by neutron
* Don't check flavor disk size when booting from volume
* libvirt: make instance compulsory in blockinfo APIs
* xapi: ensure pv driver info is present prior to live-migration
* Move existing V2 to legacy\_v2 - step 2
* Move existing V2 to legacy\_v2
* Return v2 version info with v2 legacy compatible wrapper
* Ironic: Add numa\_topology to get\_available\_resource return values
* Fix three typos on nova/pci directory
* Imported Translations from Transifex
* pci: Use PciDeviceList for PciDevTracker.pci\_devs
* pci: Remove get\_pci\_devices\_filter() method
* pci: Move whitelist filtering inside PCI tracker
* libvirt: call host.get\_capabilities after checking for bad numa versions
* libvirt: log when BAD\_LIBVIRT\_NUMA\_VERSIONS detected
* Use string substitution before raising exception
* Hyper-V: deprecates support for Windows / Hyper-V Server 2008 R2
* VMware: Do not untar OVA on the file system
* Add hacking check for greenthread.spawn()
* Ironic: Use ironicclient native retries for Conflict in ClientWrapper
* Prevent (un)pinning unknown CPUs
* libvirt: use instance UUID with exception InstanceNotFound
* Fix notify\_decorator errors
* VMware: update supported vsphere 6.0 os types
* libvirt: convert Scality vol driver to LibvirtBaseFileSystemVolumeDriver
* libvirt: convert Quobyte driver to LibvirtBaseFileSystemVolumeDriver
* pci: Use fields.Enum type for PCI device type
* pci: Use fields.Enum type for PCI device status
* More specific error messages on building BDM
* Ensure test\_models\_sync() works with new Alembic releases
* Hyper-V: Adds VolumeOps unit tests
* Hyper-V: Adds MigrationOps unit tests
* Suppress not image properties for image metadata from volume
* Add non-negative integer and float fields
* Fix DeprecationWarning when using BaseException.message
* Added support for specifying units to hw:mem\_page\_size
* Compute: use instance object for refresh\_instance\_security\_rules
* libvirt: convert GPFS volume driver to LibvirtBaseFileSystemVolumeDriver
* Updated from global requirements
* Add os-brick based LibvirtVolumeDriver for ScaleIO
* docs: add link to liberty summit session on v2.1 API
* Refactor unit test for InstanceGroup objects
* Don't pass the service catalog when making glance requests
* libvirt: check min required qemu/libvirt versions on s390/s390x
* libvirt: ensure LibvirtConfigGuestDisk parses readonly/shareable flags
* libvirt: set caps on maximum live migration time
* libvirt: support management of downtime during migration
* cleanup NovaObjectDictCompat from numa object
* Fix test\_relationships() for subobject versions
* libvirt: don't open connection in driver constructor
* Skip SO\_REUSEADDR tests on BSD
* \_\_getitem\_\_ method not returning value
* Compute: replace incorrect instance object with dict
* Fix live-migrations usage of the wrong connector information
* Honour nullability constraints of Glance schema in ImageMeta
* Change docstring in test to comment
* libvirt: convert GlusterFS driver to LibvirtBaseFileSystemVolumeDriver
* libvirt: convert SMBFS vol driver to LibvirtBaseFileSystemVolumeDriver
* libvirt: convert NFS volume driver to LibvirtBaseFileSystemVolumeDriver
* Introduce LibvirtBaseFileSystemVolumeDriver
* Add test to check relations at or below current
* Add documentation for the nova-cells command
* libvirt:Rsync remote FS driver was added
* Clean the deprecated noauth middleware
* Add os\_brick-based VolumeDriver for HGST connector
* libvirt: add os\_admin\_user to use with set admin password
* Fixed incorrect behaviour of method \_check\_instance\_exists
* Squashing down update method
* Fix the wrong file name for legacy v2 compatible wrapper functional test
* Add scenario for API sample tests with legacy v2 compatible wrapper
* Skip additionalProperties checks when LegacyV2CompatibleWrapper enabled
* Libvirt: correct libvirt reference url link when live-migration failed
* libvirt: enable virtio-net multiqueue
* Replacing unichr() with six.unichr() and reduce with six.moves.reduce()
* Fix resource leaking when consume\_from\_instance raise exception
* :Add documentation for the nova-idmapshift command
* RBD: Reading rbd\_default\_features from ceph.conf
* New nova API call to mark nova-compute down
* libvirt: move LibvirtISCSIVolumeDriver into it's own module
* libvirt: move LibvirtNETVolumeDriver into it's own module
* libvirt: move LibvirtISERVolumeDriver into it's own module
* libvirt: move LibvirtNFSVolumeDriver into it's own module
* allow live migration in case of a booted from volume instance
* Handle MessageTimeout to MigrationPreCheckError
* Create a new dictionary for type\_data in VMwareAPIVMTestCase class
* resource tracker style pci resource management
* Added missed '-' to the rest\_api\_version\_history.rst
* Imported Translations from Transifex
* Remove db layer hard-code permission checks for keypair
* Fix a couple dead links in docs
* cleanup NovaObjectDictCompat from virt\_cpu\_topology
* Adding user\_id handling to keypair index, show and create api calls
* Updated from global requirements
* Remove legacy flavor compatibility code from Instance
* libvirt: Fix root device name for volume-backed instances
* Fix few typos in nova code and docs
* Helper script for running under Apache2
* Raise NovaException for missing/empty machine-id
* Fixed random failing of test\_describe\_instances\_with\_filters\_tags
* libvirt: enhance libvirt to set admin password
* libvirt: rework quiesce to not share "sensitive" informations
* Metadata: support proxying loadbalancers
* formely is not correct
* Remove 'scheduled\_at' - DB cleanup
* Remove unnecessary executable permission
* Neutron: add in API method for updating VNIC index
* Xen: convert image auto\_disk\_config value to bool before compare
* Make BaseProxyTestCase.test\_proxy deterministic wrt traffic/verbose
* Cells: Handle instance\_destroy\_at\_top failure
* cleanup NovaObjectDictCompat from virtual\_interface
* Fix test mock that abuses objects
* VMware: map one nova-compute to one VC cluster
* VMware: add serial port device
* Handle SSL termination proxies for version list
* Use urlencode instead of dict\_to\_query\_str function
* libvirt: move LibvirtSMBFSVolumeDriver into it's own module
* libvirt: move LibvirtAOEVolumeDriver into it's own module
* libvirt: move LibvirtGlusterfsVolumeDriver into it's own module
* libvirt: move LibvirtFibreChannelVolumeDriver into it's own module
* VMware: set create\_virtual\_disk\_spec method as local
* Retry live migration on pre-check failure
* Handle config drives being stored on rbd
* Change List objects to use obj\_relationships
* Fixes delayed instance lifecycle events issue
* libvirt-vif: Allow to configure a script on bridge interface
* Include DiskFilter in the default list
* Adding support for InfiniBand SR-IOV vif type
* VMware: Add support for swap disk
* libvirt: Add logging for dm-crypt error conditions
* Service group drivers forced\_down flag utilization
* libvirt: Replace stubs with mocks for test\_dmcrypt
* clarify docs on 2.9 API change
* Remove db layer hard-code permission checks for instance\_get\_all\_hung\_in\_rebooting
* Undo tox -e docs pip install sphinx workaround
* Set autodoc\_index\_modules=True so tox -e docs builds module docs again
* Allow NUMA based reporting for Monitors
* libvirt: don't add filesystem disk to parallels containers unconditionally
* objects: add hw\_vif\_multiqueue\_enabled image property
* Prepare for unicode enums from Oslo
* rootwrap: remove obsolete filters for baremetal
* Create class hierarchy for tasks in conductor
* return more details on assertJsonEqual fail
* Fix IronicHostManager to skip get\_by\_host() call
* Store correct VirtCPUTopology
* Add documentation for block device mapping
* Show 'locked' information in server details
* VMware: add resource limits for disk
* VMware: store extra\_specs object
* VMware: Resource limits for memory
* VMware: create common object for limits, reservations and shares
* VMware: add support for cores per socket
* Add DiskNotFound and VolumeNotFound test
* Not check rotation at compute level
* Instance destroyed if ironic node in CLEANWAIT
* Ironic: Better handle InstanceNotFound on destroy()
* Fix overloading of block device on boot by device name
* tweak graphviz formatting for readability
* libvirt: rename parallels driver to virtuozzo
* libvirt: Add macvtap as virtual interface (vif) type to Nova's libvirt driver
* cells: document upgrade limitations/assumptions
* rebuild: make sure server is shut down before volumes are detached
* Implement compare-and-swap for instance update
* docs: add a placeholder link to mentoring docs
* libvirt: Kill rsync/scp processes before deleting instance
* Updated from global requirements
* Add console allowed origins setting
* libvirt: move the LibvirtScalityVolumeDriver into it's own module
* libvirt: move the LibvirtGPFSVolumeDriver into it's own module
* libvirt: move the LibvirtQuobyteVolumeDriver into the quobyte module
* libvirt: move volume/remotefs/quobyte modules under volume subdir
* Add missing policy for limits extension
* Move to using ovo's remotable decorators
* Base NovaObject on VersionedObject
* Document when we should have a microversion
* libvirt: do relative block rebase only with non-null base
* Add DictOfListOfStrings type of field
* Get py34 subunit.run test discovery to work
* Enable python34 tests for nova/tests/unit/scheduler/test\*.py
* libvirt: mark NUMA huge page mappings as shared access
* libvirt:Add a driver API to inject an NMI
* virt: convert hardware module to use nova.objects.ImageMeta

12.0.0.0b2
----------

* Replace openssl calls with cryptography lib
* libvirt: move lvm/dmcrypt/rbd\_utils modules under storage subdir
* Fix Instance object usage in test\_extended\_ips tests
* Fix test\_extended\_server\_attributes for proper Instance object usage
* Fix test\_security\_groups to use Instance object properly
* Refactor test\_servers to use instance objects
* Switch to using os-brick
* Updated from global requirements
* VMware: remove redundant check for block devices
* Remove unused decorator on attach/detach volume
* libvirt: test capability for supports\_migrate\_to\_same\_host
* Added removing of tags from instance after its deletion
* Remove unused import of the my\_ip option from the manager
* Scheduler: enhance debug messages for multitenancy aggregates
* VMware: Handle missing vmdk during volume detach
* Running microversion v2.6 sample tests under '/v2' endpoint
* VMware: implement get\_mks\_console()
* Add MKS protocol for remote consoles
* Add MKS console support
* libvirt: improve logging in the driver.py code
* Fix serializer supported version reporting in object\_backport
* Updated from global requirements
* Revert "Add error message to failed block device transform"
* tox: make it possible to run pep8 on current patch only
* Fix seven typos on nova documentation
* Add two fields to ImageMetaProps object
* Check flavor type before add tenant access
* Switch to the oslo\_utils.fileutils
* hypervisor support matrix: fix snapshot for libvirt Xen
* libvirt: implement get\_device\_name\_for\_instance
* libvirt: Always default device names at boot
* Remove unused import of the compute\_topic option from the DB API
* Remove unused call to \_get\_networks\_by\_uuids()
* libvirt: fix disk I/O QOS support with RBD
* Updated from global requirements
* Remove unnecessary oslo namespace import checks
* VMware: Fixed redeclared CONF = cfg.CONF
* Execute \_poll\_shelved\_instances only if shelved\_offload\_time is > 0
* Switch to oslo.reports
* Support Network objects in set\_network\_host
* Fix Filter Schedulers doc to refer to all\_filters
* Fixup uses of mock in hyperv tests
* Cleanup log lines in nova.image.glance
* Revert "Add config drive support for Virtuozzo containers"
* Virt: fix debug log messages
* Virt: use flavor object and not flavor dict
* Add VersionPredicate type of field
* Remove unnecessary method in FilterScheduler
* Use utf8\_bin collation on the flavor extra-specs table in MySQL
* docs: clear between current vs future plans
* cleanup NovaObjectDictCompat subclassing from pci\_device
* libvirt: make unit tests concise by setup guest object
* libvirt: introduce method to wait for block device job
* Decouple instance object tests from the api fakes module
* Fixed typos in self parameter
* Hyper-V: restart serial console workers after instance power change
* Only work with ipv4 subnet metadata if one exists
* Do not import using oslo namespace
* Refresh instance info cache within lock
* Remove db layer hard-code permission checks for fixed\_ip\_associate\_\*
* Add middleware filterout Microversions http headers
* Correct backup\_type param description
* Fix a request body template for secgroup tests
* Images: fix invalid exception message
* Updated from global requirements
* rebuild: fix rebuild of server with volume attached
* objects: send PciDeviceList 1.2 to all code that can handle it
* Fix libguestfs failure in test\_can\_resize\_need\_fs\_type\_specified
* Fix the incorrect PciDeviceList version number
* objects: Don't import CellMapping from the objects module
* Deprecate the osapi\_v3.enabled option
* Remove conductor api from resource tracker
* Fix test\_tracker object mocks
* Fix Python 3 issues in nova.utils and nova.tests
* Remove db layer hard-code permission checks for instance\_get\_all\_by\_host\_and\_not\_type
* Support all\_tenants search\_opts for neutron
* libvirt : remove broken olso\_config choices option
* Convert instance\_type to object in prep\_resize
* VMware: clean up exceptions
* Revert "Remove useless db call instance\_get\_all\_hung\_in\_rebooting"
* VMware: Use virtual disk size instead of image size
* Remove db layer hard-code permission checks for provider\_fw\_rule\_\*
* Remove db layer hard-code permission checks for archive\_deleted\_rows\*
* Revert "Implement compare-and-swap for instance update"
* Add tool to build a doc latex pdf
* make test\_save\_updates\_numa\_topology stable across python versions
* Update HACKING.rst for running tests and building docs
* Cleanup quota\_class unittest with appropriate request context
* Remove db layer hard-code permission checks for quota\_class\_create/update
* Remove db layer hard-code permission checks for quota\_class\_get\_all\_by\_name
* Improve functional test base for microversion
* Remove db layer hard-code permission checks for reservation\_expire
* Introducing new forced\_down field for a Service object
* Use stevedore for loading monitor extensions
* libvirt: Remove dead code path in method clear\_volume
* Switch to oslo.service library
* Include project\_id in instance metadata
* Convert test\_compute\_utils to use Instance object
* Fix for mock-1.1.0
* Port crypto to Python 3
* Add HostMapping object
* Remove useless db call instance\_get\_all\_hung\_in\_rebooting
* Cleanup unused method fake\_set\_snapshot\_id
* Handle KeyError when volume encryption is not supported
* Expose Neutron network data in metadata service
* Build Neutron network data for metadata service
* Implement compare-and-swap for instance update
* Added method exists to the Tag object
* Add DB2 support
* compute: rename ResizeClaim to MoveClaim
* Fix the little spelling mistake of the comment
* Remove db layer hard-code permission checks for quota\_create/update
* Fix the typo from \_pre\_upgrade\_294 to \_pre\_upgrade\_295 for tests/unit/db/test\_migration
* Ironic:check the configuration item api\_max\_retries
* Modified testscenario for micro version 2.4
* Add some notifications to the evacuate path
* Make evacuate leave a record for the source compute host to process
* Fix incorrect enum in Migration object and DB model
* Refactoring of the os-services module
* libvirt: update docstring in blockinfo module for disk\_info
* Ignore bridge already exists error when creating bridge
* libvirt: handle rescue flag first in blockinfo.get\_disk\_mapping
* libvirt: update volume delete snapshot to use Guest
* libvirt: update live snapshot to use Guest object
* libvirt: update swap volume to use Guest
* libvirt: introduce GuestBlock to wrap around Block API
* libvirt: rename GuestVCPUInfo to VCPUInfo
* libvirt: save the memory state of guest
* removed unused method \_get\_default\_deleted\_value
* Remove flavor migration from db\_api and nova-manage
* Rework monitor plugin interface and API
* Adds MonitorMetric object
* virt: add get\_device\_name\_for\_instance to the base driver class
* libvirt: return whether a domain is persistent
* Cells: fix indentation for configuration variable declaration
* VMware: add unit tests for vmops attach and detach interface
* Remove unneeded OS\_TEST\_DBAPI\_ADMIN\_CONNECTION
* Switch from MySQL-python to PyMySQL
* virt: fix picking CPU topologies based on desired NUMA topology
* Port test\_exception to Python 3
* devref: virtual machine states and transitions
* Consolidate the APIs for getting consoles
* Remove db layer hard-code permission checks for floating\_ip\_dns
* Fix typo in model doc string
* virt: Fix AttributeError for raw image format
* log meaningful error message on download exception
* Updated from global requirements
* Add bandit for security static analysis testing
* Handle unexpected clear events call
* Make on\_shared\_storage optional in compute manager
* snapshot: Add device\_name to the snapshot bdms
* compute: Make swap\_volume with resize updates BDM size
* Make Nova better at keeping track of volume sizes in BDM
* API: make sure a blank volume with no size is rejected
* Ironic: Improve driver logs
* Drop MANIFEST.in - it's not needed with PBR
* Libvirt: Define system\_family for libvirt guests
* Convert RT compute\_node to be a ComputeNode object
* glance:check the num\_retries option
* tests: Move test\_resource\_tracker to Instance objects
* Remove compat\_instance()
* Enable python34 tests for nova/tests/unit/objects/test\*.py
* Soft delete system\_metadata when destroy instance
* Remove python3 specific test-requirements file
* Try luksFormat up to 3 times in case the device is in use
* rootwrap: update ln --symbolic filter for FS and FC type volume drivers
* Add wording to error message in TestObjectVersions.test\_relationships
* Close temporary files in virt/disk/test\_api.py
* Add BlockDeviceType enum field
* Add BlockDeviceDestinationType enum field
* Add BlockDeviceSourceType enum field
* Avoid recursion in object relationships test
* tests: move a test to the proper class in test\_resource\_tracker
* Remove db layer hard-code permission checks for network\_set\_host
* Block subtractive operations in migrations for Kilo and beyond
* Remove db layer hard-code permission checks for network\_disassociate
* libvirt: Correct domxml node name
* Test relationships of List objects
* libvirt: configuration for interface driver options
* Fix Python 3 issues in nova.db.sqlalchemy
* Update test\_db\_api for oslo.db 2.0
* Fix is\_image\_extendable() thinko
* Validate maximum limit for quota
* utils: ignore block device mapping in system metadata
* libvirt: add in missing doc string for hypervisor\_version
* Remove useless policy rule from fake\_policy.py
* Replace ascii art architecture diagram with svg image
* Adds MonitorMetricTypeField enum field
* Unfudge tox -e genconfig wrt missing versionutils module
* virt: update doctrings
* hypervisor support matrix: add feature "evacuate"
* XenAPI: Refactor rotate\_xen\_guest\_logs to avoid races
* hypervisor support matrix: add feature "serial console"
* hypervisor support matrix: add CLI commands to features
* Fix typos detected by toolkit misspellings
* hypervisor support matrix: fix "evacuate" for s390 and hyper-v
* Make live migration create a migration object record
* Cells: add instance cell registration utility to nova-manage
* fix typos in docs
* Logging corrected
* Check mac for instance before disassociate in release\_fixed\_ip
* Add the rule of separate plugin for Nova REST API in devref
* Use flavor object in compute manager

12.0.0.0b1
----------

* Changes conf.py for Sphinx build because oslosphinx now contains GA
* Fix testing object fields with missing instance rows
* Change group controller of V2 test cases
* Reduce window for allocate\_fixed\_ip / release\_fixed\_ip race in nova-net
* Make NoValidHost exceptions clearer
* Hyper-V: Fixes method retrieving free SCSI controller slot on V1
* Refactor network API 'get\_instance\_nw\_info'
* Removed extra '-' from rest\_api\_version\_history.rst
* Remove an useless variable and fix a typo in api
* VMware: convert driver to use nova.objects.ImageMeta
* Bypass ironic server not available issue
* Fix test\_create\_security\_group\_with\_no\_name
* Remove unused "id" and "rules" from secgroup body
* cells: add devstack/tempest-dsvm-cells-rc for gating
* Add common function for v2.1 API flavor\_get
* Fix comment typo
* Fix up instance flavor usage in compute and network tests
* Fix up ec2 tests for flavors on instances
* Fix up xenapi tests for instance flavors
* Fix up some bits of resource\_tracker to use instance flavors
* Register the vnc config options under group 'vnc'
* Cells: cell scheduler anti-affinity filter
* Cells: add in missing unit test for get\_by\_uuid
* VMware driver: Increasing speed of downloading image
* Hyper-V: Fix virtual hard disk detach
* Add flag to force experimental run of db contract
* Make readonly field tests use exception from oslo.versionedobjects
* Fixes "Hyper-V destroy vm fails on Windows Server 2008R2"
* Add microversion to allow server search option ip6 for non-admin
* Updated from global requirements
* VMware: Handle port group not found case
* Imported Translations from Transifex
* libvirt: use correct translation format
* Add explicit alembic dependency
* network: add more debug logging context for race bug 1249065
* Add virt resource update to ComputeNode object
* xenapi: remove bittorrent entry point lookup code
* Use oslo-config-generator instead of generate\_sample.sh
* Add unit tests for PCI utils
* Support flavor object in migrate\_disk\_and\_power\_off
* Remove usage of WritableLogger from oslo\_log
* libvirt: Don't fetch kernel/ramdisk files if you already have them
* Allow non-admin to list all tenants based on policy
* Remove redundant policy check from security\_group\_default\_rule
* Return bandwidth usage after updating
* Update version for Liberty
* neutron: remove deprecated allow\_duplicate\_networks config option
* Validate maximum limit for integer
* Improve the ability to resolve capabilities from Ironic
* Fix the wrong address ref when the fixed\_ip is invalid
* The devref for Nova stable API
* Fix wrong check when use image in local
* Fixes TypeError when libvirt version is BAD\_LIBVIRT\_CPU\_POLICY\_VERSIONS

12.0.0a0
--------

* Remove hv\_type translation shim for powervm
* cells: remove deprecated mute\_weight\_value option
* Make resize api of compute manager to send flavor object
* VMware: detach cinder volume when instance destroyed
* Add unit tests for the exact filters
* test: add MatchType helper class as equivalent of mox.IsA
* Validate int using utils.validate\_integer method
* VMware: use min supported VC version in fake driver
* Updated from global requirements
* Added documentation around database upgrades
* Avoid always saving flavor info in instance
* Warn when CONF torrent\_base\_url is missing slash
* Raise invalid input if use invalid ip for network to attach interface
* Hyper-V: Removes old instance dirs after live migration
* DB downgrades are no longer supported
* Add Host Mapping table to API Database
* VMware: verify vCenter server certificate
* Implement online schema migrations
* Hyper-V: Fixes live migration configdrive copy operation
* Avoid resizing disk if the disk size doesn't change
* Remove openstack/common/versionutils module
* Fix TestObjEqualPrims test object registration
* Remove references to suds
* VMware: Remove configuration check
* Remove and deprecate conductor task\_log methods
* Remove unused compute utils methods
* Make instance usage audit use the brand new TaskLog object
* Add a TaskLog object
* Updated from global requirements
* Fix noVNC console access for an IPv6 setup
* hypervisor support matrix: add status "unknown"
* VMware: typo fix in config option help
* Sync with latest oslo-incubator
* Associating of floating IPs corrected
* Minor refactor in nova.scheduler.filters.utils
* Cleanup wording for the disable\_libvirt\_livesnapshot workaround option
* Remove cell api overrides for force-delete
* libvirt: convert imagebackend to support nova.virt.image.model classes
* virt: convert disk API over to use nova.virt.image.model
* Cells: Skip initial sync of block\_device\_mapping
* Pass Down the Instance Name to Ironic Driver
* Handle InstanceNotFound when sending instance update notification
* Add an index to virtual\_interfaces.uuid
* Updated from global requirements
* Add config drive support for Virtuozzo containers
* Update formatting of microversion 2.4 documentation
* Consolidates scheduler utils tests into a single file
* Send Instance object to cells instance\_update\_at\_top
* VMware: use vCenter instead of VC
* fix "down" nova-compute service spuriously marked as "up"
* Improve formatting of rest\_api\_version\_history
* Link to microversion history in docs
* libvirt: fix live migration handling of disk\_info
* libvirt: introduce method to get domain XML
* libvirt: introduce method detach\_device to Guest object
* Remove db layer hard-code permission checks for quota\_usage\_update
* pass environment variables of proxy to tox
* Remove db layer hard-code permission checks for quota\_get\_all\_\*
* Fixed some misspellings
* Clean up Fake\_Url for unit test of flavor\_access
* Updated from global requirements
* Add AggregateTypeAffinityFilter multi values support
* volume: log which encryptor class is being used
* VMware: Don't raise exception on resize of 0 disk
* Hyper-V: sets supports\_migrate\_to\_same\_host capability
* libvirt: remove \_get\_disk\_xml to use get\_disk from Guest
* libvirt: introduce method to attach device
* libvirt: update tests to use Mock instead of MagicMock
* libvirt: Remove unnecessary JSON conversions
* objects: fix parsing of NUMA cpu/mem properties
* compute: remove get\_image\_metadata method
* compute: only use non\_inheritable\_image\_properties if snapshotting
* objects: add os\_require\_quiesce image property
* libvirt: make default\_device\_names DRY-er
* virt: Move building the block\_device\_info dict into a method
* Objects: update missing adapter types
* Add error handling for creating secgroup
* libvirt: handle code=38 + sigkill (ebusy) in destroy()
* Removed a non-conditional 'if' statement
* Map uuid db field to instance\_uuid in BandwidthUsage object
* Hyper-V: Fix missing WMI namespace issue on Windows 2008 R2
* Replace metaclass registry with explicit opt-in registry from oslo
* Fix an objects layering violation in compute/api
* Remove assertRemotes() from objects tests
* Use fields from oslo.versionedobjects
* Convert test objects to new field formats
* Begin the transition to an explicit object registry
* Set default event status to completed
* Add a hacking rule for consistent HTTP501 message
* Add and use raise\_feature\_not\_supported()
* Objects: fix typo with exception
* Remove useless volume when boot from volume failed
